
 Xa99 Cross Assembler
EA UTILITIES IN LOW MEMORY                                   PAGE 0001
  0001            * Standard defines and routines for the TI99/4A Home Compute
  0002            * to use with the Editor/Assembler module.
  0003            *
  0005            
  0006            	IDT	'ASMUP'
  0007            
  0008            *
  0009            * To be assembled with XA99 which 
  0010            * Can be loaded in LOMEM with the
  0011            * .O >2000 option with L99
  0012            *
  0013            * Give the NAME# a value > 0 if you need them:
  0014            *===========================================================
  0015      0000  GPRDT#	EQU	0	* 1: Generate predefined REF/DEF table
  0016      0001  SCAN#	EQU	1	* 1: Need the SCAN symbol
  0017      0001  XMLLK#	EQU	1	* 1: Need the XMLLNK function
  0018      0001  KSCAN#	EQU	1	* 1: Need the KSCAN  function
  0019      0001  VSBW#	EQU	1	* 1: Need the VSBW   function
  0020      0001  VMBW#	EQU	1	* 1: Need the VMBW   function
  0021      0001  VSBR#	EQU	1	* 1: Need the VSBR   function
  0022      0001  VMBR#	EQU	1	* 1: Need the VMBR   function
  0023      0001  VWTR#	EQU	1	* 1: Need the VWTR   function
  0024      0001  DSRLK#	EQU	1	* 1: Need the DSRLNK function
  0025      0001  LOADR#	EQU	1	* 1: Need the LOADER function
  0026      0001  GPLLK#	EQU	1	* 1: Need the GPLLK  function
  0027      0001  NAMLK#	EQU	1	* 1: Need the NAMLNK function
  0028      0001  CIF#	EQU	1	* 1: Need the CIF    function
  0029            *===========================================================
  0030            *
  0031      0004  VDPH#	EQU	VSBW#+VMBW#+VSBR#+VMBR#
  0032            
  0033            	DEF	UTLTAB,PAD,GPLWS,SOUND
  0034            	DEF	VDPRD,VDPSTA,VDPWD,VDPWA
  0035            	DEF	SPCHRD,SPCHWT
  0036            	DEF	GRMRA,GRMRD,GRMWD,GRMWA
  0037            
  0038 TRUE       #if SCAN#
  0039            	DEF	SCAN
  0040 TRUE       #endif
  0041 TRUE       #if XMLLK#
  0042            	DEF	XMLLNK
  0043 TRUE       #endif
  0044 TRUE       #if KSCAN#
  0045            	DEF	KSCAN
  0046 TRUE       #endif
  0047 TRUE       #if VSBW#
  0048            	DEF	VSBW
  0049 TRUE       #endif
  0050 TRUE       #if VMBW#
  0051            	DEF	VMBW
  0052 TRUE       #endif
  0053 TRUE       #if VSBR#
  0054            	DEF	VSBR
  0055 TRUE       #endif
  0056 TRUE       #if VMBR#
  0057            	DEF	VMBR
  0058 TRUE       #endif
  0059 TRUE       #if VWTR#
  0060            	DEF	VWTR

 Xa99 Cross Assembler
EA UTILITIES IN LOW MEMORY                                   PAGE 0002
  0061 TRUE       #endif
  0062 TRUE       #if DSRLK#
  0063            	DEF	DSRLNK
  0064 TRUE       #endif
  0065 TRUE       #if LOADR#
  0066            	DEF	LOADER
  0067 TRUE       #endif
  0068 TRUE       #if GPLLK#
  0069            	DEF	GPLLNK
  0070 TRUE       #endif
  0071            
  0072            
  0073            * TI99/4A predefined addresses
  0074            *
  0075      8300  PAD	EQU	>8300
  0076      83E0  GPLWS	EQU	>83E0
  0077      8400  SOUND	EQU	>8400
  0078      8800  VDPRD	EQU	>8800
  0079      8802  VDPSTA	EQU	>8802
  0080      8C00  VDPWD	EQU	>8C00
  0081      8C02  VDPWA	EQU	>8C02
  0082      9000  SPCHRD	EQU	>9000
  0083      9400  SPCHWT	EQU	>9400
  0084      9800  GRMRD	EQU	>9800
  0085      9802  GRMRA	EQU	>9802
  0086      9C00  GRMWD	EQU	>9C00
  0087      9C02  GRMWA	EQU	>9C02
  0088      000E  SCAN	EQU	>000E
  0089            
  0090            *Register MSB/LSB offsets
  0091            *
  0092      0000  MR00   EQU  0
  0093      0001  LR00   EQU  1
  0094      0002  MR01   EQU  2
  0095      0003  LR01   EQU  3
  0096      0004  MR02   EQU  4
  0097      0005  LR02   EQU  5
  0098      0006  MR03   EQU  6
  0099      0007  LR03   EQU  7
  0100      0008  MR04   EQU  8
  0101      0009  LR04   EQU  9
  0102      000A  MR05   EQU  10
  0103      000B  LR05   EQU  11
  0104      000C  MR06   EQU  12
  0105      000D  LR06   EQU  13
  0106      000E  MR07   EQU  14
  0107      000F  LR07   EQU  15
  0108      0010  MR08   EQU  16
  0109      0011  LR08   EQU  17
  0110      0012  MR09   EQU  18
  0111      0013  LR09   EQU  19
  0112      0014  MR10   EQU  20
  0113      0015  LR10   EQU  21
  0114      0016  MR11   EQU  22
  0115      0017  LR11   EQU  23
  0116      0018  MR12   EQU  24
  0117      0019  LR12   EQU  25
  0118      001A  MR13   EQU  26
  0119      001B  LR13   EQU  27

 Xa99 Cross Assembler
EA UTILITIES IN LOW MEMORY                                   PAGE 0003
  0120      001C  MR14   EQU  28
  0121      001D  LR14   EQU  29
  0122      001E  MR15   EQU  30
  0123      001F  LR15   EQU  31
  0124            
  0125            
  0126            * START OF LOMEM
  0127            *
  0128            *	AORG	>2000
  0129            
  0130 0000 A55A  	DATA	>A55A
  0131 TRUE       #if NAMLK#
  0132 0002 0128' 	DATA	NAMLNK	2128	Start address name link routine    (XML >2
  0133 FALSE      #else
  0134            	DATA	>0000	2128	Start address name link routine    (XML >21
  0135 TRUE       #endif
  0136 TRUE       #if LOADR#
  0137 0004 0398' 	DATA	BLOADR	2398	Start address loader called by GPL (XML >2
  0138 FALSE      #else
  0139            	DATA	>0000	2398	Start address loader called by GPL (XML >22
  0140 TRUE       #endif
  0141 TRUE       #if CIF#
  0142 0006 025A' 	DATA	CIF	225A	Start address of CIF (int ->flt)   (XML >23)
  0143 FALSE      #else
  0144            	DATA	>0000	225A	Start address of CIF (int ->flt)   (XML >23
  0145 TRUE       #endif
  0146            
  0147 0008       	BSS	26
  0148            *	AORG	>2022
  0149            
  0150      0022' UTLTAB	EQU $
  0151            
  0152 0022 0000  LPADDR	DATA	>0000	2022	Start address of loaded program
  0153 0024 A000  FSTHI	DATA	>A000	2024	First free address in himem
  0154 0026 FFD7  LSTHI	DATA	>FFD7	2026	Last  free address in himem
  0155 0028 0676' FSTLOW	DATA	LOFIFR	2028	First free address in lomem (2676)
  0156 002A 4000  LSTLOW	DATA	LOLAFR	202A	Last  free address in lomem (3F38 st
  0157            
  0158 002C 0000  CHKSAV	DATA	>0000	202C	Checksum
  0159 002E 0000  FLGPTR	DATA	>0000	202E	Pointer to status in PAB (VDP)
  0160 0030 0000  SVGPRT	DATA	>0000	2030	GPL return address
  0161 0032 0000  SAVCRU	DATA	>0000	2032	CRU adres of peripheral
  0162 0034 0000  SAVENT	DATA	>0000	2034	DSR subprogram entry address
  0163 0036 0000  SAVLEN	DATA	>0000	2036	DSR device or sub program name length
  0164 0038 0000  SAVPAB	DATA	>0000	2038	DSR device name addres in PAB in VDP
  0165 003A 0000  SAVVER	DATA	>0000	203A	DSR version number
  0166 003C       LOADRB	BSS	80	203C	LOADER record buffer
  0167 008C       DSRLNB	BSS	8	208C	DSRLNK name buffer
  0168 0094       UTILWS	BSS	6	2094	Utility workspace (overlaps DSRLWS)
  0169 009A       DSRLWS	BSS	32	209A	DSRLNK workspace
  0170 00BA       USERWS	BSS	32	20BA	User workspace
  0171 00DA       LOADWS	BSS	32	20DA	LOADER workspace
  0172 00FA 0064  DC100	DATA	100	20FA	Decimal constant 100
  0173 00FC   20  BC20	BYTE	>20	20FC	Byte constant >20
  0174 00FD   00  BC00	BYTE	>00	20FD	Byte constant >00
  0175 00FE   2E  BC2E	TEXT	'.'	20FE	Byte constant decimal point (ASCII code)
  0176 00FF   AA  BCAA	BYTE	>AA	20FF	Byte constant AA for check DSR ROM availa
  0177            
  0178            * Function Vectors

 Xa99 Cross Assembler
EA UTILITIES IN LOW MEMORY                                   PAGE 0004
  0179            *
  0180 TRUE       #if GPLLK#
  0181 0100 0094' GPLLNK	DATA	UTILWS,GPLLK$	2100 2094 21C4
       0102 01C4'
  0182 TRUE       #endif
  0183 TRUE       #if XMLLK#
  0184 0104 0094' XMLLNK	DATA	UTILWS,XMLLK$   2104 2094 2196
       0106 0196'
  0185 TRUE       #endif
  0186 TRUE       #if KSCAN#
  0187 0108 0094' KSCAN	DATA	UTILWS,KSCAN$   2108 2094 21DE
       010A 01DE'
  0188 TRUE       #endif
  0189 TRUE       #if VSBW#
  0190 010C 0094' VSBW	DATA	UTILWS,VSBW$    210C 2094 21F4
       010E 01F4'
  0191 TRUE       #endif
  0192 TRUE       #if VMBW#
  0193 0110 0094' VMBW	DATA	UTILWS,VMBW$    2110 2094 2200
       0112 0200'
  0194 TRUE       #endif
  0195 TRUE       #if VSBR#
  0196 0114 0094' VSBR	DATA	UTILWS,VSBR$    2114 2094 220E
       0116 020E'
  0197 TRUE       #endif
  0198 TRUE       #if VMBR#
  0199 0118 0094' VMBR	DATA	UTILWS,VMBR$    2118 2094 221A
       011A 021A'
  0200 TRUE       #endif
  0201 TRUE       #if VWTR#
  0202 011C 0094' VWTR	DATA	UTILWS,VWTR$    211C 2094 2228
       011E 0228'
  0203 TRUE       #endif
  0204 TRUE       #if DSRLK#
  0205 0120 009A' DSRLNK	DATA	DSRLWS,DSRLK$   2120 209A 22B2
       0122 02B2'
  0206 TRUE       #endif
  0207 TRUE       #if LOADR#
  0208 0124 00DA' LOADER	DATA	LOADWS,LOADR$   2124 20DA 23BA
       0126 03BA'
  0209 TRUE       #endif
  0210            
  0211            * Functions
  0212            
  0213            * NAMLNK (XML >21)	2128
  0214 TRUE       #if NAMLK#
  0215 0128 C80B  NAMLNK	MOV	R11,@SVGPRT		Save GPL environment
       012A 0030'
  0216 012C D060  	MOVB	@>8349,R1		Get ...
       012E 8349 
  0217 0130 2060  	COC 	@BC20,R1		... bit set?
       0132 00FC'
  0218 0134 132A  	JEQ 	L218A			Yes!
  0219 0136 C020  	MOV 	@>8350,R0		Get ...
       0138 8350 
  0220 013A 1311  	JEQ 	L215E			Not ...!
  0221 013C 06A0  	BL 	@L2646			Check for unresolved references
       013E 0646'
  0222 0140 101E  	JMP	L217E			There are unresolved references: Quit

 Xa99 Cross Assembler
EA UTILITIES IN LOW MEMORY                                   PAGE 0005
  0223            
  0224 0142 0281  L2142	CI	R1,>3F38		Start of default REF/DEF table?
       0144 3F38 
  0225 0146 1319  	JEQ	L217A			Yes, not found!
  0226 0148 C001  	MOV	R1,R0
  0227 014A 0202  	LI	R2,>834A		Function name to find
       014C 834A 
  0228 014E 8CB0  	C	*R0+,*R2+		Char 1 and 2 equal?
  0229 0150 1611  	JNE	L2174			No!
  0230 0152 8CB0  	C	*R0+,*R2+		Char 3 and 4 equal?
  0231 0154 160F  	JNE	L2174			No!
  0232 0156 8CB0  	C	*R0+,*R2+		Char 5 and 6 equal?
  0233 0158 160D  	JNE	L2174			No!
  0234 015A C810  	MOV	*R0,@UTLTAB		Save function address
       015C 0022'
  0235 015E 02E0  L215E	LWPI	USERWS
       0160 00BA'
  0236 0162 C020  	MOV	@UTLTAB,R0		Get function address
       0164 0022'
  0237 0166 1309  	JEQ	L217A			Unresolved or not defined!
  0238 0168 0690  	BL	*R0			Call assembler function
  0239 016A 02E0  	LWPI	GPLWS			Restore GPL environment
       016C 83E0 
  0240 016E C2E0  	MOV	@SVGPRT,R11
       0170 0030'
  0241 0172 045B  	B	*R11
  0242            
  0243 0174 0221  L2174	AI	R1,8			Next name
       0176 0008 
  0244 0178 10E4  	JMP	L2142			Continue!
  0245            
  0246 017A 0200  L217A	LI	R0,>0F00		Return to GPL
       017C 0F00 
  0247 017E D800  L217E	MOVB	R0,@>8322
       0180 8322 
  0248 0182 02E0  	LWPI	GPLWS
       0184 83E0 
  0249 0186 0460  	B	@>00CE
       0188 00CE 
  0250            
  0251 018A 5820  L218A	SZCB	@BC20,@>8349		Set EQ bit
       018C 00FC'
       018E 8349 
  0252 0190 02E0  	LWPI	UTILWS
       0192 0094'
  0253 0194 0380  	RTWP
  0254 TRUE       #endif
  0255            
  0256            * XMLLNK  (>2196)
  0257 TRUE       #if XMLLK#
  0258 0196 C83E  XMLLK$	MOV	*R14+,@GPLWS+MR01	Function number to R1
       0198 83E2 
  0259 019A 02E0  	LWPI	GPLWS
       019C 83E0 
  0260 019E C80B  	MOV	R11,@UTILWS+MR11	Save R11
       01A0 00AA'
  0261 01A2 C081  	MOV	R1,R2
  0262 01A4 0281  	CI	R1,>8000		Function is start address?
       01A6 8000 

 Xa99 Cross Assembler
EA UTILITIES IN LOW MEMORY                                   PAGE 0006
  0263 01A8 1B07  	JH	XMLGO			No!
  0264 01AA 09C1  	SRL	R1,12			Table number
  0265 01AC 0A11  	SLA	R1,01
  0266 01AE 0A42  	SLA	R2,04			Function number
  0267 01B0 09B2  	SRL	R2,11
  0268 01B2 A0A1  	A	@>0CFA(R1),R2		Get function address offset
       01B4 0CFA 
  0269 01B6 C092  	MOV	*R2,R2			Get function address
  0270 01B8 0692  XMLGO	BL	*R2			Call function
  0271 01BA 02E0  	LWPI	UTILWS
       01BC 0094'
  0272 01BE C80B  	MOV	R11,@GPLWS+MR11		Restore R11
       01C0 83F6 
  0273 01C2 0380  	RTWP
  0274 TRUE       #endif
  0275            
  0276            
  0277            * GPLLNK
  0278 TRUE       #if GPLLK#
  0279 01C4 D060  GPLLK$	MOVB	@>8373,R1		Get offset on GPL subroutine stack
       01C6 8373 
  0280 01C8 0981  	SRL	R1,08			Move to LSByte
  0281 01CA C87E  	MOV	*R14+,@>8304(R1)	Copy GPL routine number to stack
       01CC 8304 
  0282 01CE F820  	SOCB	@BC20,@>8349		Set bit ?
       01D0 00FC'
       01D2 8349 
  0283 01D4 02E0  	LWPI	GPLWS
       01D6 83E0 
  0284 01D8 C2E0  	MOV	@SVGPRT,R11		Get return address
       01DA 0030'
  0285 01DC 045B  	B	*R11
  0286 TRUE       #endif
  0287            
  0288            * KSCAN
  0289 TRUE       #if KSCAN#
  0290 01DE 02E0  KSCAN$	LWPI	GPLWS
       01E0 83E0 
  0291 01E2 C80B  	MOV	R11,@UTILWS+MR11	20AA
       01E4 00AA'
  0292 01E6 06A0  	BL	@SCAN
       01E8 000E 
  0293 01EA 02E0  	LWPI	UTILWS
       01EC 0094'
  0294 01EE C80B  	MOV	R11,@GPLWS+MR11		83F6
       01F0 83F6 
  0295 01F2 0380  	RTWP
  0296 TRUE       #endif
  0297            
  0298            * VSBW
  0299 TRUE       #if VSBW#
  0300 01F4 06A0  VSBW$	BL	@VDPW
       01F6 023A'
  0301 01F8 D82D  	MOVB	@2(R13),@VDPWD
       01FA 0002 
       01FC 8C00 
  0302 01FE 0380  	RTWP
  0303 TRUE       #endif
  0304            

 Xa99 Cross Assembler
EA UTILITIES IN LOW MEMORY                                   PAGE 0007
  0305            * VMBW
  0306 TRUE       #if VMBW#
  0307 0200 06A0  VMBW$	BL	@VDPW
       0202 023A'
  0308 0204 D831  VMBW$1	MOVB	*R1+,@VDPWD
       0206 8C00 
  0309 0208 0602  	DEC	R2
  0310 020A 16FC  	JNE	VMBW$1
  0311 020C 0380  	RTWP
  0312 TRUE       #endif
  0313            
  0314            * VSBR
  0315 TRUE       #if VSBR#
  0316 020E 06A0  VSBR$	BL	@VDPR			2240
       0210 0240'
  0317 0212 DB60  	MOVB	@VDPRD,@2(R13)
       0214 8800 
       0216 0002 
  0318 0218 0380  	RTWP
  0319 TRUE       #endif
  0320            
  0321            * VMBR
  0322 TRUE       #if VMBR#
  0323 021A 06A0  VMBR$	BL	@VDPR
       021C 0240'
  0324 021E DC60  VMBR$1	MOVB	@VDPRD,*R1+
       0220 8800 
  0325 0222 0602  	DEC	R2
  0326 0224 16FC  	JNE	VMBR$1
  0327 0226 0380  	RTWP
  0328 TRUE       #endif
  0329            
  0330            * VWTR
  0331 TRUE       #if VWTR#
  0332 0228 C05D  VWTR$	MOV	*R13,R1
  0333 022A D82D  	MOVB	@1(R13),@VDPWA
       022C 0001 
       022E 8C02 
  0334 0230 0261  	ORI	R1,>8000
       0232 8000 
  0335 0234 D801  	MOVB	R1,@VDPWA
       0236 8C02 
  0336 0238 0380  	RTWP
  0337 TRUE       #endif
  0338            
  0339            
  0340            * VDP R/W helper
  0341 TRUE       #if VDPH#
  0342 023A 0201  VDPW	LI	R1,>4000
       023C 4000 
  0343 023E 1001  	JMP	VDP$1
  0344 0240 04C1  VDPR	CLR	R1
  0345 0242 C09D  VDP$1	MOV	*R13,R2
  0346 0244 D820  	MOVB	@UTILWS+LR02,@VDPWA	@>2099 ,@>8C02
       0246 0099'
       0248 8C02 
  0347 024A E081  	SOC	R1,R2
  0348 024C D802  	MOVB	R2,@VDPWA
       024E 8C02 

 Xa99 Cross Assembler
EA UTILITIES IN LOW MEMORY                                   PAGE 0008
  0349 0250 C06D  	MOV	@2(R13),R1
       0252 0002 
  0350 0254 C0AD  	MOV	@4(R13),R2
       0256 0004 
  0351 0258 045B  	RT
  0352 TRUE       #endif
  0353            
  0354            
  0355            * CIF (XML >23)	>225A
  0356 TRUE       #if CIF#
  0357 025A 0204  CIF	LI	R4,>834A		Get integer value in FAC
       025C 834A 
  0358 025E C014  	MOV	*R4,R0
  0359 0260 C184  	MOV	R4,R6			Clear FAC
  0360 0262 04F6  	CLR	*R6+
  0361 0264 04F6  	CLR	*R6+
  0362 0266 C140  	MOV	R0,R5			INT=0?
  0363 0268 1323  	JEQ	L22B0			Yes!
  0364 026A 0740  	ABS	R0
  0365 026C 0203  	LI	R3,>0040		100^(R3 - 64)
       026E 0040 
  0366 0270 04F6  	CLR	*R6+			Clear some more of FAC
  0367 0272 04D6  	CLR	*R6
  0368 0274 0280  	CI	R0,100			INT<100?
       0276 0064 
  0369 0278 1A13  	JL	L22A0			Yes!
  0370 027A 0280  	CI	R0,10000		INT<...?
       027C 2710 
  0371 027E 1A08  	JL	L2290			Yes!
  0372 0280 0583  	INC	R3			Increment power of 100
  0373 0282 C040  	MOV	R0,R1
  0374 0284 04C0  	CLR	R0
  0375 0286 3C20  	DIV	@DC100,R0		Divide by 100
       0288 00FA'
  0376 028A D920  	MOVB	@GPLWS+LR01,@3(R4)	Third byte of FLT
       028C 83E3 
       028E 0003 
  0377 0290 0583  L2290	INC	R3			Increment power of 100
  0378 0292 C040  	MOV	R0,R1
  0379 0294 04C0  	CLR	R0
  0380 0296 3C20  	DIV	@DC100,R0		Divide by 100
       0298 00FA'
  0381 029A D920  	MOVB	@GPLWS+LR01,@2(R4)	Second byte of FLT
       029C 83E3 
       029E 0002 
  0382 02A0 D920  L22A0	MOVB	@GPLWS+LR00,@1(R4)	First byte of FLT
       02A2 83E1 
       02A4 0001 
  0383 02A6 D520  	MOVB	@GPLWS+LR03,*R4		Power of 100 of FLT
       02A8 83E7 
  0384 02AA 0545  	INV	R5			Was INT a positive number ?
  0385 02AC 1101  	JLT	L22B0			Yes!
  0386 02AE 0514  	NEG	*R4			No, make FLT also negative!
  0387 02B0 045B  L22B0	B	*R11
  0388 TRUE       #endif
  0389            
  0390            * DSRLNK
  0391 TRUE       #if DSRLK#
  0392 02B2 C17E  DSRLK$	MOV	*R14+,R5		Routine number

 Xa99 Cross Assembler
EA UTILITIES IN LOW MEMORY                                   PAGE 0009
  0393 02B4 53E0  	SZCB	@BC20,R15		Reset EQ bit
       02B6 00FC'
  0394 02B8 C020  	MOV	@>8356,R0		Pab pointer to name
       02BA 8356 
  0395 02BC C240  	MOV	R0,R9			Pab pointer
  0396 02BE 0229  	AI	R9,-8
       02C0 FFF8 
  0397 02C2 0420  	BLWP	@VSBR			Get name length
       02C4 0114'
  0398 02C6 D0C1  	MOVB	R1,R3			Store
  0399 02C8 0983  	SRL	R3,8			To LSByte
  0400 02CA 0704  	SETO	R4			Devicename length
  0401 02CC 0202  	LI	R2,DSRLNB		Name buffer
       02CE 008C'
  0402 02D0 0580  DSRL#0	INC	R0			Get next char of name
  0403 02D2 0584  	INC	R4
  0404 02D4 80C4  	C	R4,R3			Last character of name?
  0405 02D6 1306  	JEQ	DSRL#1			Yes!
  0406 02D8 0420  	BLWP	@VSBR			Get next character
       02DA 0114'
  0407 02DC DC81  	MOVB	R1,*R2+			Add to name buffer
  0408 02DE 9801  	CB	R1,@BC2E		Is it '.'?
       02E0 00FE'
  0409 02E2 16F6  	JNE	DSRL#0			No!
  0410 02E4 C104  DSRL#1	MOV	R4,R4			Name length=0?
  0411 02E6 1352  	JEQ	DSR#DN			Yes!
  0412 02E8 0284  	CI	R4,7			Name length>7?
       02EA 0007 
  0413 02EC 154F  	JGT	DSR#DN			Yes!
  0414            
  0415 02EE 04E0  	CLR	@>83D0			Last used CRU address
       02F0 83D0 
  0416 02F2 C804  	MOV	R4,@>8354		Save name length
       02F4 8354 
  0417 02F6 C804  	MOV	R4,@SAVLEN
       02F8 0036'
  0418 02FA 0584  	INC	R4			Adjust beyond '.'
  0419 02FC A804  	A	R4,@>8356		Position after name
       02FE 8356 
  0420 0300 C820  	MOV	@>8356,@SAVPAB
       0302 8356 
       0304 0038'
  0421            
  0422 0306 02E0  DSR#SR	LWPI	GPLWS
       0308 83E0 
  0423 030A 04C1  	CLR	R1			Version found
  0424 030C 020C  	LI	R12,>0F00		First device CRU address
       030E 0F00 
  0425 0310 C30C  DSR#NR	MOV	R12,R12
  0426 0312 1301  	JEQ	DSR#ON
  0427 0314 1E00  	SBZ	0			Device off
  0428 0316 022C  DSR#ON	AI	R12,>0100		Next device
       0318 0100 
  0429 031A 04E0  	CLR	@>83D0
       031C 83D0 
  0430 031E 028C  	CI	R12,>2000		End of devices?
       0320 2000 
  0431 0322 1332  	JEQ	DSR#NO			Yes!
  0432            

 Xa99 Cross Assembler
EA UTILITIES IN LOW MEMORY                                   PAGE 0010
  0433 0324 C80C  	MOV	R12,@>83D0		Save cru
       0326 83D0 
  0434 0328 1D00  	SBO	0			Device on
  0435 032A 0202  	LI	R2,>4000		Start of DSR rom
       032C 4000 
  0436 032E 9812  	CB	*R2,@BCAA		Id >AA?
       0330 00FF'
  0437 0332 16EE  	JNE	DSR#NR			No!
  0438 0334 A0A0  	A	@DSRLWS+MR05,R2
       0336 00A4'
  0439 0338 1003  	JMP	DSR#4
  0440            
  0441 033A C0A0  DSR#3	MOV	@>83D2,R2		Continue
       033C 83D2 
  0442 033E 1D00  	SBO	0			Device on
  0443 0340 C092  DSR#4	MOV	*R2,R2			Address=0?
  0444 0342 13E6  	JEQ	DSR#NR			Yes!
  0445 0344 C802  	MOV	R2,@>83D2		Store table entry
       0346 83D2 
  0446 0348 05C2  	INCT	R2			Start address
  0447 034A C272  	MOV	*R2+,R9
  0448 034C D160  	MOVB	@>8355,R5		Get devicename length
       034E 8355 
  0449 0350 1309  	JEQ	DSR#6			=0, dont do match
  0450 0352 9C85  	CB	R5,*R2+			Length match?
  0451 0354 16F2  	JNE	DSR#3			No!
  0452            
  0453 0356 0985  	SRL	R5,8
  0454 0358 0206  	LI	R6,DSRLNB		Device name
       035A 008C'
  0455 035C 9CB6  DSR#5	CB	*R6+,*R2+		Are names equal?
  0456 035E 16ED  	JNE	DSR#3			No!
  0457 0360 0605  	DEC	R5			More?
  0458 0362 16FC  	JNE	DSR#5			Yes!
  0459 0364 0581  DSR#6	INC	R1			Next version
  0460 0366 C801  	MOV	R1,@SAVVER		Save version
       0368 003A'
  0461 036A C809  	MOV	R9,@SAVENT		Save entry
       036C 0034'
  0462 036E C80C  	MOV	R12,@SAVCRU		Save cru
       0370 0032'
  0463 0372 0699  	BL	*R9			Execute
  0464 0374 10E2  	JMP	DSR#3			Wrong version
  0465 0376 1E00  	SBZ	0			Device off
  0466 0378 02E0  	LWPI	DSRLWS
       037A 009A'
  0467 037C C009  	MOV	R9,R0			Flagbyte in PAB
  0468 037E 0420  	BLWP	@VSBR
       0380 0114'
  0469 0382 09D1  	SRL	R1,13
  0470 0384 1604  	JNE	DSR#IO			IO error!
  0471 0386 0380  	RTWP
  0472            
  0473 0388 02E0  DSR#NO	LWPI	DSRLWS
       038A 009A'
  0474 038C 04C1  DSR#DN	CLR	R1			Devicename error
  0475 038E 06C1  DSR#IO	SWPB	R1			IO error
  0476 0390 D741  	MOVB	R1,*R13
  0477 0392 F3E0  	SOCB	@BC20,R15		Set EQ bit

 Xa99 Cross Assembler
EA UTILITIES IN LOW MEMORY                                   PAGE 0011
       0394 00FC'
  0478 0396 0380  	RTWP
  0479 TRUE       #endif
  0480            
  0481            * LOADER (CALL LOAD())
  0482 TRUE       #if LOADR#
  0483 0398 C80B  BLOADR	MOV       R11,@SVGPRT		Save GROM pointer
       039A 0030'
  0484 039C 02E0  	LWPI      USERWS
       039E 00BA'
  0485 03A0 0420  	BLWP      @LOADER		Load assembler code
       03A2 0124'
  0486 03A4 02E0  	LWPI      GPLWS
       03A6 83E0 
  0487 03A8 1303  	JEQ       L23B0			Error!
  0488 03AA C2E0  	MOV       @SVGPRT,R11		Restore GROM pointer
       03AC 0030'
  0489 03AE 045B  	B         *R11			Return
  0490 03B0 D820  L23B0	MOVB      @USERWS,@>8322 	Error code (R0 USERWS)
       03B2 00BA'
       03B4 8322 
  0491 03B6 0460  	B         @>00CE  		?
       03B8 00CE 
  0492            
  0493 03BA 04E0  LOADR$	CLR       @LPADDR		Clear start address
       03BC 0022'
  0494 03BE 53E0  	SZCB      @BC20,R15		Reset EQ bit
       03C0 00FC'
  0495 03C2 C020  	MOV       @>8356,R0		Addres of PAB in VDP
       03C4 8356 
  0496 03C6 0420  	BLWP      @DSRLNK		Open file
       03C8 0120'
  0497 03CA 0008  	DATA      8
  0498 03CC 1332  	JEQ       L2432			Error!
  0499 03CE 0220  	AI        R0,-9			Address of PAB in VDP
       03D0 FFF7 
  0500 03D2 0201  	LI        R1,>0200		Opcode for read
       03D4 0200 
  0501 03D6 0420  	BLWP      @VSBW			Write to pab
       03D8 010C'
  0502 03DA 0580  	INC       R0			Address of PAB Flag
  0503 03DC C800  	MOV       R0,@FLGPTR		Save pointer
       03DE 002E'
  0504 03E0 C1E0  	MOV       @FSTHI,R7		Free address in HIMEM
       03E2 0024'
  0505 03E4 C147  	MOV       R7,R5
  0506 03E6 04CC  	CLR       R12			Uncompressed(0) or Compressed(1) code
  0507 03E8 06A0  	BL        @L25E0 		Read a record
       03EA 05E0'
  0508 03EC 0283  	CI        R3,>0001		Compressed code?
       03EE 0001 
  0509 03F0 1624  	JNE       L243A			No!
  0510 03F2 058C  	INC       R12			Compressed code
  0511 03F4 04C3  	CLR       R3			...
  0512 03F6 1023  	JMP       L243E
  0513            
  0514            * Read next TAG until EOF
  0515            * R0 record data
  0516            * R1 record buffer address

 Xa99 Cross Assembler
EA UTILITIES IN LOW MEMORY                                   PAGE 0012
  0517            * R2 remaining bytes in record buffer
  0518            * R3 last read byte from record
  0519            * R4 Miscellaneous
  0520            * R5 relocation base
  0521            * R7 load address
  0522 03F8 0283  L23F8	CI        R3,>0046		End of record (tag F)?
       03FA 0046 
  0523 03FC 161E  	JNE       L243A			No!
  0524      03FE' TAGF EQU $			*** End of record
  0525 03FE 04C2  	CLR       R2			Finished
  0526            
  0527            * Read next TAG until EOF then close file
  0528            *
  0529      0400' TAG8 EQU $			*** Ignored record checksum	
  0530 0400 06A0  L2400	BL        @L262E  		Read next TAG (and record)
       0402 062E'
  0531 0404 0283  	CI        R3,>003A		End of file (tag :) ?
       0406 003A 
  0532 0408 16F7  	JNE       L23F8			No!
  0533 040A C020  	MOV       @FLGPTR,R0		Get PAB status address
       040C 002E'
  0534 040E 0600  	DEC       R0
  0535 0410 0201  	LI        R1,>0100		Close file opcode
       0412 0100 
  0536 0414 0420  	BLWP      @VSBW			Write to PAB
       0416 010C'
  0537 0418 06A0  	BL        @L25E0  		Close file
       041A 05E0'
  0538 041C C020  	MOV       @UTLTAB,R0		Auto start program?
       041E 0022'
  0539 0420 1307  	JEQ       L2430			No!
  0540 0422 06A0  	BL        @L2646  		Check for unresolved references
       0424 0646'
  0541 0426 1005  	JMP       L2432			There are unresolved references!
  0542 0428 CB4E  	MOV       R14,@MR11(R13)	Save return address of loader
       042A 0016 
  0543 042C C3A0  	MOV       @UTLTAB,R14		Start address loaded code
       042E 0022'
  0544 0430 0380  L2430	RTWP 				Execute!
  0545            
  0546 0432 D740  L2432	MOVB      R0,*R13		File IO result code
  0547 0434 F3E0  	SOCB      @BC20,R15		Set EQ bit
       0436 00FC'
  0548 0438 0380  	RTWP
  0549            
  0550 043A 06A0  L243A	BL        @L25C2		Convert ASCII to Binary
       043C 05C2'
  0551 043E 04C4  L243E	CLR       R4
  0552 0440 D123  	MOVB      @TAGTAB(R3),R4	Get TAG entry point
       0442 0662'
  0553 0444 0974  	SRL       R4,7			To LSByte * 2
  0554 0446 C808  	MOV       R8,@CHKSAV		Save checksum
       0448 002C'
  0555 044A 06A0  	BL        @L2594		Get DATA
       044C 0594'
  0556 044E 0464  	B         @L23F8(R4)		Call TAG function
       0450 03F8'
  0557            
  0558      0452' TAG0 EQU $			*** Module ID

 Xa99 Cross Assembler
EA UTILITIES IN LOW MEMORY                                   PAGE 0013
  0559 0452 0580  	INC       R0			Module length is even
  0560 0454 0240  	ANDI      R0,>FFFE
       0456 FFFE 
  0561 0458 C120  	MOV       @FSTHI,R4		Load in HIMEM
       045A 0024'
  0562 045C A100  	A         R0,R4
  0563 045E 1808  	JOC       L2470			Beyond 64Kb, Does not fit!
  0564 0460 8804  	C         R4,@LSTHI		Beyond last free HIMEM address?
       0462 0026'
  0565 0464 1B05  	JH        L2470			Yes, does not fit!
  0566 0466 C160  	MOV       @FSTHI,R5		Get relocation base in HIMEM
       0468 0024'
  0567 046A C804  	MOV       R4,@FSTHI		New relocation base in HIMEM
       046C 0024'
  0568 046E 100A  	JMP       L2484
  0569            	
  0570 0470 C120  L2470	MOV       @FSTLOW,R4		Load in LOMEM
       0472 0028'
  0571 0474 A100  	A         R0,R4
  0572 0476 8804  	C         R4,@LSTLOW		Beyond last free LOMEM address?
       0478 002A'
  0573 047A 140C  	JHE       L2494			Yes, does not fit!
  0574 047C C160  	MOV       @FSTLOW,R5		Get relocation base in LOMEM
       047E 0028'
  0575 0480 C804  	MOV       R4,@FSTLOW		New relocation base in LOMEM
       0482 0028'
  0576 0484 C1C5  L2484	MOV       R5,R7			Relocation base is also data load ad
  0577            
  0578      0486' TAGI EQU $			*** Program segment ID (ignored)
  0579 0486 0209  	LI        R9,8			Skip module ID name / Program segment ID n
       0488 0008 
  0580 048A 06A0  L248A	BL        @L262E		Get next BYTE
       048C 062E'
  0581 048E 0609  	DEC       R9			More to skip?
  0582 0490 16FC  	JNE       L248A			Yes!
  0583 0492 10B6  	JMP       L2400			Next TAG!
  0584            
  0585 0494 0200  L2494	LI        R0,>0800		IO Error 8: Memory overflow
       0496 0800 
  0586 0498 10CC  	JMP       L2432			Quit!
  0587            
  0588      049A' TAG2 EQU $			*** Relative entry address
  0589 049A A005  	A         R5,R0			Add relocation base
  0590      049C' TAG1 EQU $			*** Absolute entry address
  0591 049C C800  	MOV       R0,@LPADDR		Save module start address		
       049E 0022'
  0592 04A0 10AF  	JMP       L2400			Next TAG!
  0593            	
  0594      04A2' TAG7 EQU $			*** Record checksum	
  0595 04A2 A800  	A         R0,@CHKSAV		Add to calculated checksum
       04A4 002C'
  0596 04A6 13AC  	JEQ       L2400			Result is 0: Is Ok, Next TAG!
  0597 04A8 0200  	LI        R0,>0B00		IO Error 11: Checksum error
       04AA 0B00 
  0598 04AC 10C2  	JMP       L2432			Quit!
  0599            
  0600      04AE' TAGA EQU $			*** Relocatable load address
  0601 04AE A005  	A         R5,R0			Add relocation base
  0602      04B0' TAG9 EQU $			*** Absolute load address

 Xa99 Cross Assembler
EA UTILITIES IN LOW MEMORY                                   PAGE 0014
  0603 04B0 C1C0  	MOV       R0,R7			New load address
  0604 04B2 10A6  	JMP       L2400			Next TAG!
  0605            	
  0606            
  0607      04B4' TAGC EQU $			*** Relocatable data
  0608 04B4 A005  	A         R5,R0			Add relocation base
  0609      04B6' TAGB EQU $			*** Absolute data
  0610 04B6 DDC0  	MOVB      R0,*R7+		MSB data to CPU memory
  0611 04B8 DDE0  	MOVB      @LOADWS+LR00,*R7+	LSB data to CPU memory
       04BA 00DB'
  0612 04BC 10A1  	JMP       L2400			Next TAG!
  0613            	
  0614      04BE' TAG3 EQU $			*** Relocatable external reference
  0615 04BE A005  	A         R5,R0			Add relocation base
  0616      04C0' TAG4 EQU $			*** Absolute external reference
  0617 04C0 06A0  	BL        @L2566		Add to REF/DEF table
       04C2 0566'
  0618 04C4 C000  	MOV       R0,R0			Entry point is NULL?
  0619 04C6 1316  	JEQ       L24F4			Yes, first occurence
  0620 04C8 0226  L24C8	AI        R6,-8			Previous entry
       04CA FFF8 
  0621 04CC 8106  	C         R6,R4			Reached new added entry?
  0622 04CE 1B02  	JH        L24D4			No, check if allready added
  0623 04D0 0514  	NEG       *R4			Yes, not a DEF found
  0624 04D2 1096  L24D2	JMP       L2400			Next TAG!
  0625            
  0626            
  0627            * Solve a REF
  0628            *
  0629            * Input: R3 New added name entry address
  0630            *	 R4 New added name in REF/DEF table
  0631            *        R6 A previous added name in REF/DEF table
  0632            *
  0633 04D4 8594  L24D4	C         *R4,*R6		Char 1 and 2 equal?
  0634 04D6 16F8  	JNE       L24C8			No!
  0635 04D8 89A4  	C         @2(R4),@2(R6)		Char 3 and 4 equal?
       04DA 0002 
       04DC 0002 
  0636 04DE 16F4  	JNE       L24C8			No!
  0637 04E0 89A4  	C         @4(R4),@4(R6)		Char 5 and 6 equal?
       04E2 0004 
       04E4 0004 
  0638 04E6 16F0  	JNE       L24C8			No!
  0639 04E8 C0E6  	MOV       @6(R6),R3		Get REF address
       04EA 0006 
  0640 04EC C250  L24EC	MOV       *R0,R9		Expand list: get previous REF
  0641 04EE C403  	MOV       R3,*R0		Link the new
  0642 04F0 C009  	MOV       R9,R0			More to solve?
  0643 04F2 16FC  	JNE       L24EC			Yes!
  0644 04F4 0224  L24F4	AI        R4,8			Remove last added name
       04F6 0008 
  0645 04F8 C804  	MOV       R4,@LSTLOW		Repair last free addres in LOMEM
       04FA 002A'
  0646 04FC 10EA  	JMP       L24D2			Next TAG!
  0647            
  0648      04FE' TAG5 EQU $			*** Relocatable external definition
  0649 04FE A005  	A         R5,R0			Add relocation base
  0650      0500' TAG6 EQU $			*** Absolute external definition
  0651 0500 06A0  	BL        @L2566		Add to REF/DEF table

 Xa99 Cross Assembler
EA UTILITIES IN LOW MEMORY                                   PAGE 0015
       0502 0566'
  0652 0504 0226  L2504	AI        R6,-8			Previous entry
       0506 FFF8 
  0653 0508 8106  L2508	C         R6,R4			Reached new added entry?
  0654 050A 13E3  	JEQ       L24D2			Yes, Next TAG!
  0655            
  0656 050C C296  	MOV       *R6,R10		Get first two chars of name
  0657 050E 1501  	JGT       L2512			Positive: DEFINED
  0658 0510 050A  	NEG       R10			Negative: UNDEFINED
  0659 0512 8294  L2512	C         *R4,R10		Char 1 and 2 equal?
  0660 0514 16F7  	JNE       L2504			No!
  0661 0516 89A4  	C         @2(R4),@2(R6)		Char 3 and 4 equal?
       0518 0002 
       051A 0002 
  0662 051C 16F3  	JNE       L2504			No!
  0663 051E 89A4  	C         @4(R4),@4(R6)		Char 5 and 6 equal?
       0520 0004 
       0522 0004 
  0664 0524 16EF  	JNE       L2504			No!
  0665 0526 C296  	MOV       *R6,R10		Get first two chars of name
  0666 0528 1516  	JGT       L2556			Positive: DEFINED
  0667            
  0668 052A C0E6  	MOV       @6(R6),R3		Get DEF address
       052C 0006 
  0669 052E C253  L252E	MOV       *R3,R9		Resolve list: Get REF address
  0670 0530 C4C0  	MOV       R0,*R3		Resolve REF
  0671 0532 C0C9  L2532	MOV       R9,R3			Next in list
  0672 0534 16FC  	JNE       L252E			More to resolve
  0673 0536 C246  	MOV       R6,R9			Calculate offset old entry
  0674 0538 6244  	S         R4,R9			and new entry
  0675 053A C286  	MOV       R6,R10		Start here
  0676 053C 022A  	AI        R10,8			
       053E 0008 
  0677 0540 C0C6  	MOV       R6,R3			From here
  0678 0542 0643  L2542	DECT      R3
  0679 0544 064A  	DECT      R10
  0680 0546 C693  	MOV       *R3,*R10		Move entry's up
  0681 0548 0649  	DECT      R9			More to move?
  0682 054A 16FB  	JNE       L2542			Yes!
  0683 054C 0224  	AI        R4,8			Previous name is removed
       054E 0008 
  0684 0550 C804  	MOV       R4,@LSTLOW		Repair last free address in LOMEM
       0552 002A'
  0685 0554 10D9  	JMP       L2508			Continue 
  0686            	
  0687 0556 CB44  L2556	MOV       R4,@2(R13)
       0558 0002 
  0688 055A 0200  	LI        R0,>0C00		Error 12: Unresolved reference
       055C 0C00 
  0689 055E 0460  	B         @L2432		Quit
       0560 0432'
  0690 0562 0460  L2562	B         @L2494		Error 8: Memory overflow
       0564 0494'
  0691            
  0692            * Add a new reference or definition to the REF/DEF table
  0693            *
  0694            * Input : R0 reference/definition address
  0695            * Output: R6 end address of REF/DEF table
  0696            *

 Xa99 Cross Assembler
EA UTILITIES IN LOW MEMORY                                   PAGE 0016
  0697 0566 C28B  L2566	MOV       R11,R10		Save return address
  0698 0568 0209  	LI        R9,6			REF/DEF name length
       056A 0006 
  0699 056C C1A0  	MOV       @LSTLOW,R6		Start address of REF/DEF table
       056E 002A'
  0700 0570 0226  	AI        R6,-8			Reserve space for new name
       0572 FFF8 
  0701 0574 C106  	MOV       R6,R4			Save
  0702 0576 8806  	C         R6,@FSTLOW		Below first free address in LOMEM?
       0578 0028'
  0703 057A 1AF3  	JL        L2562			Yes, out of memory!
  0704 057C C806  	MOV       R6,@LSTLOW		Updated address REF/DEF table
       057E 002A'
  0705 0580 06A0  L2580	BL        @L262E		Get next BYTE
       0582 062E'
  0706 0584 DDA0  	MOVB      @LOADWS+LR03,*R6+	Copy to REF/DEF table
       0586 00E1'
  0707 0588 0609  	DEC       R9			More bytes?
  0708 058A 16FA  	JNE       L2580			Yes
  0709 058C C580  	MOV       R0,*R6		Add REF/DEF address to table
  0710 058E 0206  	LI        R6,>4000		End address of REF/DEF table
       0590 4000 
  0711 0592 045A  	B         *R10			Return
  0712            
  0713            * Get (un)compressed data from record
  0714            *
  0715            * Input : R1 Record address
  0716            *         R2 Number of remaining bytes
  0717            *         R8 Updated record checksum
  0718            * Output: R0 Data from record
  0719            *
  0720 0594 C28B  L2594	MOV       R11,R10		Save return address
  0721 0596 04C0  	CLR       R0
  0722 0598 C30C  	MOV       R12,R12		Compressed?
  0723 059A 1308  	JEQ       L25AC			No!
  0724 059C 06A0  	BL        @L262E		Get next BYTE
       059E 062E'
  0725 05A0 D020  	MOVB      @LOADWS+LR03,R0	To MSB of R0
       05A2 00E1'
  0726 05A4 06A0  	BL        @L262E		Get next BYTE
       05A6 062E'
  0727 05A8 A003  	A         R3,R0			To LSB of R0
  0728 05AA 045A  	B         *R10			Return
  0729            *
  0730            * Get uncompressed data from record
  0731            *
  0732 05AC 0209  L25AC	LI        R9,4			Number of nibbles to get
       05AE 0004 
  0733 05B0 06A0  L25B0	BL        @L262E		Get next TAG/BYTE
       05B2 062E'
  0734 05B4 06A0  	BL        @L25C2		Convert ASCII to Binary
       05B6 05C2'
  0735 05B8 0A40  	SLA       R0,4			Shift nibbles in Ro
  0736 05BA A003  	A         R3,R0			To LSNibble of R0
  0737 05BC 0609  	DEC       R9			More nibbles?
  0738 05BE 16F8  	JNE       L25B0			Yes!
  0739 05C0 045A  	B         *R10			Return
  0740            
  0741            * Convert ASCII 0-9,A-I to binary

 Xa99 Cross Assembler
EA UTILITIES IN LOW MEMORY                                   PAGE 0017
  0742            *
  0743            * Input : R3 LSByte ASCII value
  0744            * Output: R3 LSNibble Binary value 
  0745            *
  0746 05C2 0223  L25C2	AI        R3,-48		Subtract ASCII '0'
       05C4 FFD0 
  0747 05C6 0283  	CI        R3,10			Value 0-9?
       05C8 000A 
  0748 05CA 1A05  	JL        L25D6			Yes!
  0749 05CC 0223  	AI        R3,-7
       05CE FFF9 
  0750 05D0 0283  	CI        R3,25			Value A-I? (this must be CI R3,18)
       05D2 0019 
  0751 05D4 1B01  	JH        L25D8			No, illegal TAG!
  0752 05D6 045B  L25D6	B         *R11			Ok!
  0753            
  0754      05D8' TAGD EQU $			*** Load Bias
  0755      05D8' TAGE EQU $			*** Undefined
  0756      05D8' TAGG EQU $			*** Undefined
  0757      05D8' TAGH EQU $			*** Undefined
  0758 05D8 0200  L25D8	LI        R0,>0A00		IO error 10: Illegal tag
       05DA 0A00 
  0759 05DC 0460  	B         @>2432		Quit!
       05DE 2432 
  0760            
  0761            * Read record or Close file
  0762            *
  0763            * Input : PAB opcode set to read (2) or close (1)
  0764            * Output: R1 Record address
  0765            *         R2 Number of remaining bytes
  0766            *         R3 First TAG
  0767            *         R8 Updated record checksum
  0768            *
  0769 05E0 02E0  L25E0	LWPI      GPLWS
       05E2 83E0 
  0770 05E4 0200  	LI        R0,SAVCRU
       05E6 0032'
  0771 05E8 C330  	MOV       *R0+,R12		Restore CRU
  0772 05EA C270  	MOV       *R0+,R9		Restore DSR entry
  0773 05EC C830  	MOV       *R0+,@>8354 		Restore name length
       05EE 8354 
  0774 05F0 C830  	MOV       *R0+,@>8356 		Restore name address
       05F2 8356 
  0775 05F4 C050  	MOV       *R0,R1		Restore version
  0776 05F6 1D00  	SBO       0			Device on
  0777 05F8 9820  	CB        @>4000,@BCAA		DSR available?
       05FA 4000 
       05FC 00FF'
  0778 05FE 161D  	JNE       L263A			No, quit
  0779 0600 0699  	BL        *R9			Call DSR function
  0780 0602 101B  	JMP       L263A			Error
  0781 0604 1E00  	SBZ       0			Device off
  0782 0606 02E0  	LWPI      LOADWS
       0608 00DA'
  0783 060A C020  	MOV       @FLGPTR,R0		FlgPtr of PAB in VDP
       060C 002E'
  0784 060E 0201  	LI        R1,LOADWS+LR00	Start destination LB R0
       0610 00DB'
  0785 0612 0202  	LI        R2,4			Number of bytes to read: Read Flg (R0),

 Xa99 Cross Assembler
EA UTILITIES IN LOW MEMORY                                   PAGE 0018
       0614 0004 
  0786 0616 0420  	BLWP      @VMBR			Buffer address (R1),  Record length(R2)
       0618 0118'
  0787 061A 7000  	SB        R0,R0			Reset MSB R0
  0788 061C 0950  	SRL       R0,5			PAB status is no error?
  0789 061E 1610  	JNE       L2640			No, quit!
  0790 0620 0982  	SRL       R2,8			Record length to LSB
  0791 0622 C001  	MOV       R1,R0			Buffer address in VDP to R0
  0792 0624 0201  	LI        R1,LOADRB		Record buffer in CPU ram
       0626 003C'
  0793 0628 0420  	BLWP      @VMBR			Copy record
       062A 0118'
  0794 062C 04C8  	CLR       R8			Clear checksum
  0795            
  0796            * Get next BYTE
  0797            *
  0798            * Input : R1 Record address
  0799            *         R2 Number of remaining bytes
  0800            *         R8 Updated record checksum
  0801            * Output: R3 Next TAG
  0802            *         R1,R2,R8 Updated
  0803            *
  0804 062E 0602  L262E	DEC       R2			More data available?
  0805 0630 11D7  	JLT       L25E0			No, read next record!
  0806 0632 D0F1  	MOVB      *R1+,R3		Get BYTE
  0807 0634 0983  	SRL       R3,8
  0808 0636 A203  	A         R3,R8			Update checksum
  0809 0638 045B  	B         *R11
  0810            
  0811 063A 02E0  L263A	LWPI      LOADWS
       063C 00DA'
  0812 063E 04C0  	CLR       R0			IO error 0: Device not found
  0813 0640 06C0  L2640	SWPB      R0
  0814 0642 0460  	B         @>2432  		Quit
       0644 2432 
  0815            
  0816            * Check REF/DEF table for unresolved references
  0817 0646 0201  L2646	LI        R1,>3F40		End of current loaded REF/DEF tabl
       0648 3F40 
  0818 064A 0221  L264A	AI        R1,-8			Previous entry
       064C FFF8 
  0819 064E C011  	MOV       *R1,R0		First two characters of name
  0820 0650 1105  	JLT       L265C			Negative, thus unresolved!
  0821 0652 8060  	C         @LSTLOW,R1		More?
       0654 002A'
  0822 0656 16F9  	JNE       L264A			Yes!
  0823 0658 05CB  	INCT      R11
  0824 065A 045B  	B         *R11
  0825 065C 0200  L265C	LI        R0,>0D00		Error 13: Unresolved references
       065E 0D00 
  0826 0660 045B  	B         *R11
  0827            
  0828            * TAG jump table relative to code at L23F8
  0829            * Entry address: L23F8 + 2*OFFSET
  0830            *
  0831 0662   2D  TAGTAB	BYTE TAG0-L23F8/2	>2D	TAG 0
  0832 0663   52  	BYTE TAG1-L23F8/2	>52	TAG 1
  0833 0664   51  	BYTE TAG2-L23F8/2	>51	TAG 2
  0834 0665   63  	BYTE TAG3-L23F8/2	>63	TAG 3

 Xa99 Cross Assembler
EA UTILITIES IN LOW MEMORY                                   PAGE 0019
  0835 0666   64  	BYTE TAG4-L23F8/2	>64	TAG 4
  0836 0667   83  	BYTE TAG5-L23F8/2	>83	TAG 5
  0837 0668   84  	BYTE TAG6-L23F8/2	>84	TAG 6
  0838 0669   55  	BYTE TAG7-L23F8/2	>55	TAG 7
  0839 066A   04  	BYTE TAG8-L23F8/2	>04	TAG 8
  0840 066B   5C  	BYTE TAG9-L23F8/2	>5C	TAG 9
  0841 066C   5B  	BYTE TAGA-L23F8/2	>5B	TAG A
  0842 066D   5F  	BYTE TAGB-L23F8/2	>5F	TAG B
  0843 066E   5E  	BYTE TAGC-L23F8/2	>5E	TAG C
  0844 066F   F0  	BYTE TAGD-L23F8/2	>F0	TAG D
  0845 0670   F0  	BYTE TAGE-L23F8/2	>F0	TAG E
  0846 0671   03  	BYTE TAGF-L23F8/2	>03	TAG F
  0847 0672   F0  	BYTE TAGG-L23F8/2	>F0	TAG G
  0848 0673   F0  	BYTE TAGH-L23F8/2	>F0	TAG H
  0849 0674   47  	BYTE TAGI-L23F8/2	>47	TAG I
  0850 0675   00  	BYTE >00	EOT
  0851 TRUE       #endif
  0852            
  0853      0676' LOFIFR	EQU	$		First free address in LO memory
  0854            
  0855            * REF/DEF Table
  0856            *
  0857 FALSE      #if GPRDT#
  0858            *
  0859            * Fill predefined REF/DEF table
  0860            *
  0861            AORG#0	EQU	11*8+>3F38
  0862            
  0863            AORG#X	EQU	SCAN#+XMLLK#+KSCAN#+DSRLK#+LOADR#+GPLLK#
  0864            AORG#Y	EQU	VSBW#+VMBW#+VSBR#+VMBR#+VWTR#
  0865            AORG#Z	EQU	AORG#X+AORG#Y*8
  0866            
  0867            *LOLAFR	AORG	>3F38		Last free address in LO memory
  0868            LOLAFR	EQU	AORG#0-AORG#Z
  0869            
  0870            	AORG	LOLAFR		Last free address in LO memory
  0871            
  0872            	TEXT	'UTLTAB'
  0873            	DATA	UTLTAB		>2022
  0874            	TEXT	'PAD   '
  0875            	DATA	PAD		>8300
  0876            	TEXT	'GPLWS '
  0877            	DATA	GPLWS		>83E0
  0878            	TEXT	'SOUND '
  0879            	DATA	SOUND		>8400
  0880            	TEXT	'VDPRD '
  0881            	DATA	VDPRD		>8800
  0882            	TEXT	'VDPSTA'
  0883            	DATA	VDPSTA		>8802
  0884            	TEXT	'VDPWD '
  0885            	DATA	VDPWD		>8C00
  0886            	TEXT	'VDPWA '
  0887            	DATA	VDPWA		>8C02
  0888            	TEXT	'SPCHRD'
  0889            	DATA	SPCHRD		>9000
  0890            	TEXT	'SPCHWT'
  0891            	DATA	SPCHWT		>9400
  0892            	TEXT	'GRMRD '
  0893            	DATA	GRMRD		>9800

 Xa99 Cross Assembler
EA UTILITIES IN LOW MEMORY                                   PAGE 0020
  0894            	TEXT	'GRMRA '
  0895            	DATA	GRMWA		>9802
  0896            	TEXT	'GRMWD '
  0897            	DATA	GRMWD		>9C00
  0898            	TEXT	'GRMWA '
  0899            	DATA	GRMWA		>9C02
  0900            
  0901            
  0902 FALSE      #if SCAN#
  0903            	TEXT	'SCAN  '
  0904            	DATA	SCAN		>000E
  0905 FALSE      #endif
  0906 FALSE      #if XMLLK#
  0907            	TEXT	'XMLLNK'
  0908            	DATA	XMLLNK		>2104	2094 2196
  0909 FALSE      #endif
  0910 FALSE      #if KSCAN#
  0911            	TEXT	'KSCAN '
  0912            	DATA	KSCAN		>2108	2094 21DE
  0913 FALSE      #endif
  0914 FALSE      #if VSBW#
  0915            	TEXT	'VSBW  '
  0916            	DATA	VSBW		>210C	2094 21F4
  0917 FALSE      #endif
  0918 FALSE      #if VMBW#
  0919            	TEXT	'VMBW  '
  0920            	DATA	VMBW		>2110	2094 2200
  0921 FALSE      #endif
  0922 FALSE      #if VSBR#
  0923            	TEXT	'VSBR  '
  0924            	DATA	VSBR		>2114	2094 220E
  0925 FALSE      #endif
  0926 FALSE      #if VMBR#
  0927            	TEXT	'VMBR  '
  0928            	DATA	VMBR		>2118	2094 221A
  0929 FALSE      #endif
  0930 FALSE      #if VWTR#
  0931            	TEXT	'VWTR  '
  0932            	DATA	VWTR		>211C	2094 2228
  0933 FALSE      #endif
  0934 FALSE      #if DSRLK#
  0935            	TEXT	'DSRLNK'
  0936            	DATA	DSRLNK		>2120	209A 22B2
  0937 FALSE      #endif
  0938 FALSE      #if LOADR#
  0939            	TEXT	'LOADER'
  0940            	DATA	LOADER		>2124	20DA 23BA
  0941 FALSE      #endif
  0942 FALSE      #if GPLLK#
  0943            	TEXT	'GPLLNK'
  0944            	DATA	GPLLNK		>2100	2094 21C4
  0945 FALSE      #endif
  0946            
  0947 TRUE       #else
  0948            * No predefined REF/DEF table
  0949      4000  LOLAFR	EQU	>4000
  0950 TRUE       #endif
  0951            	END

 Xa99 Cross Assembler
EA UTILITIES IN LOW MEMORY                                   PAGE 0021
  ' BC00    00FD    ' BC20    00FC    ' BC2E    00FE    ' BCAA    00FF  
  ' BLOADR  0398    ' CHKSAV  002C    ' CIF     025A      CIF#    0001  
  ' DC100   00FA    ' DSR#3   033A    ' DSR#4   0340    ' DSR#5   035C  
  ' DSR#6   0364    ' DSR#DN  038C    ' DSR#IO  038E    ' DSR#NO  0388  
  ' DSR#NR  0310    ' DSR#ON  0316    ' DSR#SR  0306    ' DSRL#0  02D0  
  ' DSRL#1  02E4      DSRLK#  0001    ' DSRLK$  02B2    ' DSRLNB  008C  
  D DSRLNK  0120    ' DSRLWS  009A    ' FLGPTR  002E    ' FSTHI   0024  
  ' FSTLOW  0028      GPLLK#  0001    ' GPLLK$  01C4    D GPLLNK  0100  
  D GPLWS   83E0      GPRDT#  0000    D GRMRA   9802    D GRMRD   9800  
  D GRMWA   9C02    D GRMWD   9C00    D KSCAN   0108      KSCAN#  0001  
  ' KSCAN$  01DE    ' L2142   0142    ' L215E   015E    ' L2174   0174  
  ' L217A   017A    ' L217E   017E    ' L218A   018A    ' L2290   0290  
  ' L22A0   02A0    ' L22B0   02B0    ' L23B0   03B0    ' L23F8   03F8  
  ' L2400   0400    ' L2430   0430    ' L2432   0432    ' L243A   043A  
  ' L243E   043E    ' L2470   0470    ' L2484   0484    ' L248A   048A  
  ' L2494   0494    ' L24C8   04C8    ' L24D2   04D2    ' L24D4   04D4  
  ' L24EC   04EC    ' L24F4   04F4    ' L2504   0504    ' L2508   0508  
  ' L2512   0512    ' L252E   052E    ' L2532   0532    ' L2542   0542  
  ' L2556   0556    ' L2562   0562    ' L2566   0566    ' L2580   0580  
  ' L2594   0594    ' L25AC   05AC    ' L25B0   05B0    ' L25C2   05C2  
  ' L25D6   05D6    ' L25D8   05D8    ' L25E0   05E0    ' L262E   062E  
  ' L263A   063A    ' L2640   0640    ' L2646   0646    ' L264A   064A  
  ' L265C   065C    D LOADER  0124      LOADR#  0001    ' LOADR$  03BA  
  ' LOADRB  003C    ' LOADWS  00DA    ' LOFIFR  0676      LOLAFR  4000  
  ' LPADDR  0022      LR00    0001      LR01    0003      LR02    0005  
    LR03    0007      LR04    0009      LR05    000B      LR06    000D  
    LR07    000F      LR08    0011      LR09    0013      LR10    0015  
    LR11    0017      LR12    0019      LR13    001B      LR14    001D  
    LR15    001F    ' LSTHI   0026    ' LSTLOW  002A      MR00    0000  
    MR01    0002      MR02    0004      MR03    0006      MR04    0008  
    MR05    000A      MR06    000C      MR07    000E      MR08    0010  
    MR09    0012      MR10    0014      MR11    0016      MR12    0018  
    MR13    001A      MR14    001C      MR15    001E      NAMLK#  0001  
  ' NAMLNK  0128    D PAD     8300      R0      0000      R1      0001  
    R10     000A      R11     000B      R12     000C      R13     000D  
    R14     000E      R15     000F      R2      0002      R3      0003  
    R4      0004      R5      0005      R6      0006      R7      0007  
    R8      0008      R9      0009    ' SAVCRU  0032    ' SAVENT  0034  
  ' SAVLEN  0036    ' SAVPAB  0038    ' SAVVER  003A    D SCAN    000E  
    SCAN#   0001    D SOUND   8400    D SPCHRD  9000    D SPCHWT  9400  
  ' SVGPRT  0030    ' TAG0    0452    ' TAG1    049C    ' TAG2    049A  
  ' TAG3    04BE    ' TAG4    04C0    ' TAG5    04FE    ' TAG6    0500  
  ' TAG7    04A2    ' TAG8    0400    ' TAG9    04B0    ' TAGA    04AE  
  ' TAGB    04B6    ' TAGC    04B4    ' TAGD    05D8    ' TAGE    05D8  
  ' TAGF    03FE    ' TAGG    05D8    ' TAGH    05D8    ' TAGI    0486  
  ' TAGTAB  0662    ' USERWS  00BA    ' UTILWS  0094    D UTLTAB  0022  
  ' VDP$1   0242      VDPH#   0004    ' VDPR    0240    D VDPRD   8800  
  D VDPSTA  8802    ' VDPW    023A    D VDPWA   8C02    D VDPWD   8C00  
  D VMBR    0118      VMBR#   0001    ' VMBR$   021A    ' VMBR$1  021E  
  D VMBW    0110      VMBW#   0001    ' VMBW$   0200    ' VMBW$1  0204  
  D VSBR    0114      VSBR#   0001    ' VSBR$   020E    D VSBW    010C  
    VSBW#   0001    ' VSBW$   01F4    D VWTR    011C      VWTR#   0001  
  ' VWTR$   0228    ' XMLGO   01B8      XMLLK#  0001    ' XMLLK$  0196  
  D XMLLNK  0104  
  0000 ERRORS

 Xa99 Cross Assembler
EA UTILITIES IN LOW MEMORY                                   PAGE 0022
  SEGMENT RORG     SIZE 01654 (>0676) BYTES
