
 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0001
  0002            *         TITL 'C99 CSUP V6 - Runtime Library 12/01/2003'
  0003            
  0004                      IDT  'C99CSUP7'
  0005            
  0006            * Copyright 1988 Clint pulley
  0007            *
  0008            * This is the debuged version of the CSUP compiler routines
  0009            * for the TI99/4a
  0010            *
  0011            * Original version: Clint Pulley
  0012            *                   38 Townsend Avenue
  0013            *                   Burlington, Ontario
  0014            *                   Canada L7T 1Y6
  0015            *
  0016            * Updated by:       Frederik G. Kaal
  0017            *                   De Dadelboom 81
  0018            *                   1911 KK Uitgeest
  0019            *                   The Netherlands
  0020            *
  0021            * V6: Additions for the X-optimizer: passing arguments in re
  0022            *     for the funtions: XGETS,XPUTS,XDPUTS,XPUTC,XLOCAT,XPOL
  0023            *
  0024            *
  0025            * Updated by:       Frederik G. Kaal
  0026            *                   Goudsbloem 68
  0027            *                   3984CP Odijk
  0028            *                   The Netherlands
  0029            *
  0030            * V7: Set S$BUFF to 80 for V9938 and F18A 80 column mode
  0031            *     Removed symbols C$SEND,C$STRT
  0032            *     Added symbols ERRNO, CNULL from the now obsolete CGLOB
  0033            *

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0002
  0035                   DEF  START,C99STK      Start CSUP and stack
  0036                   DEF  TSCRN,POLL,LOCATE
  0037                   DEF  C$VADR,C$FILL,C$CLS,S$LOC
  0038            *      DEF  C$SEND,C$STRT,S$SEND,S$STRT,S$WDTH,ERRNO,CNULL
  0039                   DEF  S$SEND,S$STRT,S$WDTH,ERRNO,CNULL
  0040                   DEF  C$CALL,C$HOOK,C$SWCH,C$GPLL,C$CTFL
  0041                   DEF  ABORT,EXIT,C$PGRA,C$SGRA,S#DRCT
  0042                   DEF  DPUTS,PUTS,PUTCHA,GETS,GETCHA
  0043                   DEF  C$LNEG,C$CIND,C$REM
  0044                   DEF  C$DIV,C$ASL,C$ASR
  0045                   DEF  C$UGE,C$UGT,C$ULE,C$ULT
  0046                   DEF  C$GE,C$GT,C$LE,C$LT,C$NE,C$EQ
  0047                   DEF  XGETS,XPUTS,XDPUTS,XPUTC,XLOCAT,XPOLL,XTSRCN
  0048            
  0049                   REF  MAIN              User program
  0050            
  0051                   REF  GPLWS
  0052                   REF  GRMRD,GRMWD,GRMRA,GRMWA
  0053                   REF  VDPRD,VDPWD,VDPWA,VDPSTA
  0054                   REF  VWTR,VSBW,VMBW,VSBR,VMBR
  0055                   REF  DSRLNK,XMLLNK,GPLLNK
  0056                   REF  KSCAN,SCAN
  0057            

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0003
  0059            
  0060      8300  C99WS  EQU  >8300             C99 Workspace
  0061 0000 3FFE  C99STK DATA >3FFE             C99 Stack
  0062            
  0063      8300  HR0    EQU  C99WS+0
  0064      8301  LR0    EQU  C99WS+1
  0065      8302  HR1    EQU  C99WS+2
  0066      8303  LR1    EQU  C99WS+3
  0067      8304  HR2    EQU  C99WS+4
  0068      8305  LR2    EQU  C99WS+5
  0069      8306  HR3    EQU  C99WS+6
  0070      8307  LR3    EQU  C99WS+7
  0071      8308  HR4    EQU  C99WS+8
  0072      8309  LR4    EQU  C99WS+9
  0073      830A  HR5    EQU  C99WS+10
  0074      830B  LR5    EQU  C99WS+11
  0075      830C  HR6    EQU  C99WS+12
  0076      830D  LR6    EQU  C99WS+13
  0077      830E  HR7    EQU  C99WS+14
  0078      830F  LR7    EQU  C99WS+15
  0079      8310  HR8    EQU  C99WS+16
  0080      8311  LR8    EQU  C99WS+17
  0081      8312  HR9    EQU  C99WS+18
  0082      8313  LR9    EQU  C99WS+19
  0083      8314  HR10   EQU  C99WS+20
  0084      8315  LR10   EQU  C99WS+21
  0085      8316  HR11   EQU  C99WS+22
  0086      8317  LR11   EQU  C99WS+23
  0087      8318  HR12   EQU  C99WS+24
  0088      8319  LR12   EQU  C99WS+25
  0089      831A  HR13   EQU  C99WS+26
  0090      831B  LR13   EQU  C99WS+27
  0091      831C  HR14   EQU  C99WS+28
  0092      831D  LR14   EQU  C99WS+29
  0093      831E  HR15   EQU  C99WS+30
  0094      831F  LR15   EQU  C99WS+31
  0095            

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0004
  0097            
  0098            * PUSH
  0099            *
  0100            * Pushes contents R8 on stack
  0101            * Called as: BL R15
  0102            *
  0103 0002 064E  PUSH   DECT  R14
  0104 0004 880E         C     R14,@C99STK  DBG: Check lowest value stack poin
       0006 0000'
  0105 0008 1402         JHE   PUSHZ$
  0106 000A C80E         MOV   R14,@C99STK 
       000C 0000'
  0107 000E C788  PUSHZ$ MOV   R8,*R14
  0108 0010 045B         B     *R11
  0109      0010  PUSHZ  EQU   $-PUSH
  0110            
  0111            * CALL
  0112            * Calls a C written function
  0113            * Called as: BL   *R12
  0114            *            DATA function
  0115            *
  0116 0012 C1FB  CALL   MOV   *R11+,R7
  0117 0014 064E         DECT  R14
  0118 0016 C78B         MOV   R11,*R14
  0119 0018 0457         B     *R7
  0120      0008  CALLZ  EQU   $-CALL
  0121            
  0122            * RETURN
  0123            * Returns to calling function
  0124            * Called as: BL *R13
  0125            *
  0126 001A C1FE  RETURN MOV   *R14+,R7
  0127 001C 0457         B     *R7
  0128      0004  RETRNZ EQU   $-RETURN
  0129            
  0130            * C99 Main startup routine
  0131            
  0132 001E C80B  START  MOV  R11,@C99RT        Save return address
       0020 00AC'
  0133 0022 02E0         LWPI C99WS
       0024 8300 
  0134 0026 06A0         BL   @C$SGRA           Get GROM address
       0028 011E'
  0135 002A C800         MOV  R0,@C99GRA
       002C 013C'
  0136 002E 04C0         CLR  R0
  0137 0030 04C1         CLR  R1
  0138 0032 06A0         BL   @C$PGRA           Get G0000
       0034 012E'
  0139 0036 D060  START1 MOVB @GRMRD,R1
       0038 0000 
  0140 003A 0580         INC  R0
  0141 003C 0280         CI   R0,>17FF          Maximum number of bytes
       003E 17FF 
  0142 0040 1B0C         JH   START3            Yes
  0143            
  0144 0042 0281  START2 CI   R1,>0F00          Is it >07?
       0044 0F00 
  0145 0046 16F7         JNE  START1            No!

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0005
  0146 0048 D060         MOVB @GRMRD,R1         Read Next
       004A 0038'
  0147 004C 0580         INC  R0
  0148 004E 0281         CI   R1,>F000          Is pattern >07F0
       0050 F000 
  0149 0052 16F7         JNE  START2            No!
  0150 0054 0640         DECT R0                Yes!
  0151 0056 C800         MOV  R0,@C99GRB        Save address
       0058 013E'
  0152 005A 06A0  START3 BL   @C$CLS            Clear screen
       005C 044A'
  0153 005E 0200         LI   R0,>01F0          VDP R1=16K-BlankDisable-IntEna
       0060 01F0 
  0154 0062 0420         BLWP @VWTR
       0064 0000 
  0155 0066 06C0         SWPB R0
  0156 0068 D800         MOVB R0,@>83D4         Copy to >83D4
       006A 83D4 
  0157 006C 0200         LI   R0,>07F4          VDP R7=White on Blue
       006E 07F4 
  0158 0070 0420         BLWP @VWTR
       0072 0064'
  0159            *
  0160            * Setup R10 as pointer to LSB R8
  0161            * R12 as function call routine
  0162            * R13 as return routine
  0163            * R14 as stack pointer
  0164            * R15 as push routine
  0165            *
  0166 0074 0200         LI   R0,CEXIT1         Push return address
       0076 00AE'
  0167 0078 C3A0         MOV  @C99STK,R14       Stack address
       007A 0000'
  0168 007C 0720         SETO @C99STK           DBG: Max word for stack check
       007E 0000'
  0169 0080 C780         MOV  R0,*R14
  0170 0082 02A0         STWP R0
  0171 0084 C280         MOV  R0,R10
  0172 0086 022A         AI   R10,>0011         Lsb R8
       0088 0011 
  0173 008A 0220         AI   R0,>001E          Msb R15 is push routine
       008C 001E 
  0174 008E C300         MOV  R0,R12
  0175 0090 022C         AI   R12,PUSHZ         Size PUSH routine is start add
       0092 0010 
  0176 0094 C34C         MOV  R12,R13           Start address CALL routine
  0177 0096 022D         AI   R13,CALLZ         Size CALL routine is start add
       0098 0008 
  0178 009A 0201         LI   R1,PUSH
       009C 0002'
  0179 009E 0202         LI   R2,PUSHZ+CALLZ+RETRNZ
       00A0 001C 
  0180 00A2 CC31  START4 MOV  *R1+,*R0+         Move PUSH, CALL and RETURN to 
  0181 00A4 0642         DECT R2
  0182 00A6 16FD         JNE  START4
  0183 00A8 0460         B    @MAIN             Call user program
       00AA 0000 
  0184            
  0185 00AC FFFF  C99RT  DATA >FFFF             C99 return address

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0006
  0186            
  0187 00AE 0205  CEXIT1 LI   R5,C99T1          puts(C99T1)
       00B0 0102'
  0188 00B2 069C         BL   *R12
  0189 00B4 02C0'        DATA PUTS1
  0190            
  0191 00B6 C020  CEXIT2 MOV  @C$HOOK,R0        Close files?
       00B8 054E'
  0192 00BA 1301         JEQ  CEXIT3            No!
  0193 00BC 0690         BL   *R0               Yes!
  0194 00BE 0205  CEXIT3 LI   R5,C99T2          puts(C99T2)
       00C0 010C'
  0195 00C2 069C         BL   *R12
  0196 00C4 02C0'        DATA PUTS1
  0197            
  0198 00C6 06A0  CEXIT4 BL   @RDCHR            Read keyboard
       00C8 0358'
  0199 00CA 0241         ANDI R1,>5F00          Convert to UPC
       00CC 5F00 
  0200 00CE 0281         CI   R1,>5900          Y?
       00D0 5900 
  0201 00D2 13C3         JEQ  START3            Rerun!
  0202 00D4 0281         CI   R1,>4E00          N?
       00D6 4E00 
  0203 00D8 16F6         JNE  CEXIT4            No, read again
  0204            
  0205 00DA 06A0  CEXIT5 BL   @C$CLS            Clear screen
       00DC 044A'
  0206 00DE 04E0         CLR  @>837C            and GPL status
       00E0 837C 
  0207 00E2 0760         ABS  @C$CTFL           EA?
       00E4 011C'
  0208 00E6 1302         JEQ  CEXIT6            Yes!
  0209 00E8 0420         BLWP @>0000            Exit to title screen
       00EA 0000 
  0210            
  0211 00EC C020  CEXIT6 MOV  @C99GRA,R0        Restrore GROM address
       00EE 013C'
  0212 00F0 06A0         BL   @C$PGRA
       00F2 012E'
  0213 00F4 02E0         LWPI GPLWS
       00F6 0000 
  0214 00F8 C2E0         MOV  @C99RT,R11
       00FA 00AC'
  0215 00FC 0300         LIMI >0002
       00FE 0002 
  0216 0100 045B         B    *R11              Exit
  0217            
  0218 0102   0A  C99T1  BYTE 10
  0219 0103   63         TEXT 'c99 exit'
  0220 010B   00         BYTE 0
  0221 010C   2D  C99T2  TEXT '-Rerun? (Y/N) '
  0222 011A 0000         DATA 0
  0223            
  0224 011C 0000  C$CTFL DATA 0                 Console type flag EA, EXBAS?
  0225            
  0226 011E D020  C$SGRA MOVB @GRMRA,R0         Get Grom address
       0120 0000 
  0227 0122 06C0         SWPB R0

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0007
  0228 0124 D020         MOVB @GRMRA,R0
       0126 0120'
  0229 0128 06C0         SWPB R0
  0230 012A 0600         DEC  R0
  0231 012C 045B         B    *R11
  0232            
  0233 012E D800  C$PGRA MOVB R0,@GRMWA         Put Grom address
       0130 0000 
  0234 0132 06C0         SWPB R0
  0235 0134 D800         MOVB R0,@GRMWA
       0136 0130'
  0236 0138 06C0         SWPB R0
  0237 013A 045B         B    *R11
  0238            
  0239 013C 0000  C99GRA DATA  >0000            Grom address A
  0240 013E 0000  C99GRB DATA  >0000            Grom address B
  0241            
  0242 0140 D020  C$GPLL MOVB @>8373,R0
       0142 8373 
  0243 0144 0980         SRL  R0,8
  0244 0146 0220         AI   R0,HR1
       0148 8302 
  0245 014A C420         MOV  @C99GRB,*R0
       014C 013E'
  0246 014E 06C0         SWPB R0
  0247 0150 D800         MOVB R0,@>8373
       0152 8373 
  0248 0154 C03B         MOV  *R11+,R0          Get routine number
  0249 0156 C04B         MOV  R11,R1            Save return address
  0250 0158 06A0         BL   @C$PGRA           Restore GROM address
       015A 012E'
  0251 015C 0200         LI   R0,C$GPL1         Return address
       015E 0168'
  0252 0160 02E0         LWPI GPLWS
       0162 00F6'
  0253 0164 0460         B    @>006A
       0166 006A 
  0254 0168 02E0  C$GPL1 LWPI C99WS
       016A 8300 
  0255 016C 0451         B    *R1
  0256            
  0257            * C99 Jump instructions
  0258            *
  0259 016E 823E  C$EQ   C     *R14+,R8
  0260 0170 130F         JEQ   C$TRUE
  0261 0172 1011         JMP   C$FALS
  0262            
  0263 0174 823E  C$NE   C     *R14+,R8
  0264 0176 160C         JNE   C$TRUE
  0265 0178 100E         JMP   C$FALS
  0266            
  0267 017A 823E  C$LT   C     *R14+,R8
  0268 017C 1109         JLT   C$TRUE
  0269 017E 100B         JMP   C$FALS
  0270            
  0271 0180 823E  C$LE   C     *R14+,R8
  0272 0182 1509         JGT   C$FALS
  0273 0184 1005         JMP   C$TRUE
  0274            

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0008
  0275 0186 823E  C$GT   C     *R14+,R8
  0276 0188 1503         JGT   C$TRUE
  0277 018A 1005         JMP   C$FALS
  0278            
  0279 018C 823E  C$GE   C     *R14+,R8
  0280 018E 1103         JLT   C$FALS
  0281            
  0282 0190 0208  C$TRUE LI    R8,>FFFF
       0192 FFFF 
  0283 0194 045B         B     *R11
  0284            
  0285 0196 6208  C$FALS S     R8,R8
  0286 0198 045B         B     *R11
  0287            
  0288 019A 823E  C$ULT  C     *R14+,R8
  0289 019C 1AF9         JL    C$TRUE
  0290 019E 10FB         JMP   C$FALS
  0291            
  0292 01A0 823E  C$ULE  C     *R14+,R8
  0293 01A2 12F6         JLE   C$TRUE
  0294 01A4 10F8         JMP   C$FALS
  0295            
  0296 01A6 823E  C$UGT  C     *R14+,R8
  0297 01A8 1BF3         JH    C$TRUE
  0298 01AA 10F5         JMP   C$FALS
  0299            
  0300 01AC 823E  C$UGE  C     *R14+,R8
  0301 01AE 14F0         JHE   C$TRUE
  0302 01B0 10F2         JMP   C$FALS
  0303            

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0009
  0305            * C99 Shift instructions
  0306            *
  0307 01B2 C008  C$ASR  MOV   R8,R0
  0308 01B4 C23E         MOV   *R14+,R8
  0309 01B6 0808         SRA   R8,0
  0310 01B8 045B         B     *R11
  0311            
  0312 01BA C008  C$ASL  MOV   R8,R0
  0313 01BC C23E         MOV   *R14+,R8
  0314 01BE 0A08         SLA   R8,0
  0315 01C0 045B         B     *R11
  0316            
  0317            * C99 Divide and Module instructions
  0318            *
  0319 01C2 C1CB  C$DIV  MOV   R11,R7
  0320 01C4 06A0         BL    @DIVIDE
       01C6 01D6'
  0321 01C8 C200         MOV   R0,R8            Quotient
  0322 01CA 0457         B     *R7
  0323            
  0324 01CC C1CB  C$REM  MOV   R11,R7
  0325 01CE 06A0         BL    @DIVIDE
       01D0 01D6'
  0326 01D2 C201         MOV   R1,R8            Remainder
  0327 01D4 0457         B     *R7
  0328            
  0329            * R0,R1 / R2 --> R0 = Quotient, R1 = Remainder
  0330            *
  0331 01D6 04C0  DIVIDE CLR   R0               Most Significant word
  0332 01D8 C27E         MOV   *R14+,R9
  0333 01DA C049         MOV   R9,R1            Least Significant word
  0334 01DC 0741         ABS   R1
  0335 01DE C088         MOV   R8,R2            Divider
  0336 01E0 130A         JEQ   DIVID3           Divide by zero!
  0337 01E2 0742         ABS   R2
  0338 01E4 3C02         DIV   R2,R0
  0339 01E6 C208         MOV   R8,R8
  0340 01E8 1501         JGT   DIVID1
  0341 01EA 0500         NEG   R0
  0342 01EC C249  DIVID1 MOV   R9,R9
  0343 01EE 1502         JGT   DIVID2
  0344 01F0 0500         NEG   R0
  0345 01F2 0501         NEG   R1
  0346 01F4 045B  DIVID2 B     *R11
  0347            
  0348 01F6 04C1  DIVID3 CLR   R1                R0=R1=0 Divide by zero
  0349 01F8 045B         B     *R11
  0350            
  0351            * Indirect function call
  0352            * Called as: LI  R8,function address
  0353            *            MOV R8,@C$CALL
  0354            *            BL  C$IND
  0355            *
  0356 01FA 064E  C$CIND DECT  R14              Save program counter
  0357 01FC C78B         MOV   R11,*R14
  0358 01FE C1E0         MOV   @C$CALL,R7       Statement address
       0200 0204'
  0359 0202 0457         B     *R7              Execute Statement
  0360            

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0010
  0361 0204       C$CALL BSS   2
  0362            
  0363            * Negate
  0364            * 0000 --> FFFF
  0365            * xxxx --> 0000
  0366            *
  0367 0206 C208  C$LNEG MOV   R8,R8
  0368 0208 1302         JEQ   C$LNG1
  0369 020A 6208         S     R8,R8
  0370 020C 045B         B     *R11
  0371 020E 0608  C$LNG1 DEC   R8
  0372 0210 045B         B     *R11
  0373            
  0374            * Switch statement
  0375            * Called as:      B    @C$2
  0376            *            C$3  case statements
  0377            *            C$4  case statements
  0378            *            C$5  default statements
  0379            *                 B    @C$3 exit switch
  0380            *
  0381            *           C$2   BL   @C$SWCH
  0382            *                 DATA C$3,value
  0383            *                 DATA C$4,value
  0384            *                 DATA 0
  0385            *                 B    C$5 do default
  0386            *           C$1   Every break jumps here
  0387            *
  0388 0212 C03B  C$SWCH MOV   *R11+,R0         Statament adres
  0389 0214 1303         JEQ   C$SWC1           End of list
  0390 0216 823B         C     *R11+,R8         This Switch TRUE?
  0391 0218 16FC         JNE   C$SWCH           No!
  0392 021A 0450         B     *R0              Execute case Statement
  0393 021C 045B  C$SWC1 B     *R11             Do default statement
  0394            
  0395            * c = GETCHAR()
  0396            *
  0397            * Wait for a key to be pressed and returns the
  0398            * character value. The character is egoed to
  0399            * the screen. If the character is ENTER the
  0400            * screen spaces to the start of a new line and
  0401            * a value of 10 is returned. If the character is
  0402            * Ctrl-z, a value of -1 is returned.
  0403            *
  0404 021E 06A0  GETCHA BL   @RDCHR            Read keyboard
       0220 0358'
  0405 0222 C201         MOV  R1,R8             Return value
  0406 0224 0988         SRL  R8,8
  0407 0226 0241         ANDI R1,>7F00          c>=' '
       0228 7F00 
  0408 022A 0281         CI   R1,>2000
       022C 2000 
  0409 022E 1A03         JL   GETCH2            No!
  0410 0230 06A0         BL   @WRCHR            Yes, echo
       0232 03AE'
  0411 0234 045D         B    *R13
  0412            
  0413 0236 0281  GETCH2 CI   R1,>0D00          c=enter?
       0238 0D00 
  0414 023A 1607         JNE  GETCH5            No!

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0011
  0415 023C 0208         LI   R8,>000A          Yes return 10
       023E 000A 
  0416 0240 0201  GETCH3 LI   R1,>0A00
       0242 0A00 
  0417 0244 06A0         BL   @WRCHR            echo
       0246 03AE'
  0418 0248 045D  GETCH4 B    *R13
  0419            
  0420 024A 0281  GETCH5 CI   R1,>1A00          c=Ctrl-z
       024C 1A00 
  0421 024E 16FC         JNE  GETCH4            No!
  0422 0250 0708         SETO R8                Yes return -1
  0423 0252 10F6         JMP  GETCH3            Echo
  0424            
  0425            * c=GETS(buff)
  0426            *
  0427            * Read one line from the keyboard to a character
  0428            * array. The line is terminated with Enter, Cltr-z
  0429            * or the 80th character. The array is assumed to be
  0430            * 81 characters long and a null (0) character is
  0431            * appended to the end of the string. A value of buff
  0432            * is returned unless Ctrl-z is pressed. In that case
  0433            * a null is returned. Use of the backspace key (Fctn-s)
  0434            * for inline editing is supported.
  0435            
  0436 0254 C16E  GETS   MOV  @>2(R14),R5       Get &buff
       0256 0002 
  0437 0258 0204  XGETS  LI   R4,>0050          Max characters
       025A 0050 
  0438 025C C205         MOV  R5,R8             Return value
  0439 025E 06A0  GETS1  BL   @RDCHR            Read a character
       0260 0358'
  0440 0262 0281         CI   R1,>0D00          Is it Enter
       0264 0D00 
  0441 0266 1315         JEQ  GETS4             Yes
  0442 0268 0281         CI   R1,>9A00          Is it Ctrl-z
       026A 9A00 
  0443 026C 1602         JNE  GETS2             No
  0444 026E 04C8         CLR  R8                Return null
  0445 0270 1010         JMP  GETS4
  0446 0272 0281  GETS2  CI   R1,>0800          Is it BS
       0274 0800 
  0447 0276 1608         JNE  GETS3             No
  0448 0278 0284         CI   R4,>0050          First Character
       027A 0050 
  0449 027C 13F0         JEQ  GETS1             Yes
  0450 027E 0584         INC  R4                Loose character
  0451 0280 0605         DEC  R5
  0452 0282 06A0         BL   @WRCHR            Echo
       0284 03AE'
  0453 0286 10EB         JMP  GETS1             Again
  0454 0288 DD41  GETS3  MOVB R1,*R5+           Store character
  0455 028A 06A0         BL   @WRCHR            Echo
       028C 03AE'
  0456 028E 0604         DEC  R4                More characters
  0457 0290 16E6         JNE  GETS1             Yes
  0458 0292 0201  GETS4  LI   R1,>000A          Terminate string
       0294 000A 
  0459 0296 D541         MOVB R1,*R5

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0012
  0460 0298 06C1         SWPB R1                Echo LF
  0461 029A 06A0         BL   @WRCHR
       029C 03AE'
  0462 029E 045D         B    *R13
  0463            
  0464            
  0465            * c=PUTCHAR(c)
  0466            *
  0467            * Writes the character whose ascii value is c to the
  0468            * screen. If c==10 (eol) the screen spaces to the start
  0469            * of a new line. If c==8 (BS) the cursor is backspaced.
  0470            * if c==12 (FF) the screen is cleared and the cursor is
  0471            * homed. If c represents a non printing character, a \
  0472            * is echoed. The value of c is returned.
  0473            *
  0474 02A0 C06E  PUTCHA MOV  @>2(R14),R1       Get character
       02A2 0002 
  0475 02A4 C201  XPUTC  MOV  R1,R8             Return value
  0476 02A6 06C1         SWPB R1
  0477 02A8 06A0         BL   @WRCHR            Echo
       02AA 03AE'
  0478 02AC 045D         B    *R13
  0479            
  0480            * PUTS(string)
  0481            *
  0482            * Writes a string to the screen, stopping when
  0483            * it finds a null (0) character. The null
  0484            * character is not written. The cursor is not
  0485            * spaced to the start of a newline unless
  0486            * newline (\n) is encountered.
  0487            *
  0488 02AE C060  XPUTS  MOV  @S#DRCT,R1
       02B0 034A'
  0489 02B2 160E         JNE  XDPUTS
  0490 02B4 1005         JMP  PUTS1
  0491            
  0492 02B6 C16E  PUTS   MOV  @2(R14),R5        Get string address
       02B8 0002 
  0493 02BA C060         MOV  @S#DRCT,R1        Direct video
       02BC 034A'
  0494 02BE 1606         JNE  DPUTS
  0495 02C0 D075  PUTS1  MOVB *R5+,R1           Get character
  0496 02C2 1303         JEQ  PUTS2             End of string
  0497 02C4 06A0         BL   @WRCHR            Echo
       02C6 03AE'
  0498 02C8 10FB         JMP  PUTS1             Next
  0499 02CA 045D  PUTS2  B    *R13
  0500            
  0501 02CC C16E  DPUTS  MOV  @2(R14),R5        Get string address
       02CE 0002 
  0502 02D0 04E0  XDPUTS CLR  @S#DRCT
       02D2 034A'
  0503 02D4 0201         LI   R1,>4000          Set VDP location
       02D6 4000 
  0504 02D8 E060         SOC  @S$LOC,R1
       02DA 034C'
  0505 02DC 06C1         SWPB R1
  0506 02DE D801         MOVB R1,@VDPWA
       02E0 0000 

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0013
  0507 02E2 06C1         SWPB R1
  0508 02E4 D801         MOVB R1,@VDPWA
       02E6 02E0'
  0509 02E8 D075  DPUTS1 MOVB *R5+,R1           Write string
  0510 02EA 1305         JEQ  DPUTSX
  0511 02EC D801         MOVB R1,@VDPWD
       02EE 0000 
  0512 02F0 05A0         INC  @S$LOC
       02F2 034C'
  0513 02F4 10F9         JMP  DPUTS1
  0514 02F6 045D  DPUTSX B    *13
  0515            
  0516 02F8       S$BUFF BSS  80       Scroll buffer
  0517 0348 0000  S$CHAR DATA 0        Screen character
  0518 034A 0000  S#DRCT DATA 0        Direct video
  0519 034C 0000  S$LOC  DATA 0        Cursor location
  0520 034E 0028  S$WDTH DATA 40       Screen width
  0521 0350 0000  S$STRT DATA 0        Screen start
  0522 0352 03C0  S$SEND DATA 40*24    Screen end
  0523            *C$STRT DATA 0        Screen start
  0524            *C$SEND DATA 40*24    Screen end
  0525 0354 0000  ERRNO  DATA 0        Error number
  0526 0356 0000  CNULL  DATA 0        Constant byte/word NULL
  0527            
  0528            * RDCHR
  0529            *
  0530            * Read a character, display a cursor
  0531            * result in R1
  0532            *
  0533 0358 0207  RDCHR  LI   R7,>00C7          Cursor timer
       035A 00C7 
  0534 035C C020         MOV  @S$LOC,R0         Read character
       035E 034C'
  0535 0360 0420         BLWP @VSBR
       0362 0000 
  0536 0364 D801         MOVB R1,@S$CHAR        Save it
       0366 0348'
  0537 0368 0587  RDCHR1 INC  R7
  0538 036A 0420         BLWP @KSCAN            Scan key board
       036C 0000 
  0539 036E C0A0         MOV  @>837C,R2         New key pressed
       0370 837C 
  0540 0372 0242         ANDI R2,>2000
       0374 2000 
  0541 0376 1613         JNE  RDCHR5            Yes
  0542 0378 0287         CI   R7,>0064          Cursor swap
       037A 0064 
  0543 037C 1603         JNE  RDCHR2            No
  0544 037E D060         MOVB @S$CHAR,R1        Get screen character
       0380 0348'
  0545 0382 1006         JMP  RDCHR3            Write back
  0546 0384 0287  RDCHR2 CI   R7,>00C8          Display cursor?
       0386 00C8 
  0547 0388 1605         JNE  RDCHR4            No
  0548 038A 04C7         CLR  R7                Yes
  0549 038C 0201         LI   R1,>5F20          Cursor '_ '
       038E 5F20 
  0550 0390 0420  RDCHR3 BLWP @VSBW             Write cursor or character
       0392 0000 

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0014
  0551 0394 0300  RDCHR4 LIMI >0002
       0396 0002 
  0552 0398 0300         LIMI >0000
       039A 0000 
  0553 039C 10E5         JMP  RDCHR1
  0554 039E D060  RDCHR5 MOVB @S$CHAR,R1        Restore screen character
       03A0 0348'
  0555 03A2 0420         BLWP @VSBW
       03A4 0392'
  0556 03A6 04C1         CLR  R1
  0557 03A8 D060         MOVB @>8375,R1         Get key code
       03AA 8375 
  0558 03AC 045B         B    *R11
  0559            
  0560            
  0561            * WRCHR
  0562            *
  0563            * Write a character to the screen
  0564            * and take actions for BS, CR, LF and FF
  0565            *
  0566 03AE 0241  WRCHR  ANDI R1,>7F00
       03B0 7F00 
  0567 03B2 0281  WRCHBS CI   R1,>0800          BackSpace
       03B4 0800 
  0568 03B6 160C         JNE  WRCHLF            No
  0569 03B8 0201         LI   R1,>2020          '  '
       03BA 2020 
  0570 03BC C020         MOV  @S$LOC,R0         VDP location
       03BE 034C'
  0571 03C0 0420         BLWP @VSBW
       03C2 03A4'
  0572 03C4 8800         C    R0,@S$STRT        First location
       03C6 0350'
  0573 03C8 1202         JLE  WRCHEX            Yes
  0574 03CA 0620         DEC  @S$LOC            Previous location
       03CC 034C'
  0575 03CE 045B  WRCHEX B    *R11
  0576            
  0577 03D0 0281  WRCHLF CI   R1,>0A00          LineFeed
       03D2 0A00 
  0578 03D4 1627         JNE  WRCHCR            No
  0579 03D6 C1E0         MOV  @S$SEND,R7        Past end of screen
       03D8 0352'
  0580 03DA 61E0         S    @S$WDTH,R7
       03DC 034E'
  0581 03DE 81E0         C    @S$LOC,R7
       03E0 034C'
  0582 03E2 1404         JHE  SCROLL            Yes
  0583 03E4 A820         A    @S$WDTH,@S$LOC    Next line
       03E6 034E'
       03E8 034C'
  0584 03EA 101F         JMP  WRCCR1
  0585            
  0586 03EC C020  SCROLL MOV  @S$STRT,R0        Start of screen
       03EE 0350'
  0587 03F0 0201         LI   R1,S$BUFF
       03F2 02F8'
  0588 03F4 C0A0         MOV  @S$WDTH,R2        Screen width
       03F6 034E'

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0015
  0589 03F8 A002         A    R2,R0             Next line
  0590 03FA 0420  SCRLL1 BLWP @VMBR
       03FC 0000 
  0591 03FE 6002         S    R2,R0             Previous line
  0592 0400 0420         BLWP @VMBW
       0402 0000 
  0593 0404 A002         A    R2,R0             Calculate next line
  0594 0406 A002         A    R2,R0
  0595 0408 8800         C    R0,@S$SEND        Past end of screen
       040A 0352'
  0596 040C 1AF6         JL   SCRLL1            No
  0597 040E C042         MOV  R2,R1             Number of characters to clear
  0598 0410 0200         LI   R0,>2020          with spaces
       0412 2020 
  0599 0414 60A0         S    @S$SEND,R2        Calculate last line address
       0416 0352'
  0600 0418 0502         NEG  R2
  0601 041A C1CB         MOV  R11,R7            Save return address
  0602 041C 06A0         BL   @C$FILL           Clear line
       041E 0484'
  0603 0420 C2C7         MOV  R7,R11
  0604 0422 1003         JMP  WRCCR1
  0605            
  0606 0424 0281  WRCHCR CI   R1,>0D00          CariageReturn
       0426 0D00 
  0607 0428 160D         JNE  WRCHFF            No
  0608 042A 04C0  WRCCR1 CLR  R0                Calculate start address of lin
  0609 042C C060         MOV  @S$LOC,R1
       042E 034C'
  0610 0430 C0C1         MOV  R1,R3
  0611 0432 6060         S    @S$STRT,R1
       0434 0350'
  0612 0436 C0A0         MOV  @S$WDTH,R2
       0438 034E'
  0613 043A 3C02         DIV  R2,R0
  0614 043C 60C1         S    R1,R3
  0615 043E C803         MOV  R3,@S$LOC
       0440 034C'
  0616 0442 045B         B    *R11
  0617            
  0618 0444 0281  WRCHFF CI   R1,>0C00          FormFeed
       0446 0C00 
  0619 0448 160B         JNE  WRCHC             No
  0620 044A C0A0  C$CLS  MOV  @S$STRT,R2        Start on top
       044C 0350'
  0621 044E C802         MOV  R2,@S$LOC
       0450 034C'
  0622 0452 C060         MOV  @S$SEND,R1        Number of bytes on screen
       0454 0352'
  0623 0456 6042         S    R2,R1
  0624 0458 0200         LI   R0,>2020          Fill with spaces
       045A 2020 
  0625 045C 0460         B    @C$FILL           Clear screen and return
       045E 0484'
  0626            
  0627 0460 0281  WRCHC  CI   R1,>1F00          Character >=' '
       0462 1F00 
  0628 0464 1B02         JH   WRCC1             Yes
  0629 0466 0201         LI   R1,>5C20

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0016
       0468 5C20 
  0630 046A C020  WRCC1  MOV  @S$LOC,R0
       046C 034C'
  0631 046E 0420         BLWP @VSBW
       0470 03C2'
  0632 0472 C0A0         MOV  @S$SEND,R2        Reached end of screen
       0474 0352'
  0633 0476 0602         DEC  R2
  0634 0478 8080         C    R0,R2
  0635 047A 14B8         JHE  SCROLL            Yes
  0636 047C 0580         INC  R0                Next location
  0637 047E C800         MOV  R0,@S$LOC
       0480 034C'
  0638 0482 045B         B    *R11
  0639            
  0640            * C$FILL
  0641            *
  0642            * Fill screen locations, start addres in R2
  0643            * and count in R1, with the character in R0
  0644            *
  0645 0484 0262  C$FILL ORI  R2,>4000          Vdp address
       0486 4000 
  0646 0488 06C2         SWPB R2
  0647 048A D802         MOVB R2,@VDPWA
       048C 02E6'
  0648 048E 06C2         SWPB R2
  0649 0490 D802         MOVB R2,@VDPWA
       0492 048C'
  0650 0494 1000         NOP
  0651 0496 D800  C$FIL1 MOVB R0,@VDPWD         Write character
       0498 02EE'
  0652 049A 0601         DEC  R1                More to write
  0653 049C 16FC         JNE  C$FIL1            Yes
  0654 049E 045B         B    *R11
  0655            
  0656            * LOCATE(row,col)
  0657            *
  0658            * Places the cursor at the screen location specified
  0659            * by row and col. Subsequent console I/O will start
  0660            * at the new cursor location. Row and Column numbering
  0661            * starts with 1 and the validity is not checked.
  0662            *
  0663 04A0 C02E  LOCATE MOV  @>2(R14),R0     Get Col
       04A2 0002 
  0664 04A4 C06E         MOV  @>4(R14),R1     Get Row
       04A6 0004 
  0665 04A8 06A0  XLOCAT BL   @C$VADR         Calculate VDP address
       04AA 0502'
  0666 04AC C800         MOV  R0,@S$LOC       Save screen location
       04AE 034C'
  0667 04B0 045D         B    *R13
  0668            
  0669            * key=POLL(c)
  0670            *
  0671            * Scans the keyboard and returns the key value
  0672            * if one is pressed or 0. If c!=0 the program
  0673            * will pause while a key is down. If c!=0 and
  0674            * Fctn-4 is pressed (CLEAR) the program will
  0675            * branch to the c99 exit function.

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0017
  0676            *
  0677 04B2 C0EE  POLL   MOV  @>2(R14),R3       Get c
       04B4 0002 
  0678 04B6 0300  XPOLL  LIMI >0002
       04B8 0002 
  0679 04BA 0300         LIMI >0000
       04BC 0000 
  0680 04BE 0420  POLL1  BLWP @KSCAN            Read keyboard
       04C0 036C'
  0681 04C2 D220         MOVB @>8375,R8         Get key code
       04C4 8375 
  0682 04C6 0988         SRL  R8,8
  0683 04C8 0288         CI   R8,>00FF          Key pressed
       04CA 00FF 
  0684 04CC 1602         JNE  POLL3             Yes
  0685 04CE 04C8         CLR  R8                No
  0686 04D0 045D  POLL2  B    *R13
  0687 04D2 C0C3  POLL3  MOV  R3,R3             Wait?
  0688 04D4 13FD         JEQ  POLL2             No
  0689 04D6 0288         CI   R8,>0002          Fctn-4
       04D8 0002 
  0690 04DA 16F1         JNE  POLL1             No
  0691 04DC 0460         B    @CEXIT1           Yes
       04DE 00AE'
  0692            
  0693            * TSCRN(f,b)
  0694            *
  0695            * Changes the text mode screen color to f (foreground)
  0696            * and b (background). The basic color numbering convention
  0697            * is used.
  0698            *
  0699 04E0 C02E  TSCRN  MOV   @>2(R14),R0      Background color
       04E2 0002 
  0700 04E4 C06E         MOV   @>4(R14),R1      Foreground color
       04E6 0004 
  0701 04E8 0600  XTSRCN DEC   R0
  0702 04EA 0240         ANDI  R0,>000F
       04EC 000F 
  0703 04EE 0601         DEC   R1
  0704 04F0 0241         ANDI  R1,>000F
       04F2 000F 
  0705 04F4 0A41         SLA   R1,4
  0706 04F6 E001         SOC   R1,R0
  0707 04F8 0220         AI    R0,>0700         VDP register 7
       04FA 0700 
  0708 04FC 0420         BLWP  @VWTR
       04FE 0072'
  0709 0500 045D         B     *R13
  0710            
  0711            * C$VADR
  0712            *
  0713            * Calculate VDP screen address from Row (R1)
  0714            * and Column (R0)
  0715            *
  0716 0502 0600  C$VADR DEC   R0               Column-1
  0717 0504 0601         DEC   R1               Row-1
  0718 0506 3860         MPY   @S$WDTH,R1       Row * Screen Width
       0508 034E'
  0719 050A A002         A     R2,R0            + Column

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0018
  0720 050C A020         A     @S$STRT,R0       + Screen start address
       050E 0350'
  0721            *      A     @C$STRT,R0       + Screen start address
  0722 0510 045B         B     *R11
  0723            
  0724            * EXIT(c) or ABORT(c)
  0725            *
  0726            * Branches to the c99 exit function which closes
  0727            * any open files. The value of c may be between
  0728            * 0 and 7. if c==0 the normal exit message is
  0729            * displayed. if c==7 the program terminates
  0730            * immediately. Otherwise the vvalue of c is
  0731            * displayed in an error message. The exit(0)
  0732            * function is also executed when function main()
  0733            * terminates normally.
  0734            *
  0735            EXIT
  0736 0512 C02E  ABORT  MOV  @2(R14),R0        Get exit value
       0514 0002 
  0737 0516 1602         JNE  ABORT1            >0
  0738 0518 0460         B    @CEXIT1
       051A 00AE'
  0739 051C 0240  ABORT1 ANDI R0,>0007          Only exit codes 1-7
       051E 0007 
  0740 0520 0280         CI   R0,>0007          Is it 7, terminate immediatell
       0522 0007 
  0741 0524 1602         JNE  ABORT2            No
  0742 0526 0460         B    @CEXIT5           Terminate immediatelly
       0528 00DA'
  0743            
  0744 052A 0220  ABORT2 AI   R0,>0030          Make value 1-6
       052C 0030 
  0745 052E 06C0         SWPB R0
  0746 0530 D800         MOVB R0,@C99T3X
       0532 054B'
  0747 0534 0208         LI   R8,C99T3          puts(C99T3)
       0536 0542'
  0748 0538 068F         BL   R15
  0749 053A 069C         BL   *R12
  0750 053C 02B6'        DATA PUTS
  0751 053E 0460         B    @CEXIT2
       0540 00B6'
  0752            
  0753 0542   0A  C99T3  BYTE  10
  0754 0543   63         TEXT  'c99 err='
  0755 054B   58  C99T3X BYTE  'X'
  0756 054C 0000         DATA  >0000
  0757 054E 0000  C$HOOK DATA  >0000
  0758                   END

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0019
  D ABORT   0512    ' ABORT1  051C    ' ABORT2  052A    D C$ASL   01BA  
  D C$ASR   01B2    D C$CALL  0204    D C$CIND  01FA    D C$CLS   044A  
  D C$CTFL  011C    D C$DIV   01C2    D C$EQ    016E    ' C$FALS  0196  
  ' C$FIL1  0496    D C$FILL  0484    D C$GE    018C    ' C$GPL1  0168  
  D C$GPLL  0140    D C$GT    0186    D C$HOOK  054E    D C$LE    0180  
  D C$LNEG  0206    ' C$LNG1  020E    D C$LT    017A    D C$NE    0174  
  D C$PGRA  012E    D C$REM   01CC    D C$SGRA  011E    ' C$SWC1  021C  
  D C$SWCH  0212    ' C$TRUE  0190    D C$UGE   01AC    D C$UGT   01A6  
  D C$ULE   01A0    D C$ULT   019A    D C$VADR  0502    ' C99GRA  013C  
  ' C99GRB  013E    ' C99RT   00AC    D C99STK  0000    ' C99T1   0102  
  ' C99T2   010C    ' C99T3   0542    ' C99T3X  054B      C99WS   8300  
  ' CALL    0012      CALLZ   0008    ' CEXIT1  00AE    ' CEXIT2  00B6  
  ' CEXIT3  00BE    ' CEXIT4  00C6    ' CEXIT5  00DA    ' CEXIT6  00EC  
  D CNULL   0356    ' DIVID1  01EC    ' DIVID2  01F4    ' DIVID3  01F6  
  ' DIVIDE  01D6    D DPUTS   02CC    ' DPUTS1  02E8    ' DPUTSX  02F6  
  E DSRLNK  0000    D ERRNO   0354    D EXIT    0512    ' GETCH2  0236  
  ' GETCH3  0240    ' GETCH4  0248    ' GETCH5  024A    D GETCHA  021E  
  D GETS    0254    ' GETS1   025E    ' GETS2   0272    ' GETS3   0288  
  ' GETS4   0292    E GPLLNK  0000    E GPLWS   0162    E GRMRA   0126  
  E GRMRD   004A    E GRMWA   0136    E GRMWD   0000      HR0     8300  
    HR1     8302      HR10    8314      HR11    8316      HR12    8318  
    HR13    831A      HR14    831C      HR15    831E      HR2     8304  
    HR3     8306      HR4     8308      HR5     830A      HR6     830C  
    HR7     830E      HR8     8310      HR9     8312    E KSCAN   04C0  
  D LOCATE  04A0      LR0     8301      LR1     8303      LR10    8315  
    LR11    8317      LR12    8319      LR13    831B      LR14    831D  
    LR15    831F      LR2     8305      LR3     8307      LR4     8309  
    LR5     830B      LR6     830D      LR7     830F      LR8     8311  
    LR9     8313    E MAIN    00AA    D POLL    04B2    ' POLL1   04BE  
  ' POLL2   04D0    ' POLL3   04D2    ' PUSH    0002      PUSHZ   0010  
  ' PUSHZ$  000E    D PUTCHA  02A0    D PUTS    02B6    ' PUTS1   02C0  
  ' PUTS2   02CA      R0      0000      R1      0001      R10     000A  
    R11     000B      R12     000C      R13     000D      R14     000E  
    R15     000F      R2      0002      R3      0003      R4      0004  
    R5      0005      R6      0006      R7      0007      R8      0008  
    R9      0009    ' RDCHR   0358    ' RDCHR1  0368    ' RDCHR2  0384  
  ' RDCHR3  0390    ' RDCHR4  0394    ' RDCHR5  039E      RETRNZ  0004  
  ' RETURN  001A    D S#DRCT  034A    ' S$BUFF  02F8    ' S$CHAR  0348  
  D S$LOC   034C    D S$SEND  0352    D S$STRT  0350    D S$WDTH  034E  
  E SCAN    0000    ' SCRLL1  03FA    ' SCROLL  03EC    D START   001E  
  ' START1  0036    ' START2  0042    ' START3  005A    ' START4  00A2  
  D TSCRN   04E0    E VDPRD   0000    E VDPSTA  0000    E VDPWA   0492  
  E VDPWD   0498    E VMBR    03FC    E VMBW    0402    E VSBR    0362  
  E VSBW    0470    E VWTR    04FE    ' WRCC1   046A    ' WRCCR1  042A  
  ' WRCHBS  03B2    ' WRCHC   0460    ' WRCHCR  0424    ' WRCHEX  03CE  
  ' WRCHFF  0444    ' WRCHLF  03D0    ' WRCHR   03AE    D XDPUTS  02D0  
  D XGETS   0258    D XLOCAT  04A8    E XMLLNK  0000    D XPOLL   04B6  
  D XPUTC   02A4    D XPUTS   02AE    D XTSRCN  04E8  
  0000 ERRORS

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0020
  SEGMENT RORG     SIZE 01360 (>0550) BYTES
