
 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20210126                      PAGE 0001
  0002            
  0003                      IDT  'C99CSUP5'
  0004            
  0005            * Copyright 1988 Clint pulley
  0006            *
  0007            * This is the debuged version of the CSUP compiler routines
  0008            * wherin the locate() mistake is repaired.
  0009            *
  0010            * Original version:           Clint Pulley
  0011            *                             38 Townsend Avenue
  0012            *                             Burlington, Ontario
  0013            *                             Canada L7T 1Y6
  0014            *
  0015            * Debugged by:                Frederik G. Kaal
  0016            *                             Goudsbloem 68
  0017            *                             3984CP Odijk
  0018            *                             Netherlands
  0019            *
  0020            * V5 Added symbols ERRNO, CNULL from the now obsolete CGLOB.
  0021            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20210126                      PAGE 0002
  0023            
  0024                   REF  MAIN              User program
  0025            
  0026                   DEF  START             Start CSUP
  0027            
  0028                   DEF  TSCRN,POLL,S#KBM,KEYBRD,LOCATE
  0029                   DEF  S$TII
  0030                   DEF  S#PAGE,S#WDTH,S#LOC,S#DRCT
  0031                   DEF  C$CALL,C$HOOK,C$SWCH
  0032                   DEF  ABORT,EXIT,DPUTS
  0033                   DEF  PUTS,PUTCHA,GETS,GETCHA,GETCHR
  0034                   DEF  C$LNEG,C$CIND,C$REM
  0035                   DEF  C$DIV,C$ASL,C$ASR
  0036                   DEF  C$UGE,C$UGT
  0037                   DEF  C$ULE,C$ULT
  0038                   DEF  C$GE,C$GT,C$LE,C$LT,C$NE,C$EQ
  0039            *the C-globals
  0040                   DEF  ERRNO,CNULL
  0041            *the X-routines
  0042                   DEF  XTSCRN,XLOCAT,XPOLL,XPUTS,XDPUTS
  0043                   DEF  XPUTC,XGETS
  0044            
  0045                   DXOP SYSC,0
  0046            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20210126                      PAGE 0003
  0048            
  0049      F000  C99WS  EQU  >F000             C99 Workspace
  0050            
  0051      F000  HR0    EQU  C99WS+0
  0052      F001  LR0    EQU  C99WS+1
  0053      F002  HR1    EQU  C99WS+2
  0054      F003  LR1    EQU  C99WS+3
  0055      F004  HR2    EQU  C99WS+4
  0056      F005  LR2    EQU  C99WS+5
  0057      F006  HR3    EQU  C99WS+6
  0058      F007  LR3    EQU  C99WS+7
  0059      F008  HR4    EQU  C99WS+8
  0060      F009  LR4    EQU  C99WS+9
  0061      F00A  HR5    EQU  C99WS+10
  0062      F00B  LR5    EQU  C99WS+11
  0063      F00C  HR6    EQU  C99WS+12
  0064      F00D  LR6    EQU  C99WS+13
  0065      F00E  HR7    EQU  C99WS+14
  0066      F00F  LR7    EQU  C99WS+15
  0067      F010  HR8    EQU  C99WS+16
  0068      F011  LR8    EQU  C99WS+17
  0069      F012  HR9    EQU  C99WS+18
  0070      F013  LR9    EQU  C99WS+19
  0071      F014  HR10   EQU  C99WS+20
  0072      F015  LR10   EQU  C99WS+21
  0073      F016  HR11   EQU  C99WS+22
  0074      F017  LR11   EQU  C99WS+23
  0075      F018  HR12   EQU  C99WS+24
  0076      F019  LR12   EQU  C99WS+25
  0077      F01A  HR13   EQU  C99WS+26
  0078      F01B  LR13   EQU  C99WS+27
  0079      F01C  HR14   EQU  C99WS+28
  0080      F01D  LR14   EQU  C99WS+29
  0081      F01E  HR15   EQU  C99WS+30
  0082      F01F  LR15   EQU  C99WS+31
  0083            
  0084 0000 02E0  START  LWPI  C99WS
       0002 F000 
  0085 0004 0200         LI    R0,CEXIT0        ^C Exit
       0006 0528'
  0086 0008 C800         MOV   R0,@>00FE
       000A 00FE 
  0087            
  0088 000C 0200         LI    R0,>0001         Get number of pages
       000E 0001 
  0089 0010 C040         MOV   R0,R1            One page
  0090 0012 0202         LI    R2,>0007         Local page#
       0014 0007 
  0091 0016 0703         SETO  R3               Fast memory
  0092 0018 2C20         SYSC  @MEMORY
       001A 0174'
  0093 001C 0740         ABS   R0
  0094 001E 130C         JEQ   START1           Got it!
  0095            
  0096 0020 0200         LI    R0,>0001         Get number of pages
       0022 0001 
  0097 0024 C040         MOV   R0,R1            One page
  0098 0026 0202         LI    R2,>0007         Local page#
       0028 0007 

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20210126                      PAGE 0004
  0099 002A 04C3         CLR   R3               Slow memory
  0100 002C 2C20         SYSC  @MEMORY
       002E 0174'
  0101 0030 0740         ABS   R0
  0102 0032 1302         JEQ   START1           Got it!
  0103 0034 0420         BLWP  @>0000           No memory, Exit to dos
       0036 0000 
  0104            
  0105 0038 0200  START1 LI    R0,>0003         Map local pages
       003A 0003 
  0106 003C 0201         LI    R1,>0007         Local page#
       003E 0007 
  0107 0040 C081         MOV   R1,R2            Execution page
  0108 0042 2C20         SYSC  @MEMORY
       0044 0174'
  0109            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20210126                      PAGE 0005
  0111            
  0112            * Copy command line to userbuffer CMDBUF
  0113            *
  0114            * @>0128 --> *next bytecnt c c c c c *next c c c c c c 0
  0115            *                |                   ^   |             ^
  0116            *                `-------------------'   `-------------'
  0117            *
  0118 0046 C0A0         MOV   @>0128,R2        Startadres commandline
       0048 0128 
  0119 004A 1336         JEQ   START2           No commandline
  0120            
  0121 004C 0205         LI    R5,CMDBUF
       004E 0194'
  0122 0050 D1A2         MOVB  @>0002(R2),R6    Get total bytecount
       0052 0002 
  0123 0054 0986         SRL   R6,8
  0124 0056 0286         CI    R6,>0050         Does it fit
       0058 0050 
  0125 005A 142E         JHE   START2           No!
  0126 005C C206         MOV   R6,R8
  0127 005E 05C6         INCT  R6
  0128 0060 C0C2         MOV   R2,R3            First character in commandline
  0129 0062 0583         INC   R3
  0130 0064 1001         JMP   GETCM2
  0131 0066 C0C2  GETCM1 MOV   R2,R3
  0132 0068 05C3  GETCM2 INCT  R3
  0133 006A C102         MOV   R2,R4            End address this piece
  0134 006C 0224         AI    R4,>0008
       006E 0008 
  0135 0070 DD73  GETCM3 MOVB  *R3+,*R5+        Copy 6 bytes to bufer
  0136 0072 0606         DEC   R6               All done?
  0137 0074 1304         JEQ   ARGPNT           Yes!
  0138 0076 8103         C     R3,R4            Reached and address
  0139 0078 1AFB         JL    GETCM3           No!
  0140 007A C092         MOV   *R2,R2           Address next piece
  0141 007C 10F4         JMP   GETCM1           Copy it
  0142            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20210126                      PAGE 0006
  0144            
  0145            * Determine argument count ARGC and address of each
  0146            * argument ARGV[1..16], ARGV[0]='*'
  0147            *
  0148 007E 0209  ARGPNT LI    R9,CMDBUF        Commandline buffer
       0080 0194'
  0149 0082 020A         LI    R10,ARGV1        Address pointer to first argum
       0084 01EA'
  0150 0086 020C         LI    R12,NARGC        Maximum number of arguments
       0088 0010 
  0151 008A 1003         JMP   ARGPT2
  0152 008C 0589  ARGPT1 INC   R9
  0153 008E 0608         DEC   R8               All done?
  0154 0090 1310         JEQ   ARGPT4           Yes
  0155 0092 9819  ARGPT2 CB    *R9,@SPACE
       0094 0190'
  0156 0096 12FA         JLE   ARGPT1
  0157 0098 CE89         MOV   R9,*R10+         Store argument adres in ARGC[]
  0158 009A 05A0         INC   @ARGC
       009C 01E6'
  0159 009E 0589  ARGPT3 INC   R9
  0160 00A0 0608         DEC   R8               All done
  0161 00A2 1307         JEQ   ARGPT4           Yes
  0162 00A4 9819         CB    *R9,@SPACE       End of argument?
       00A6 0190'
  0163 00A8 1BFA         JH    ARGPT3           No
  0164 00AA D660         MOVB  @NULL,*R9        Close argument
       00AC 018F'
  0165 00AE 060C         DEC   R12              Can we store more arguments?
  0166 00B0 16ED         JNE   ARGPT1           Yes
  0167 00B2 0589  ARGPT4 INC   R9
  0168 00B4 D660         MOVB  @NULL,*R9
       00B6 018F'
  0169            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20210126                      PAGE 0007
  0171            
  0172            * Plaats addressen van ARGC en ARGV op de stack
  0173            *
  0174            *
  0175            *
  0176 00B8 0200  START2 LI    R0,CEXIT         Address EXIT routine
       00BA 0118'
  0177 00BC 0201         LI    R1,ARGV0         Address ARGV[0]
       00BE 01E8'
  0178 00C0 020E         LI    R14,>FFF6        Start of stack
       00C2 FFF6 
  0179 00C4 C7A0         MOV   @ARGC,*R14       Push ARGV
       00C6 01E6'
  0180 00C8 064E         DECT  R14
  0181 00CA C781         MOV   R1,*R14          Push ARGC[0]
  0182 00CC 064E         DECT  R14
  0183 00CE C780         MOV   R0,*R14          Push return address CEXIT
  0184 00D0 02A0         STWP  R0
  0185 00D2 C280         MOV   R0,R10
  0186 00D4 022A         AI    R10,>0011        Lsb R8
       00D6 0011 
  0187 00D8 0220         AI    R0,>001E         Msb R15 is PUSH routine
       00DA 001E 
  0188 00DC C300         MOV   R0,R12
  0189 00DE 022C         AI    R12,PUSHZ        Size PUSH routine is start add
       00E0 0006 
  0190 00E2 C34C         MOV   R12,R13          Start address CALL routine
  0191 00E4 022D         AI    R13,CALLZ        Size CALL routine is start add
       00E6 0008 
  0192 00E8 0201         LI    R1,PUSH
       00EA 0162'
  0193 00EC 0202         LI    R2,PUSHZ+CALLZ+RETRNZ
       00EE 0012 
  0194 00F0 CC31  START3 MOV   *R1+,*R0+        Move PUSH, CALL and RETURN to 
  0195 00F2 0642         DECT  R2
  0196 00F4 16FD         JNE   START3
  0197 00F6 0200         LI    R0,>0001         Get video mode
       00F8 0001 
  0198 00FA 2C20         SYSC  @VIDEO
       00FC 03C6'
  0199 00FE C801  START4 MOV   R1,@S#WDTH       Save screen width
       0100 03CC'
  0200 0102 C802         MOV   R2,@S#SHGT       Save screen height
       0104 03CE'
  0201 0106 3881         MPY   R1,R2
  0202 0108 C803         MOV   R3,@S#SEND
       010A 03D2'
  0203 010C 0201         LI    R1,>0A00         LF
       010E 0A00 
  0204 0110 06A0         BL    @WRCHR1
       0112 043A'
  0205 0114 0460         B     @MAIN            Call user program
       0116 0000 
  0206            
  0207 0118 04E0  CEXIT  CLR   @C$HOOK+2
       011A 0556'
  0208 011C 0208  CEXIT2 LI    R8,C99CT1        c99 exit
       011E 0176'
  0209 0120 068F         BL    R15

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20210126                      PAGE 0008
  0210 0122 069C         BL    *R12
  0211 0124 037A'        DATA  PUTS
  0212            
  0213 0126 C020  CEXIT1 MOV   @C$HOOK,R0
       0128 0554'
  0214 012A 1301         JEQ   CEXT11
  0215 012C 0690         BL    *R0              Call HOOK (closing files)
  0216            
  0217 012E 0760  CEXT11 ABS   @C$HOOK+2
       0130 0556'
  0218 0132 1611         JNE   CEXT13
  0219 0134 0208         LI    R8,C99CT2        - Rerun? (Y/N)
       0136 0180'
  0220 0138 068F         BL    R15
  0221 013A 069C         BL    *R12
  0222 013C 037A'        DATA  PUTS
  0223 013E 0200  CEXT12 LI    R0,>2000
       0140 2000 
  0224 0142 06A0         BL    @S$TII           Read keyboard
       0144 03DE'
  0225 0146 0241         ANDI  R1,>5F00         Convert to UPC
       0148 5F00 
  0226 014A 0281         CI    R1,>5900         Y?
       014C 5900 
  0227 014E 13B4         JEQ   START2           Rerun
  0228 0150 0281         CI    R1,>4E00         N?
       0152 4E00 
  0229 0154 16F4         JNE   CEXT12           No, read again
  0230 0156 0201  CEXT13 LI    R1,>0A00         LF
       0158 0A00 
  0231 015A 06A0         BL    @WRCHR1
       015C 043A'
  0232 015E 0420         BLWP  @>0000           Return to MDOS
       0160 0000 
  0233            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20210126                      PAGE 0009
  0235            
  0236            * PUSH
  0237            *
  0238            * Pushes contents R8 on stack
  0239            * Called as: BL R15
  0240            *
  0241 0162 064E  PUSH   DECT  R14
  0242 0164 C788         MOV   R8,*R14
  0243 0166 045B         B     *R11
  0244      0006  PUSHZ  EQU   $-PUSH
  0245            
  0246            * CALL
  0247            * Calls a C written function
  0248            * Called as: BL   *R12
  0249            *            DATA function
  0250            *
  0251 0168 C1FB  CALL   MOV   *R11+,R7
  0252 016A 064E         DECT  R14
  0253 016C C78B         MOV   R11,*R14
  0254 016E 0457         B     *R7
  0255      0008  CALLZ  EQU   $-CALL
  0256            
  0257            * RETURN
  0258            * Returns to calling function
  0259            * Called as: BL *R13
  0260            *
  0261 0170 C1FE  RETURN MOV   *R14+,R7
  0262 0172 0457         B     *R7
  0263      0004  RETRNZ EQU   $-RETURN
  0264            
  0265 0174 0007  MEMORY DATA  >0007
  0266            
  0267 0176   0A  C99CT1 BYTE 10
  0268 0177   63         TEXT 'c99 exit'
  0269 017F   00         BYTE 0
  0270 0180   2D  C99CT2 TEXT '-Rerun? (Y/N) '
  0271 018E   00  CNULL  BYTE 0                 Constant byte/word NULL
  0272 018F   00  NULL   BYTE 0
  0273 0190   20  SPACE  BYTE ' '
  0274 0191   7E  TILDE  BYTE '~'
  0275            
  0276 0192   2A  CMDBU0 TEXT '*'
  0277 0193   00         BYTE 0
  0278 0194       CMDBUF BSS  80                Commandline buffer
  0279      0010  NARGC  EQU  16                Max. number of arguments
  0280                   EVEN
  0281            
  0282 01E4 0000  ERRNO  DATA 0                 Error number
  0283 01E6 0001  ARGC   DATA 1                 Aantal argumenten
  0284 01E8 0192' ARGV0  DATA CMDBU0            Argumenten lijst ARGC[0]='*'
  0285 01EA 018F' ARGV1  DATA NULL,NULL         Argumenten lijst ARGC[1..16]
       01EC 018F'
  0286 01EE 018F'        DATA NULL,NULL,NULL,NULL,NULL,NULL,NULL
       01F0 018F'
       01F2 018F'
       01F4 018F'
       01F6 018F'
       01F8 018F'
       01FA 018F'

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20210126                      PAGE 0010
  0287 01FC 018F'        DATA NULL,NULL,NULL,NULL,NULL,NULL,NULL
       01FE 018F'
       0200 018F'
       0202 018F'
       0204 018F'
       0206 018F'
       0208 018F'

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20210126                      PAGE 0011
  0289            
  0290 020A 823E  C$EQ   C     *R14+,R8
  0291 020C 130F         JEQ   C$TRUE
  0292 020E 1011         JMP   C$FALS
  0293            
  0294 0210 823E  C$NE   C     *R14+,R8
  0295 0212 160C         JNE   C$TRUE
  0296 0214 100E         JMP   C$FALS
  0297            
  0298 0216 823E  C$LT   C     *R14+,R8
  0299 0218 1109         JLT   C$TRUE
  0300 021A 100B         JMP   C$FALS
  0301            
  0302 021C 823E  C$LE   C     *R14+,R8
  0303 021E 1509         JGT   C$FALS
  0304 0220 1005         JMP   C$TRUE
  0305            
  0306 0222 823E  C$GT   C     *R14+,R8
  0307 0224 1503         JGT   C$TRUE
  0308 0226 1005         JMP   C$FALS
  0309            
  0310 0228 823E  C$GE   C     *R14+,R8
  0311 022A 1103         JLT   C$FALS
  0312            
  0313 022C 0208  C$TRUE LI    R8,>FFFF
       022E FFFF 
  0314 0230 045B         B     *R11
  0315            
  0316 0232 6208  C$FALS S     R8,R8
  0317 0234 045B         B     *R11
  0318            
  0319 0236 823E  C$ULT  C     *R14+,R8
  0320 0238 1AF9         JL    C$TRUE
  0321 023A 10FB         JMP   C$FALS
  0322            
  0323 023C 823E  C$ULE  C     *R14+,R8
  0324 023E 12F6         JLE   C$TRUE
  0325 0240 10F8         JMP   C$FALS
  0326            
  0327 0242 823E  C$UGT  C     *R14+,R8
  0328 0244 1BF3         JH    C$TRUE
  0329 0246 10F5         JMP   C$FALS
  0330            
  0331 0248 823E  C$UGE  C     *R14+,R8
  0332 024A 14F0         JHE   C$TRUE
  0333 024C 10F2         JMP   C$FALS
  0334            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20210126                      PAGE 0012
  0336            
  0337 024E C008  C$ASR  MOV   R8,R0
  0338 0250 C23E         MOV   *R14+,R8
  0339 0252 0808         SRA   R8,0
  0340 0254 045B         B     *R11
  0341            
  0342 0256 C008  C$ASL  MOV   R8,R0
  0343 0258 C23E         MOV   *R14+,R8
  0344 025A 0A08         SLA   R8,0
  0345 025C 045B         B     *R11
  0346            
  0347 025E C1CB  C$DIV  MOV   R11,R7
  0348 0260 06A0         BL    @DIVIDE
       0262 0272'
  0349 0264 C200         MOV   R0,R8            Quotient
  0350 0266 0457         B     *R7
  0351            
  0352 0268 C1CB  C$REM  MOV   R11,R7
  0353 026A 06A0         BL    @DIVIDE
       026C 0272'
  0354 026E C201         MOV   R1,R8            Remainder
  0355 0270 0457         B     *R7
  0356            
  0357            * R0,R1 / R2 --> R0 = Quotient, R1 = Remainder
  0358            *
  0359 0272 04C0  DIVIDE CLR   R0               Most Significant word
  0360 0274 C27E         MOV   *R14+,R9
  0361 0276 C049         MOV   R9,R1            Least Significant word
  0362 0278 0741         ABS   R1
  0363 027A C088         MOV   R8,R2            Divider
  0364 027C 130A         JEQ   DIVID3           Divide by zero!
  0365 027E 0742         ABS   R2
  0366 0280 3C02         DIV   R2,R0
  0367 0282 C208         MOV   R8,R8
  0368 0284 1501         JGT   DIVID1
  0369 0286 0500         NEG   R0
  0370 0288 C249  DIVID1 MOV   R9,R9
  0371 028A 1502         JGT   DIVID2
  0372 028C 0500         NEG   R0
  0373 028E 0501         NEG   R1
  0374 0290 045B  DIVID2 B     *R11
  0375            
  0376 0292 04C0  DIVID3 CLR   R0               Divide by zero
  0377 0294 04C1         CLR   R1
  0378 0296 045B         B     *R11
  0379            
  0380            * 0000 --> FFFF
  0381            * xxxx --> 0000
  0382            *
  0383 0298 C208  C$LNEG MOV   R8,R8
  0384 029A 1302         JEQ   C$LNG1
  0385 029C 6208         S     R8,R8
  0386 029E 045B         B     *R11
  0387 02A0 0608  C$LNG1 DEC   R8
  0388 02A2 045B         B     *R11
  0389            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20210126                      PAGE 0013
  0391            
  0392            * Switch statement
  0393            * Called as:      B    @C$2
  0394            *            C$3  case statements
  0395            *            C$4  case statements
  0396            *            C$5  default statements
  0397            *                 B    @C$3 exit switch
  0398            *
  0399            *           C$2   BL   @C$SWCH
  0400            *                 DATA C$3,value
  0401            *                 DATA C$4,value
  0402            *                 DATA 0
  0403            *                 B    C$5 do default
  0404            *           C$1   Every break jumps here
  0405            *
  0406 02A4 C03B  C$SWCH MOV   *R11+,R0         Statament adres
  0407 02A6 1303         JEQ   C$SWC1           End of list
  0408 02A8 823B         C     *R11+,R8         This Switch TRUE?
  0409 02AA 16FC         JNE   C$SWCH           No!
  0410 02AC 0450         B     *R0              Execute case Statement
  0411 02AE 045B  C$SWC1 B     *R11             Do default statement
  0412            
  0413            * Indirect function call
  0414            * Called as: LI  R8,function address
  0415            *            MOV R8,@C$CALL
  0416            *            BL  C$IND
  0417            *
  0418 02B0 064E  C$CIND DECT  R14              Save program counter
  0419 02B2 C78B         MOV   R11,*R14
  0420 02B4 C1E0         MOV   @C$CALL,R7       Statement address
       02B6 02BA'
  0421 02B8 0457         B     *R7              Execute Statement
  0422            
  0423 02BA       C$CALL BSS   2
  0424            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20210126                      PAGE 0014
  0426            
  0427            * c=GETCHAR(), c=GETCHR(chr)
  0428            * GETCHAR displays a space at cursor location
  0429            * GETCHR  displays chr at cursor location
  0430            * Wait for a key to be pressed and returns the
  0431            * character value. The character is egoed to
  0432            * the screen. If the character is Enter the
  0433            * screen spaces to the start of a new line and
  0434            * a value of 10 is returned. If the character is
  0435            * Ctrl-z a value of -1 is returned
  0436            *
  0437 02BC C02E  GETCHR MOV   @2(R14),0
       02BE 0002 
  0438 02C0 06C0         SWPB  0
  0439 02C2 1002         JMP   GETCH
  0440 02C4 06A0  GETCHA BL    @SBRV            Read character from cursor loc
       02C6 02FC'
  0441 02C8 06A0  GETCH  BL    @S$TII           Before reading character
       02CA 03DE'
  0442 02CC C201         MOV   R1,R8            Return character
  0443 02CE 0988         SRL   R8,8
  0444 02D0 0281         CI    R1,>2000         Is it ' '..'~'
       02D2 2000 
  0445 02D4 1A06         JL    GETCH3           No, lower
  0446 02D6 0281         CI    R1,>7F00
       02D8 7F00 
  0447 02DA 1403         JHE   GETCH3           No, higher
  0448 02DC 06A0  GETCH1 BL    @WRCHR1          Echo character
       02DE 043A'
  0449 02E0 045D  GETCH2 B     *R13
  0450            
  0451 02E2 0281  GETCH3 CI    R1,>0D00         Is it Enter
       02E4 0D00 
  0452 02E6 1605         JNE   GETCH5           No
  0453 02E8 0208         LI    R8,>000A         Translate to LF
       02EA 000A 
  0454 02EC 0201  GETCH4 LI    R1,>0A00
       02EE 0A00 
  0455 02F0 10F5         JMP   GETCH1           Echo LF character
  0456 02F2 0281  GETCH5 CI    R1,>1A00         Is it Ctrl-z
       02F4 1A00 
  0457 02F6 16F4         JNE   GETCH2           No, but don't echo
  0458 02F8 0708         SETO  R8               Return -1
  0459 02FA 10F8         JMP   GETCH4           Echo LF character
  0460            
  0461            * SBRV - Single byte read video
  0462            *
  0463            * Read character at cursor location
  0464            * row,col-->R0
  0465            *
  0466 02FC 0200  SBRV   LI    R0,3             Get cursor location
       02FE 0003 
  0467 0300 2C20         SYSC  @VIDEO
       0302 03C6'
  0468 0304 C081         MOV   R1,R2
  0469 0306 C040         MOV   R0,R1
  0470 0308 0200         LI    R0,>0B           Get character
       030A 000B 
  0471 030C 2C20         SYSC  @VIDEO

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20210126                      PAGE 0015
       030E 03C6'
  0472 0310 06C0         SWPB  R0
  0473 0312 045B         RT
  0474            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20210126                      PAGE 0016
  0476            
  0477            * c=GETS(buff)
  0478            *
  0479            * Read one line from the keyboard to a character
  0480            * array. The line is terminated with Enter, Ctrl-z
  0481            * or the 80th character. The array is assumed to be
  0482            * 81 characters long and a null (0) character is
  0483            * appended to the end of the string. A vulue of buff
  0484            * is returned unless Ctrl-z is pressed. In that case
  0485            * a null is returned. Use of the backspace key (Fctn-s)
  0486            * for inline editing is supported.
  0487            *
  0488 0314 C16E  GETS   MOV   @>0002(R14),R5   Get character array address
       0316 0002 
  0489 0318 0204  XGETS  LI    R4,>0050         Maximum 80 characters
       031A 0050 
  0490 031C C205         MOV   R5,R8            Return value
  0491 031E 0200  GETS1  LI    R0,>2000         Read a character
       0320 2000 
  0492 0322 06A0         BL    @S$TII
       0324 03DE'
  0493 0326 0281         CI    R1,>0D00         Is it Enter
       0328 0D00 
  0494 032A 1315         JEQ   GETS4            Yes
  0495 032C 0281         CI    R1,>1A00         Is it Ctrl-z
       032E 1A00 
  0496 0330 1602         JNE   GETS2            No
  0497 0332 04C8         CLR   R8               Return 0
  0498 0334 1010         JMP   GETS4
  0499 0336 0281  GETS2  CI    R1,>8800         Is it Fctn-s
       0338 8800 
  0500 033A 1608         JNE   GETS3            No
  0501 033C 0284         CI    R4,>0050         Max characters entered
       033E 0050 
  0502 0340 13EE         JEQ   GETS1            Yes
  0503 0342 0584         INC   R4               Backspace one character
  0504 0344 0605         DEC   R5
  0505 0346 06A0         BL    @WRCHR1          Echo
       0348 043A'
  0506 034A 10E9         JMP   GETS1            Read next
  0507 034C DD41  GETS3  MOVB  R1,*R5+          Move character into buffer
  0508 034E 06A0         BL    @WRCHR1          Echo character
       0350 043A'
  0509 0352 0604         DEC   R4
  0510 0354 16E4         JNE   GETS1            Read next
  0511 0356 0201  GETS4  LI    R1,>000A         Close string
       0358 000A 
  0512 035A D541         MOVB  R1,*R5
  0513 035C 06C1         SWPB  R1               Print LF
  0514 035E 06A0         BL    @WRCHR1
       0360 043A'
  0515 0362 045D         B     *R13
  0516            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20210126                      PAGE 0017
  0518            
  0519            * c=PUTCHAR(c)
  0520            *
  0521            * Writes the character whose ascii value is c to the
  0522            * screen. If c==10 (eol) the screen spaces to the start
  0523            * of a new line. If c==8 (BS) the cursor is backspaced.
  0524            * If c==12 (FF) the screen is cleared and the cursor is
  0525            * homed. If c represents a non printing character, a \
  0526            * is echoed. The value of c is returned.
  0527            *
  0528 0364 C06E  PUTCHA MOV   @>0002(R14),R1   Get return character
       0366 0002 
  0529 0368 C201  XPUTC  MOV   R1,R8            Print it
  0530 036A 06C1         SWPB  R1
  0531 036C 06A0         BL    @WRCHR1
       036E 043A'
  0532 0370 045D         B     *R13
  0533            
  0534            * PUTS(string)
  0535            *
  0536            * Writes a string to the screen, stopping when
  0537            * it finds a null (0) character. The null
  0538            * character is not written. The cursor is not
  0539            * spaced to the start of a newline unless
  0540            * newline (\n) is encountered.
  0541            *
  0542 0372 C060  XPUTS  MOV   @S#DRCT,R1       Direct video
       0374 03C8'
  0543 0376 160E         JNE   XDPUTS
  0544 0378 1005         JMP   PUTS1
  0545            
  0546 037A C060  PUTS   MOV   @S#DRCT,R1       Direct video
       037C 03C8'
  0547 037E 1608         JNE   DPUTS            Yes
  0548 0380 C16E         MOV   @>0002(R14),R5   Get string address
       0382 0002 
  0549 0384 D075  PUTS1  MOVB  *R5+,R1          Get character
  0550 0386 1303         JEQ   PUTS2            Its a 0
  0551 0388 06A0         BL    @WRCHR1          Print character
       038A 043A'
  0552 038C 10FB         JMP   PUTS1            Get next one
  0553 038E 045D  PUTS2  B     *R13
  0554            
  0555            * DPUTS - Direct to video ram
  0556            
  0557      F102  VDPWA  EQU   >F102
  0558      F100  VDPWD  EQU   >F100
  0559            
  0560 0390 C16E  DPUTS  MOV   @>0002(R14),R5   Get string address
       0392 0002 
  0561 0394 04E0  XDPUTS CLR   @S#DRCT
       0396 03C8'
  0562 0398 0201         LI    R1,>4000         Set VDP location
       039A 4000 
  0563 039C E060         SOC   @S#LOC,R1
       039E 03CA'
  0564 03A0 06C1         SWPB  R1
  0565 03A2 0300         LIMI  0
       03A4 0000 

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20210126                      PAGE 0018
  0566 03A6 D801         MOVB  R1,@VDPWA
       03A8 F102 
  0567 03AA 06C1         SWPB  R1
  0568 03AC D801         MOVB  R1,@VDPWA
       03AE F102 
  0569 03B0 D075  DPUTS1 MOVB  *R5+,R1          Write string
  0570 03B2 1305         JEQ   DPUTSX
  0571 03B4 D801         MOVB  R1,@VDPWD
       03B6 F100 
  0572 03B8 05A0         INC   @S#LOC
       03BA 03CA'
  0573 03BC 10F9         JMP   DPUTS1
  0574 03BE 0300  DPUTSX LIMI  1
       03C0 0001 
  0575 03C2 045D         B     *R13
  0576            
  0577 03C4 0005  KEYBRD DATA  >0005
  0578 03C6 0006  VIDEO  DATA  >0006
  0579            
  0580 03C8 0000  S#DRCT DATA  0                Direct video
  0581 03CA 0000  S#LOC  DATA  0                Cursor loc
  0582 03CC 0050  S#WDTH DATA  80               Screen width
  0583 03CE 0018  S#SHGT DATA  24               Screen height
  0584 03D0 0000  S#STRT DATA  0                Screen start
  0585 03D2 0780  S#SEND DATA  80*24            Screen end
  0586 03D4 0000  S#PAGE DATA  >0000
  0587            
  0588 03D6 FF00  NOKEY  DATA  >FF00            Nokey code
  0589 03D8 5F08  CURBS  DATA  >5F08            Cursor & Backspace
  0590 03DA 2008  CHRBS  DATA  >2008            Character & Backspace
  0591            
  0592            * S$TII
  0593            *
  0594            * This routine scans the keyboard and returns the
  0595            * entered character. It shows a blinking cursor
  0596            * on the screen on the active row, column position
  0597            *
  0598 03DC 0004  S#KBM  DATA  4                Default Pascal mode
  0599            
  0600 03DE 04C1  S$TII  CLR   R1
  0601 03E0 C18B         MOV   R11,R6           Save return address
  0602 03E2 D800         MOVB  R0,@CHRBS        Save character
       03E4 03DA'
  0603 03E6 1007         JMP   S$TII3           Print cursor
  0604 03E8 0207  S$TII1 LI    R7,>0258         Delay timer
       03EA 0258 
  0605 03EC 0607  S$TII2 DEC   R7               End of delay
  0606 03EE 160D         JNE   S$TII6           No, scan keyboard
  0607 03F0 8803         C     R3,@CURBS        Yes exchange cursor and charac
       03F2 03D8'
  0608 03F4 1303         JEQ   S$TII4
  0609 03F6 C0E0  S$TII3 MOV   @CURBS,R3        Display Cursor
       03F8 03D8'
  0610 03FA 1002         JMP   S$TII5
  0611 03FC C0E0  S$TII4 MOV   @CHRBS,R3        Display Character
       03FE 03DA'
  0612 0400 0202  S$TII5 LI    R2,>0002         Two bytes to print
       0402 0002 
  0613 0404 06A0         BL    @WRCHR3

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20210126                      PAGE 0019
       0406 042C'
  0614 0408 10EF         JMP   S$TII1           Restart delay
  0615 040A C020  S$TII6 MOV   @S#KBM,R0        Scan keyboard
       040C 03DC'
  0616 040E 2C20         SYSC  @KEYBRD
       0410 03C4'
  0617 0412 16EC         JNE   S$TII2           No key pressed
  0618 0414 9801         CB    R1,@NOKEY        Valid character code
       0416 03D6'
  0619 0418 13E9         JEQ   S$TII2           No
  0620 041A C241         MOV   R1,R9            Save character code
  0621 041C 0202         LI    R2,>0002         Restore character
       041E 0002 
  0622 0420 C0E0         MOV   @CHRBS,R3
       0422 03DA'
  0623 0424 06A0         BL    @WRCHR3
       0426 042C'
  0624 0428 C049         MOV   R9,R1
  0625 042A 0456         B     *R6              Return
  0626            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20210126                      PAGE 0020
  0628            
  0629            * Write Character R3
  0630            *
  0631            * Writes the character(s) in R3 to the screen
  0632            * If R2=1 the MSByte of R3 is written
  0633            * If R2=2 both the MSByte and the LSByte of R3
  0634            * is writen
  0635            *
  0636 042C 0200  WRCHR3 LI    R0,>0027
       042E 0027 
  0637 0430 0201         LI    R1,HR3
       0432 F006 
  0638 0434 2C20         SYSC  @VIDEO
       0436 03C6'
  0639 0438 045B         B     *R11
  0640            
  0641            
  0642            * Write Character R1
  0643            *
  0644            * Writes the MSByte of R1 on the screen. If it
  0645            * is a unprintable character a \ is printed.
  0646            *
  0647 043A C1CB  WRCHR1 MOV   R11,R7           Save return address
  0648 043C 0241         ANDI  R1,>7F00         Strip MSBit
       043E 7F00 
  0649 0440 C0C1         MOV   R1,R3
  0650 0442 0281         CI    R1,>0800         Is it a BS
       0444 0800 
  0651 0446 1315         JEQ   WRCH12           Yes
  0652 0448 0281         CI    R1,>0D00         Is it a CR
       044A 0D00 
  0653 044C 1312         JEQ   WRCH12           Yes
  0654 044E 0281         CI    R1,>0C00         Is it a FF
       0450 0C00 
  0655 0452 130F         JEQ   WRCH12           Yes
  0656 0454 0281         CI    R1,>0A00         Is it a LF
       0456 0A00 
  0657 0458 1607         JNE   WRCH11           No
  0658 045A 0202         LI    R2,>0002         Two bytes to write
       045C 0002 
  0659 045E 0203         LI    R3,>0D0A         CRLF
       0460 0D0A 
  0660 0462 06A0         BL    @WRCHR3          Write characters
       0464 042C'
  0661 0466 0457         B     *R7              Return
  0662            
  0663 0468 0281  WRCH11 CI    R1,>1F00         Is it ' '..'~'
       046A 1F00 
  0664 046C 1B02         JH    WRCH12           Yes
  0665 046E 0203         LI    R3,>5C20         No, print '\'
       0470 5C20 
  0666 0472 0202  WRCH12 LI    R2,>0001         One byte to write
       0474 0001 
  0667 0476 06A0         BL    @WRCHR3          Write character
       0478 042C'
  0668 047A 0457         B     *R7              return
  0669            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20210126                      PAGE 0021
  0671            
  0672            * LOCATE(row,col)
  0673            *
  0674            * Places the cursor at the screen location specified
  0675            * by row and col. Subsequent console I/O will start
  0676            * at the new cursor location. Row and Column numbering
  0677            * starts witch 1 and the validity is not checked.
  0678            *
  0679 047C C02E  LOCATE MOV   @>0002(R14),R0
       047E 0002 
  0680 0480 C06E         MOV   @>0004(R14),R1
       0482 0004 
  0681 0484 C080  XLOCAT MOV   R0,R2
  0682 0486 0601         DEC   R1
  0683 0488 0602         DEC   R2
  0684 048A 0200         LI    R0,>0002
       048C 0002 
  0685 048E 2C20         SYSC  @VIDEO
       0490 03C6'
  0686 0492 C0C2         MOV   R2,R3       Calc cursor loc
  0687 0494 3860         MPY   @S#WDTH,R1  for direct video
       0496 03CC'
  0688 0498 A0C2         A     R2,R3
  0689 049A C803         MOV   R3,@S#LOC
       049C 03CA'
  0690 049E 045D         B     *R13
  0691            
  0692            * Key=POLL(c)
  0693            *
  0694            * Scans the keyboard and returns the key value
  0695            * if one is pressed or 0. If c!=0, the program
  0696            * will pause while a key is down. If c!=0 and
  0697            * Fctn-4 is pressed (CLEAR) the program will
  0698            * branch to the c99 exit function.
  0699            *
  0700 04A0 C0EE  POLL   MOV   @>0002(R14),R3
       04A2 0002 
  0701 04A4 04C0  XPOLL  CLR   R0               Use last keyboard mode
  0702 04A6 2C20         SYSC  @KEYBRD
       04A8 03C4'
  0703 04AA 0981         SRL   R1,8
  0704 04AC C201         MOV   R1,R8
  0705 04AE 0288         CI    R8,>00FF         Key Hit?
       04B0 00FF 
  0706 04B2 1602         JNE   POLL3            Yes
  0707 04B4 04C8         CLR   R8               No
  0708 04B6 045D  POLL2  B     *R13             Return
  0709 04B8 0743  POLL3  ABS   R3
  0710 04BA 13FD         JEQ   POLL2
  0711 04BC 0288         CI    R8,>0002         Fctn4
       04BE 0002 
  0712 04C0 16F1         JNE   XPOLL            No
  0713 04C2 0460         B     @CEXIT
       04C4 0118'
  0714            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20210126                      PAGE 0022
  0716            
  0717            * TSCRN(f,b)
  0718            *
  0719            * Chacges the text mode screen color to f (foreground)
  0720            * and b (background). The Basic color number convention
  0721            * is used.
  0722            *
  0723 04C6 C02E  TSCRN  MOV   @>0002(R14),R0   Background color
       04C8 0002 
  0724 04CA C06E         MOV   @>0004(R14),R1   Foreground color
       04CC 0004 
  0725 04CE 0600  XTSCRN DEC   R0
  0726 04D0 0240         ANDI  R0,>000F
       04D2 000F 
  0727 04D4 0601         DEC   R1
  0728 04D6 0241         ANDI  R1,>000F
       04D8 000F 
  0729 04DA 0A41         SLA   R1,4
  0730 04DC E001         SOC   R1,R0
  0731 04DE 0220         AI    R0,>8700
       04E0 8700 
  0732 04E2 06C0         SWPB  R0
  0733 04E4 D800         MOVB  R0,@>F102
       04E6 F102 
  0734 04E8 06C0         SWPB  R0
  0735 04EA D800         MOVB  R0,@>F102
       04EC F102 
  0736 04EE 045D         B     *R13
  0737            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20210126                      PAGE 0023
  0739            
  0740            * EXIT(c) or ABORT(c)
  0741            *
  0742            * Branches to the c99 exit function which closes
  0743            * any open files. The value of c may be between
  0744            * 0 and 7. If c==0 the normal exit message is
  0745            * displayed. If c==7 the program terminates
  0746            * immediately. Otherwise the value of c is displayed
  0747            * in an error message. The exit(0) function is also
  0748            * executed when function main() terminates normally
  0749            *
  0750            EXIT
  0751 04F0 04E0  ABORT  CLR   @C$HOOK+2
       04F2 0556'
  0752 04F4 C02E         MOV   @>0002(R14),R0   Exit status
       04F6 0002 
  0753 04F8 1602         JNE   ABORT1
  0754 04FA 0460         B     @CEXIT
       04FC 0118'
  0755            
  0756 04FE 0240  ABORT1 ANDI  R0,>0007         Only exit codes 1..7
       0500 0007 
  0757 0502 0280         CI    R0,>0007         Terminate immediately?
       0504 0007 
  0758 0506 1604         JNE   ABORT2           No!
  0759 0508 0720         SETO  @C$HOOK+2        Set flag
       050A 0556'
  0760 050C 0460         B     @CEXIT1
       050E 0126'
  0761            *      B     @CEXIT2
  0762 0510 0220  ABORT2 AI    R0,>0030         +ASC("0")
       0512 0030 
  0763 0514 06C0         SWPB  R0
  0764 0516 D800         MOVB  R0,@C99T3X       Move into error message
       0518 0543'
  0765 051A 0208         LI    R8,C99T3         c99 err=X
       051C 053A'
  0766 051E 068F         BL    R15
  0767 0520 069C         BL    *R12
  0768 0522 037A'        DATA  PUTS
  0769 0524 0460         B     @CEXIT1
       0526 0126'
  0770            
  0771 0528 0208  CEXIT0 LI    R8,C99T4         c99 ^C exit
       052A 0545'
  0772 052C 068F         BL    R15
  0773 052E 069C         BL    *R12
  0774 0530 037A'        DATA  PUTS
  0775 0532 0720         SETO  @C$HOOK+2        Set flag
       0534 0556'
  0776 0536 0460         B     @CEXIT1
       0538 0126'
  0777            
  0778 053A   0A  C99T3  BYTE 10
  0779 053B   63         TEXT 'c99 err='
  0780 0543   58  C99T3X TEXT 'X'
  0781 0544   00         BYTE 0
  0782 0545   0A  C99T4  BYTE 10
  0783 0546   63         TEXT 'c99 ^C exit'

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20210126                      PAGE 0024
  0784 0551   0A         BYTE 10
  0785 0552 0000         DATA  >0000
  0786 0554 0000  C$HOOK DATA  >0000
  0787 0556 0000         DATA  >0000
  0788            
  0789                   END

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20210126                      PAGE 0025
  D ABORT   04F0    ' ABORT1  04FE    ' ABORT2  0510    ' ARGC    01E6  
  ' ARGPNT  007E    ' ARGPT1  008C    ' ARGPT2  0092    ' ARGPT3  009E  
  ' ARGPT4  00B2    ' ARGV0   01E8    ' ARGV1   01EA    D C$ASL   0256  
  D C$ASR   024E    D C$CALL  02BA    D C$CIND  02B0    D C$DIV   025E  
  D C$EQ    020A    ' C$FALS  0232    D C$GE    0228    D C$GT    0222  
  D C$HOOK  0554    D C$LE    021C    D C$LNEG  0298    ' C$LNG1  02A0  
  D C$LT    0216    D C$NE    0210    D C$REM   0268    ' C$SWC1  02AE  
  D C$SWCH  02A4    ' C$TRUE  022C    D C$UGE   0248    D C$UGT   0242  
  D C$ULE   023C    D C$ULT   0236    ' C99CT1  0176    ' C99CT2  0180  
  ' C99T3   053A    ' C99T3X  0543    ' C99T4   0545      C99WS   F000  
  ' CALL    0168      CALLZ   0008    ' CEXIT   0118    ' CEXIT0  0528  
  ' CEXIT1  0126    ' CEXIT2  011C    ' CEXT11  012E    ' CEXT12  013E  
  ' CEXT13  0156    ' CHRBS   03DA    ' CMDBU0  0192    ' CMDBUF  0194  
  D CNULL   018E    ' CURBS   03D8    ' DIVID1  0288    ' DIVID2  0290  
  ' DIVID3  0292    ' DIVIDE  0272    D DPUTS   0390    ' DPUTS1  03B0  
  ' DPUTSX  03BE    D ERRNO   01E4    D EXIT    04F0    ' GETCH   02C8  
  ' GETCH1  02DC    ' GETCH2  02E0    ' GETCH3  02E2    ' GETCH4  02EC  
  ' GETCH5  02F2    D GETCHA  02C4    D GETCHR  02BC    ' GETCM1  0066  
  ' GETCM2  0068    ' GETCM3  0070    D GETS    0314    ' GETS1   031E  
  ' GETS2   0336    ' GETS3   034C    ' GETS4   0356      HR0     F000  
    HR1     F002      HR10    F014      HR11    F016      HR12    F018  
    HR13    F01A      HR14    F01C      HR15    F01E      HR2     F004  
    HR3     F006      HR4     F008      HR5     F00A      HR6     F00C  
    HR7     F00E      HR8     F010      HR9     F012    D KEYBRD  03C4  
  D LOCATE  047C      LR0     F001      LR1     F003      LR10    F015  
    LR11    F017      LR12    F019      LR13    F01B      LR14    F01D  
    LR15    F01F      LR2     F005      LR3     F007      LR4     F009  
    LR5     F00B      LR6     F00D      LR7     F00F      LR8     F011  
    LR9     F013    E MAIN    0116    ' MEMORY  0174      NARGC   0010  
  ' NOKEY   03D6    ' NULL    018F    D POLL    04A0    ' POLL2   04B6  
  ' POLL3   04B8    ' PUSH    0162      PUSHZ   0006    D PUTCHA  0364  
  D PUTS    037A    ' PUTS1   0384    ' PUTS2   038E      R0      0000  
    R1      0001      R10     000A      R11     000B      R12     000C  
    R13     000D      R14     000E      R15     000F      R2      0002  
    R3      0003      R4      0004      R5      0005      R6      0006  
    R7      0007      R8      0008      R9      0009      RETRNZ  0004  
  ' RETURN  0170    D S#DRCT  03C8    D S#KBM   03DC    D S#LOC   03CA  
  D S#PAGE  03D4    ' S#SEND  03D2    ' S#SHGT  03CE    ' S#STRT  03D0  
  D S#WDTH  03CC    D S$TII   03DE    ' S$TII1  03E8    ' S$TII2  03EC  
  ' S$TII3  03F6    ' S$TII4  03FC    ' S$TII5  0400    ' S$TII6  040A  
  ' SBRV    02FC    ' SPACE   0190    D START   0000    ' START1  0038  
  ' START2  00B8    ' START3  00F0    ' START4  00FE    X SYSC    0000  
  ' TILDE   0191    D TSCRN   04C6      VDPWA   F102      VDPWD   F100  
  ' VIDEO   03C6    ' WRCH11  0468    ' WRCH12  0472    ' WRCHR1  043A  
  ' WRCHR3  042C    D XDPUTS  0394    D XGETS   0318    D XLOCAT  0484  
  D XPOLL   04A4    D XPUTC   0368    D XPUTS   0372    D XTSCRN  04CE  
  0000 ERRORS

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20210126                      PAGE 0026
  SEGMENT RORG     SIZE 01368 (>0558) BYTES
