
 Xa99 Cross Assembler
LONG FUNCTIONS 01/02/2007                                    PAGE 0001
  0001            *
  0002            * long functions for C99 2.0
  0003            *
  0004            * Frederik G. Kaal	01/02/2007
  0005            *
  0006            * Because not every project need all long functions
  0007            * you can copy this file to the project directory
  0008            * and comment-out the functions you don't need.
  0009            *
  0010            * A library with all functions is available in the Tilib.
  0011            *
  0012            * Name convention:
  0013            *   Lxxx(*L)      Functions with one argument
  0014            *   LxxxL(*L,*L)  Functions with two arguments and both are 
  0015            *   LxxxS(*L, S)  Functions with two arguments first is long
  0016            *   SLxxxS(*L, S) Functions with two arguments first is long
  0017            *                   and result is short
  0018            *
  0020            
  0021                    IDT 'LONG'
  0022            
  0023                    DEF LCLR,LSETO,LINC,LDEC,LINV,LABS,LNEG
  0024                    DEF LCPYS,LCPYL,LCMPL,LTST
  0025                    DEF LANDL,LORL,LXORL,LSHLS,LSHRS
  0026                    DEF LADDS,LADDL,LSUBS,LSUBL
  0027                    DEF LMPYS,LMPYL,LDIVS,LMODS,LDIVL,LMODL
  0028                    DEF LMPY#S,LDIV#S
  0029            	
  0030            *****************************
  0031            *	AORG    >A000
  0032            *TEST	LWPI	MYWS
  0033            *	LI      13,RETURN
  0034            *	LI	14,STACK
  0035            *	
  0036            *START	LI      8,LONG1
  0037            *	BL      15
  0038            *	LI      8,LONG2
  0039            **	LI      8,>6666
  0040            *	BL      15
  0041            *	BL	@GOSUB
  0042            *	DATA	LDIVL
  0043            **	DATA	LMPYL
  0044            *		
  0045            *	DATA	>0D00	TI994W debugger
  0046            *STOP	JMP	TEST
  0047            *
  0048            *GOSUB	MOV	*11+,7	
  0049            *	DECT	14
  0050            *	MOV	11,*14
  0051            *	B	*7
  0052            *
  0053            *RETURN	MOV	*14+,7
  0054            *	B	*7
  0055            *
  0056            *
  0057            *MYWS	DATA	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
  0058            *PUSH	DECT	14
  0059            *	MOV	8,*14
  0060            *	B	*11

 Xa99 Cross Assembler
LONG FUNCTIONS 01/02/2007                                    PAGE 0002
  0061            *
  0062            *
  0063            *LONG1	DATA	>FFFF,>FFFF
  0064            *LONG2	DATA	>0FFF,>FFFF
  0065            *
  0066            *	DATA	0,0,0,0,0
  0067            *	DATA	0,0,0,0,0 
  0068            *	DATA	0,0,0,0,0 
  0069            *STACK	DATA	0,0,0,0,0 
  0070            *	DATA	0,0,0,0,0 
  0071            *
  0072            *
  0073            ******************************
  0074 0000 0000  L0000  DATA >0000,>0000
       0002 0000 
  0075            
  0076            * lclr(long) int *long;
  0077            *
  0078            * long = 0
  0079            * returns *long
  0080            *
  0081 0004 04E8  LCLR   CLR @2(8)         R8=&long
       0006 0002 
  0082 0008 04D8         CLR *8
  0083 000A 045D         B   *13
  0084            	
  0085            * lseto(long) int *long;
  0086            *
  0087            * long = 0xffffffff = -1
  0088            * returns *long
  0089            *
  0090 000C 0728  LSETO  SETO @2(8)        R8=&long
       000E 0002 
  0091 0010 0718         SETO *8
  0092 0012 045D         B    *13
  0093            
  0094            * linc(long) int *long;
  0095            * 
  0096            * long += 1
  0097            * returns *long
  0098            *
  0099 0014 05A8  LINC   INC @2(8)         R8=&long
       0016 0002 
  0100 0018 1701         JNC LINC#X
  0101 001A 0598         INC *8
  0102 001C 045D  LINC#X B   *13
  0103            
  0104            * ldec(long) int *long;
  0105            *
  0106            * long -= 1
  0107            * returns *long
  0108            *
  0109 001E 0628  LDEC   DEC @2(8)         R8=&long
       0020 0002 
  0110 0022 1801         JOC LDEC#X
  0111 0024 0618         DEC *8
  0112 0026 045D  LDEC#X B   *13
  0113            
  0114            * linv(long) int *long

 Xa99 Cross Assembler
LONG FUNCTIONS 01/02/2007                                    PAGE 0003
  0115            *
  0116            * long = ~long
  0117            * returns *long
  0118            *
  0119 0028 0568  LINV   INV @2(8)         R8=&long
       002A 0002 
  0120 002C 0558         INV *8
  0121 002E 045D         B   *13
  0122            
  0123            * labs(long) int *long
  0124            *
  0125            * long = ABS(long)
  0126            * returns *long
  0127            *
  0128 0030 C018  LABS   MOV *8,0          R8=&long
  0129 0032 1101         JLT LNEG	
  0130 0034 045D         B   *13
  0131            
  0132            * lneg(long) int *long
  0133            *
  0134            * long = -long
  0135            * returns *long
  0136            *
  0137 0036 0558  LNEG   INV *8	         R8=&long
  0138 0038 0528         NEG @2(8)
       003A 0002 
  0139 003C 1701         JNC LNEG#X
  0140 003E 0598         INC *8
  0141 0040 045D  LNEG#X B   *13
  0142            
  0143            * lcpys(long,short) int *long,short;
  0144            *
  0145            * long = short
  0146            * returns *long
  0147            *
  0148 0042 C048  LCPYS  MOV  8,1          R1=short
  0149 0044 C22E         MOV  @4(14),8     R8=&long
       0046 0004 
  0150 0048 04D8         CLR  *8
  0151 004A CA01         MOV  1,@2(8)
       004C 0002 
  0152 004E 045D         B    *13
  0153            
  0154            * lcpyl(long1, long2) int *long1, *long2;
  0155            *
  0156            * long1 = long2
  0157            * returns *long1
  0158            *
  0159 0050 C06E  LCPYL  MOV  @2(14),1     R1=&long1
       0052 0002 
  0160 0054 C22E         MOV  @4(14),8     R8=&long2
       0056 0004 
  0161 0058 C631         MOV  *1+,*8
  0162 005A CA11         MOV  *1,@2(8)
       005C 0002 
  0163 005E 045D         B    *13	
  0164            
  0165            * lcmpl(long1,long2) int *long1,*long2;
  0166            *

 Xa99 Cross Assembler
LONG FUNCTIONS 01/02/2007                                    PAGE 0004
  0167            * compare long1 and long2
  0168            * returns > 0 if long1 > long2
  0169            * returns   0 if long1 = long2
  0170            * returns < 0 if long1 < long2
  0171            *
  0172 0060 C02E  LCMPL  MOV  @4(14),0     R0=&long1
       0062 0004 
  0173 0064 C048         MOV  8,1          R1=&long2
  0174 0066 1003         JMP  LTST#X
  0175            
  0176            * ltst(long) int *long
  0177            *
  0178            * compare long with 0
  0179            *
  0180            * returns > 0 if long > 0
  0181            * returns   0 if long = 0
  0182            * returns < 0 if long < 0
  0183            *
  0184 0068 C008  LTST   MOV  8,0          R0=&Long	
  0185 006A 0201  LTST#0 LI   1,L0000      R1=&>00000000
       006C 0000'
  0186 006E 04C8  LTST#X CLR  8
  0187 0070 8C70         C    *0+,*1+      HOW(long1)-HOW(long2)
  0188 0072 1A06         JL   LTST#L
  0189 0074 1B03         JH   LTST#H
  0190 0076 8450         C    *0,*1        LOW(long1)-LOW(long2)
  0191 0078 1A03         JL   LTST#L
  0192 007A 1301         JEQ  LTST#E
  0193 007C 0588  LTST#H INC  8
  0194 007E 045D  LTST#E B    *13
  0195 0080 0708  LTST#L SETO 8
  0196 0082 045D         B    *13
  0197                   
  0198            * landl(long1,long2) int *long1,*long2
  0199            *
  0200            * long1 &= long2
  0201            * returns *long1
  0202            *
  0203 0084 C048  LANDL  MOV  8,1          R1=&long2
  0204 0086 C22E         MOV  @4(14),8     R8=&long1
       0088 0004 
  0205 008A C031         MOV  *1+,0
  0206 008C 0540         INV  0
  0207 008E 4600         SZC  0,*8
  0208 0090 C011         MOV  *1,0
  0209 0092 0540         INV  0
  0210 0094 4A00         SZC  0,@2(8)
       0096 0002 
  0211 0098 045D         B    *13 
  0212            
  0213            * lorl(long1,long2) int *long1,*long2
  0214            *
  0215            * long1 |= long2
  0216            * returns *long1
  0217            *
  0218 009A C048  LORL   MOV  8,1          R1=&long2
  0219 009C C22E         MOV  @4(14),8     R8=&long1
       009E 0004 
  0220 00A0 E631         SOC  *1+,*8

 Xa99 Cross Assembler
LONG FUNCTIONS 01/02/2007                                    PAGE 0005
  0221 00A2 EA11         SOC  *1,@2(8)
       00A4 0002 
  0222 00A6 045D         B    *13 
  0223            
  0224            * lxorl(long1,long2) int *long1,*long2
  0225            *
  0226            * long1 ^= long2
  0227            * returns *long1
  0228            *
  0229 00A8 C048  LXORL  MOV  8,1          R1=&long2
  0230 00AA C22E         MOV  @4(14),8     R8=&long1
       00AC 0004 
  0231 00AE C088         MOV  8,2          R2=&long1
  0232 00B0 C012         MOV  *2,0         HOW XOR HOW
  0233 00B2 2831         XOR  *1+,0
  0234 00B4 CC80         MOV  0,*2+
  0235 00B6 C012         MOV  *2,0         LOW XOR LOW
  0236 00B8 2811         XOR  *1,0
  0237 00BA C480         MOV  0,*2
  0238 00BC 045D         B    *13 
  0239            
  0240            * lshls(long,shcnt) int *long, shcnt
  0241            *
  0242            * long <<= shcnt (1-16)
  0243            * returns *long
  0244            *
  0245 00BE C008  LSHLS  MOV  8,0          R0=shcnt
  0246 00C0 1310         JEQ  LSHL#X	 =0
  0247 00C2 C22E         MOV  @4(14),8     R8=&long
       00C4 0004 
  0248            
  0249 00C6 C058         MOV  *8,1
  0250 00C8 C0A8         MOV  @2(8),2
       00CA 0002 
  0251 00CC C0C2         MOV  2,3
  0252 00CE 0A01         SLA  1,0
  0253 00D0 0A02         SLA  2,0
  0254 00D2 0500         NEG  0
  0255 00D4 0220         AI   0,16
       00D6 0010 
  0256 00D8 0903         SRL  3,0
  0257 00DA A043         A    3,1
  0258 00DC C601         MOV  1,*8
  0259 00DE CA02         MOV  2,@2(8)	
       00E0 0002 
  0260 00E2 045D  LSHL#X B    *13
  0261            
  0262            * lshrs(long,shcnt) int *long, shcnt
  0263            *
  0264            * long >>= shcnt (1-16)
  0265            * returns *long
  0266            *
  0267 00E4 C008  LSHRS  MOV 8,0           R0=shcnt
  0268 00E6 13FD         JEQ LSHL#X
  0269 00E8 C22E         MOV @4(14),8      R8=&long
       00EA 0004 
  0270                   
  0271 00EC C058         MOV *8,1
  0272 00EE C0A8         MOV @2(8),2

 Xa99 Cross Assembler
LONG FUNCTIONS 01/02/2007                                    PAGE 0006
       00F0 0002 
  0273 00F2 C0C1         MOV 1,3
  0274 00F4 0901         SRL 1,0
  0275 00F6 0902         SRL 2,0
  0276 00F8 0500         NEG 0
  0277 00FA 0220         AI  0,16
       00FC 0010 
  0278 00FE 0A03         SLA 3,0
  0279 0100 A083         A   3,2
  0280 0102 C601         MOV 1,*8
  0281 0104 CA02         MOV 2,@2(8)	
       0106 0002 
  0282 0108 045D  LSHR#X B   *13
  0283            
  0284            * ladds(long, short) int *long, short;
  0285            *
  0286            * long += short
  0287            * returns *long
  0288            *
  0289 010A C048  LADDS  MOV  8,1          R1=short
  0290 010C C22E         MOV  @4(14),8     R8=&long
       010E 0004 
  0291 0110 AA01         A    1,@2(8)
       0112 0002 
  0292 0114 1701         JNC  LADS#1
  0293 0116 0598         INC  *8
  0294 0118 045D  LADS#1 B    *13
  0295            
  0296            * laddl(long1, long2) int *long1, long2;
  0297            *
  0298            * long1 += long2
  0299            * returns *long1
  0300            *
  0301 011A C048  LADDL  MOV  8,1          R1=&long2
  0302 011C C22E         MOV  @4(14),8     R8=&long1
       011E 0004 
  0303 0120 AA21         A    @2(1),@2(8)
       0122 0002 
       0124 0002 
  0304 0126 1701         JNC  LADD#1
  0305 0128 0598         INC  *8
  0306 012A A611  LADD#1 A    *1,*8
  0307 012C 045D         B    *13
  0308            
  0309            * lsubs(long, short) int *long, short;
  0310            *
  0311            * long -= short
  0312            * returns *long
  0313            *
  0314 012E C048  LSUBS  MOV  8,1          R1=short
  0315 0130 C22E         MOV  @4(14),8     R8=&long
       0132 0004 
  0316 0134 6A01         S    1,@2(8)
       0136 0002 
  0317 0138 1801         JOC  LSBS#1
  0318 013A 0618         DEC  *8
  0319 013C 045D  LSBS#1 B    *13
  0320            
  0321            * lsubl(long1, long2) int *long1, long2;

 Xa99 Cross Assembler
LONG FUNCTIONS 01/02/2007                                    PAGE 0007
  0322            *
  0323            * long1 -= long2
  0324            * returns *long1
  0325            *
  0326 013E C048  LSUBL  MOV  8,1          R1=&long2
  0327 0140 C22E         MOV  @4(14),8     R8=&long1
       0142 0004 
  0328 0144 6A21         S    @2(1),@2(8)
       0146 0002 
       0148 0002 
  0329 014A 1801         JOC  LSUB#1
  0330 014C 0618         DEC  *8
  0331 014E 6611  LSUB#1 S    *1,*8
  0332 0150 045D         B    *13
  0333            
  0334            * lmpys(long,short) int *long,short;
  0335            *
  0336            * long *= short = (short*LOW(long))        overflow if:
  0337            *               + (short*HOW(long)) 0000   HOW(result)!=0
  0338            * returns *long
  0339            *
  0340            * overflow if: 
  0341            *
  0342 0152 04C7  LMPYS  CLR  7            R7=HOW(short)
  0343 0154 C188         MOV  8,6          R6=LOW(short)
  0344 0156 C22E         MOV  @4(14),8     R8=&Long 
       0158 0004 
  0345            
  0346 015A C068         MOV  @2(8),1      LOW(long)
       015C 0002 
  0347 015E 3846         MPY  6,1          LOW(short)*LOW(long)
  0348 0160 06A0         BL   @LMPY#1
       0162 0190'
  0349 0164 045D         B    *13
  0350            
  0351            * lmpyl(long1,long2) int *long1,*long2;
  0352            *
  0353            * unsigned multiply
  0354            *
  0355            * long1 *= long2 = (LOW(long2) * LOW(long1))            over
  0356            *                + (HOW(long2) * LOW(long1)) 0000       HOW(
  0357            *                + (LOW(long2) * HOW(long1)) 0000       HOW(
  0358            *                + (HOW(long2) * HOW(long1)) 0000 0000      
  0359            *
  0360            * returns *long1, if overflow occured long1=0xFFFFFFFF 
  0361            *
  0362            *
  0363            *
  0364 0166 C198  LMPYL  MOV  *8,6     R6=HOW(long2)
  0365 0168 C1E8         MOV  @2(8),7  R7=LOW(long2)
       016A 0002 
  0366 016C C22E         MOV  @4(14),8 R8=&long1
       016E 0004 
  0367 0170 06A0         BL   @LMPY#S
       0172 0176'
  0368 0174 045D         B    *13
  0369                   
  0370 0176 C0D8  LMPY#S MOV  *8,3     HOW(long1)=0
  0371 0178 1302         JEQ  LMPY#0

 Xa99 Cross Assembler
LONG FUNCTIONS 01/02/2007                                    PAGE 0008
  0372 017A C0C6         MOV  6,3      HOW(long2)=0
  0373 017C 1613         JNE  LMPY#V   Overflow
  0374            
  0375 017E C068  LMPY#0 MOV  @2(8),1  LOW(long1)
       0180 0002 
  0376 0182 C0C1         MOV  1,3
  0377 0184 3847         MPY  7,1      LOW(long2)*LOW(long1)
  0378                   
  0379 0186 38C6         MPY  6,3      HOW(long2)*LOW(long1)
  0380 0188 A044         A    4,1
  0381 018A 180C         JOC  LMPY#V   Overflow
  0382 018C 0743         ABS  3        !=0
  0383 018E 160A         JNE  LMPY#V   Overflow
  0384                  
  0385 0190 C0D8  LMPY#1 MOV  *8,3     HOW(long1)
  0386 0192 38C7         MPY  7,3      LOW(long2)*HOW(long1)
  0387 0194 A044         A    4,1
  0388 0196 1806         JOC  LMPY#V   Overflow
  0389 0198 0743         ABS  3        !=0
  0390 019A 1604         JNE  LMPY#V   Overflow
  0391            
  0392 019C C601  LMPY#X MOV  1,*8     HOW(long1*long2)
  0393 019E CA02         MOV  2,@2(8)  LOW(long1*long2)
       01A0 0002 
  0394 01A2 045B         B    *11	
  0395                   
  0396 01A4 0718  LMPY#V SETO *8       Overflow
  0397 01A6 0728         SETO @2(8)
       01A8 0002 
  0398 01AA 045B         B    *11
  0399            
  0400            * sldivs(long,short) int *long1,short;
  0401            *
  0402            * result = long / short
  0403            * returns result
  0404            *
  0405 01AC C048  SLDIVS MOV  8,1          R1=short
  0406 01AE C0AE         MOV  @4(14),2     R2=&long
       01B0 0004 
  0407 01B2 C212         MOV  *2,8         R7=HOW(long)
  0408 01B4 C262         MOV  @2(2),9      R8=LOW(long)
       01B6 0002 
  0409 01B8 3E01         DIV  1,8          R8=quotient
  0410 01BA 045D         B    *13
  0411            
  0412            * ldivs(long,short) int *long1,short;
  0413            *
  0414            * long = long / short
  0415            * returns *long
  0416            *
  0417 01BC C048  LDIVS  MOV  8,1          R1=short=dividend
  0418 01BE C22E         MOV  @4(14),8     R8=&long
       01C0 0004 
  0419                   
  0420 01C2 04C2         CLR  2            R2=HOW(divisor)
  0421 01C4 C0D8         MOV  *8,3         R3=HOW(long)=LOW(divisor)
  0422 01C6 3C81         DIV  1,2          R2=quotient=HOW(result),R3=remainde
  0423            
  0424 01C8 C128         MOV  @2(8),4      R4=LOW(long)=LOW(divisor)

 Xa99 Cross Assembler
LONG FUNCTIONS 01/02/2007                                    PAGE 0009
       01CA 0002 
  0425 01CC 3CC1         DIV  1,3          R3=LOW(result), R4=remainder
  0426                   
  0427 01CE C602         MOV  2,*8
  0428 01D0 CA03         MOV  3,@2(8)
       01D2 0002 
  0429 01D4 045D         B    *13
  0430            
  0431            * lmods(long,short) int *long,short
  0432            *
  0433            * result = long % short
  0434            * returns result
  0435            *
  0436 01D6 C048  LMODS  MOV  8,1          R1=short
  0437 01D8 C0AE         MOV  @4(14),2     R2=&long
       01DA 0004 
  0438 01DC C1F2         MOV  *2+,7        R7=HOW(long)
  0439 01DE C212         MOV  *2,8         R8=LOW(long)
  0440 01E0 3DC1         DIV  1,7          R8=modulo
  0441 01E2 045D         B    *13
  0442            
  0443            * ldivl(long1,long2) int *long1,*long2
  0444            *
  0445            * unsigned divide
  0446            *
  0447            * long1 = long1 / long2
  0448            * returns *long1
  0449            *
  0450 01E4 06A0  LDIVL  BL   @LDIV#U
       01E6 01FC'
  0451 01E8 C604         MOV  4,*8         R8=&long1
  0452 01EA CA05         MOV  5,@2(8)
       01EC 0002 
  0453 01EE 045D         B    *13
  0454            
  0455            * lmodl(long1,long2) int *long1,*long2
  0456            *
  0457            * unsigned modulo
  0458            *
  0459            * long1 = long1 % long2
  0460            * returns *long1
  0461            *
  0462 01F0 06A0  LMODL  BL   @LDIV#U
       01F2 01FC'
  0463 01F4 C602         MOV  2,*8         R8=&long1
  0464 01F6 CA03         MOV  3,@2(8)
       01F8 0002 
  0465 01FA 045D         B    *13
  0466            
  0467            * ldiv0(long1,long2) int *long1,*long2
  0468            *
  0469            * R4,5 = long1 / long2
  0470            * R2,3 = long1 % long2
  0471            *
  0472 01FC C02E  LDIV#U MOV  @4(14),0
       01FE 0004 
  0473 0200 C230         MOV  *0+,8    Dividend HOW
  0474 0202 C250         MOV  *0,9     LOW
  0475 0204 C02E         MOV  @2(14),0

 Xa99 Cross Assembler
LONG FUNCTIONS 01/02/2007                                    PAGE 0010
       0206 0002 
  0476 0208 C1B0         MOV  *0+,6    Divider HOW
  0477 020A C1D0         MOV  *0,7     LOW
  0478            
  0479 020C 04C2  LDIV#S CLR  2        Modulo HOW
  0480 020E 04C3         CLR  3        LOW
  0481 0210 04C4         CLR  4        Quotient HOW
  0482 0212 04C5         CLR  5        LOW
  0483            
  0484 0214 C046         MOV  6,1	     Divide by 0?
  0485 0216 E047         SOC  7,1    
  0486 0218 1603         JNE  LDIV#0   No!
  0487 021A 0704         SETO 4        Result = long max	
  0488 021C 0705         SETO 5	
  0489 021E 101E         JMP  LDIV#9
  0490                  
  0491 0220 0201  LDIV#0 LI   1,32     32bits divide
       0222 0020 
  0492                   
  0493 0224 0A14  LDIV#1 SLA  4,1      Quotient *=2
  0494 0226 0A15         SLA  5,1
  0495 0228 1701         JNC  LDIV#2
  0496 022A 0584         INC  4        HOW+C
  0497                   
  0498 022C 0A12  LDIV#2 SLA  2,1      Modulo *=2
  0499 022E 0A13         SLA  3,1
  0500 0230 1701         JNC  LDIV#3
  0501 0232 0582         INC  2        HOW+C
  0502                   
  0503 0234 0A18  LDIV#3 SLA  8,1      Divider *=2
  0504 0236 1701         JNC  LDIV#4
  0505 0238 0583         INC  3        Modulo+C
  0506 023A 0A19  LDIV#4 SLA  9,1
  0507 023C 1701         JNC  LDIV#5
  0508 023E 0588         INC  8        HOW+C
  0509             
  0510 0240 8182  LDIV#5 C    2,6      HOW(Modulo) > HOW(Divider) ?
  0511 0242 1A0A         JL   LDIV#8   No!	
  0512 0244 1B02         JH   LDIV#6   Yes! 
  0513 0246 81C3         C    3,7      LOW(Modulo) >= LOW(Modulo)
  0514 0248 1A07         JL   LDIV#8
  0515 024A 60C7  LDIV#6 S    7,3      Modulo -= Divider
  0516 024C 1801         JOC  LDIV#7
  0517 024E 0602         DEC  2
  0518 0250 6086  LDIV#7 S    6,2
  0519 0252 0585         INC  5        Quotient +=1
  0520 0254 1701         JNC  LDIV#8
  0521 0256 0584         INC  4        HOW+C
  0522                          
  0523 0258 0601  LDIV#8 DEC  1
  0524 025A 16E4         JNE  LDIV#1
  0525 025C C22E  LDIV#9 MOV  @4(14),8 R8=&long1
       025E 0004 
  0526 0260 045B         B    *11
  0527            
  0528                   END

 Xa99 Cross Assembler
LONG FUNCTIONS 01/02/2007                                    PAGE 0011
  ' L0000   0000    D LABS    0030    ' LADD#1  012A    D LADDL   011A  
  D LADDS   010A    ' LADS#1  0118    D LANDL   0084    D LCLR    0004  
  D LCMPL   0060    D LCPYL   0050    D LCPYS   0042    D LDEC    001E  
  ' LDEC#X  0026    ' LDIV#0  0220    ' LDIV#1  0224    ' LDIV#2  022C  
  ' LDIV#3  0234    ' LDIV#4  023A    ' LDIV#5  0240    ' LDIV#6  024A  
  ' LDIV#7  0250    ' LDIV#8  0258    ' LDIV#9  025C    D LDIV#S  020C  
  ' LDIV#U  01FC    D LDIVL   01E4    D LDIVS   01BC    D LINC    0014  
  ' LINC#X  001C    D LINV    0028    D LMODL   01F0    D LMODS   01D6  
  ' LMPY#0  017E    ' LMPY#1  0190    D LMPY#S  0176    ' LMPY#V  01A4  
  ' LMPY#X  019C    D LMPYL   0166    D LMPYS   0152    D LNEG    0036  
  ' LNEG#X  0040    D LORL    009A    ' LSBS#1  013C    D LSETO   000C  
  ' LSHL#X  00E2    D LSHLS   00BE    ' LSHR#X  0108    D LSHRS   00E4  
  ' LSUB#1  014E    D LSUBL   013E    D LSUBS   012E    D LTST    0068  
  ' LTST#0  006A    ' LTST#E  007E    ' LTST#H  007C    ' LTST#L  0080  
  ' LTST#X  006E    D LXORL   00A8      R0      0000      R1      0001  
    R10     000A      R11     000B      R12     000C      R13     000D  
    R14     000E      R15     000F      R2      0002      R3      0003  
    R4      0004      R5      0005      R6      0006      R7      0007  
    R8      0008      R9      0009    ' SLDIVS  01AC  
  0000 ERRORS

 Xa99 Cross Assembler
LONG FUNCTIONS 01/02/2007                                    PAGE 0012
  SEGMENT RORG     SIZE 00610 (>0262) BYTES
