
 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20010401                      PAGE 0001
  0002            
  0003                      IDT  'C99CSUP4'
  0004            
  0005            * Copyright 1988 Clint pulley
  0006            *
  0007            * This is the debuged version of the CSUP compiler routines
  0008            * wherin the locate() mistake is repaired.
  0009            *
  0010            * Original version:           Clint Pulley
  0011            *                             38 Townsend Avenue
  0012            *                             Burlington, Ontario
  0013            *                             Canada L7T 1Y6
  0014            *
  0015            * Debugged by:                Frederik G. Kaal
  0016            *                             Kinheimstraat 9
  0017            *                             1815 BD Alkmaar
  0018            *                             Holland
  0019            *

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20010401                      PAGE 0002
  0021            
  0022                   REF  MAIN              User program
  0023            
  0024                   DEF  START             Start CSUP
  0025            
  0026                   DEF  TSCRN,POLL,S#KBM,KEYBRD,LOCATE
  0027                   DEF  S$TII
  0028                   DEF  S#PAGE,S#WDTH,S#LOC,S#DRCT
  0029                   DEF  C$CALL,C$HOOK,C$SWCH
  0030                   DEF  ABORT,EXIT,DPUTS
  0031                   DEF  PUTS,PUTCHA,GETS,GETCHA,GETCHR
  0032                   DEF  C$LNEG,C$CIND,C$REM
  0033                   DEF  C$DIV,C$ASL,C$ASR
  0034                   DEF  C$UGE,C$UGT
  0035                   DEF  C$ULE,C$ULT
  0036                   DEF  C$GE,C$GT,C$LE,C$LT,C$NE,C$EQ
  0037            *the X-routines
  0038                   DEF  XTSCRN,XLOCAT,XPOLL,XPUTS,XDPUTS
  0039                   DEF  XPUTC,XGETS
  0040            
  0041                   DXOP SYSC,0
  0042            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20010401                      PAGE 0003
  0044            
  0045      F000  C99WS  EQU  >F000             C99 Workspace
  0046            
  0047      F000  HR0    EQU  C99WS+0
  0048      F001  LR0    EQU  C99WS+1
  0049      F002  HR1    EQU  C99WS+2
  0050      F003  LR1    EQU  C99WS+3
  0051      F004  HR2    EQU  C99WS+4
  0052      F005  LR2    EQU  C99WS+5
  0053      F006  HR3    EQU  C99WS+6
  0054      F007  LR3    EQU  C99WS+7
  0055      F008  HR4    EQU  C99WS+8
  0056      F009  LR4    EQU  C99WS+9
  0057      F00A  HR5    EQU  C99WS+10
  0058      F00B  LR5    EQU  C99WS+11
  0059      F00C  HR6    EQU  C99WS+12
  0060      F00D  LR6    EQU  C99WS+13
  0061      F00E  HR7    EQU  C99WS+14
  0062      F00F  LR7    EQU  C99WS+15
  0063      F010  HR8    EQU  C99WS+16
  0064      F011  LR8    EQU  C99WS+17
  0065      F012  HR9    EQU  C99WS+18
  0066      F013  LR9    EQU  C99WS+19
  0067      F014  HR10   EQU  C99WS+20
  0068      F015  LR10   EQU  C99WS+21
  0069      F016  HR11   EQU  C99WS+22
  0070      F017  LR11   EQU  C99WS+23
  0071      F018  HR12   EQU  C99WS+24
  0072      F019  LR12   EQU  C99WS+25
  0073      F01A  HR13   EQU  C99WS+26
  0074      F01B  LR13   EQU  C99WS+27
  0075      F01C  HR14   EQU  C99WS+28
  0076      F01D  LR14   EQU  C99WS+29
  0077      F01E  HR15   EQU  C99WS+30
  0078      F01F  LR15   EQU  C99WS+31
  0079            
  0080 0000 02E0  START  LWPI  C99WS
       0002 F000 
  0081 0004 0200         LI    R0,CEXIT0        ^C Exit
       0006 0526'
  0082 0008 C800         MOV   R0,@>00FE
       000A 00FE 
  0083            
  0084 000C 0200         LI    R0,>0001         Get number of pages
       000E 0001 
  0085 0010 C040         MOV   R0,R1            One page
  0086 0012 0202         LI    R2,>0007         Local page#
       0014 0007 
  0087 0016 0703         SETO  R3               Fast memory
  0088 0018 2C20         SYSC  @MEMORY
       001A 0174'
  0089 001C 0740         ABS   R0
  0090 001E 130C         JEQ   START1           Got it!
  0091            
  0092 0020 0200         LI    R0,>0001         Get number of pages
       0022 0001 
  0093 0024 C040         MOV   R0,R1            One page
  0094 0026 0202         LI    R2,>0007         Local page#
       0028 0007 

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20010401                      PAGE 0004
  0095 002A 04C3         CLR   R3               Slow memory
  0096 002C 2C20         SYSC  @MEMORY
       002E 0174'
  0097 0030 0740         ABS   R0
  0098 0032 1302         JEQ   START1           Got it!
  0099 0034 0420         BLWP  @>0000           No memory, Exit to dos
       0036 0000 
  0100            
  0101 0038 0200  START1 LI    R0,>0003         Map local pages
       003A 0003 
  0102 003C 0201         LI    R1,>0007         Local page#
       003E 0007 
  0103 0040 C081         MOV   R1,R2            Execution page
  0104 0042 2C20         SYSC  @MEMORY
       0044 0174'
  0105            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20010401                      PAGE 0005
  0107            
  0108            * Copy command line to userbuffer CMDBUF
  0109            *
  0110            * @>0128 --> *next bytecnt c c c c c *next c c c c c c 0
  0111            *                |                   ^   |             ^
  0112            *                `-------------------'   `-------------'
  0113            *
  0114 0046 C0A0         MOV   @>0128,R2        Startadres commandline
       0048 0128 
  0115 004A 1336         JEQ   START2           No commandline
  0116            
  0117 004C 0205         LI    R5,CMDBUF
       004E 0194'
  0118 0050 D1A2         MOVB  @>0002(R2),R6    Get total bytecount
       0052 0002 
  0119 0054 0986         SRL   R6,8
  0120 0056 0286         CI    R6,>0050         Does it fit
       0058 0050 
  0121 005A 142E         JHE   START2           No!
  0122 005C C206         MOV   R6,R8
  0123 005E 05C6         INCT  R6
  0124 0060 C0C2         MOV   R2,R3            First character in commandline
  0125 0062 0583         INC   R3
  0126 0064 1001         JMP   GETCM2
  0127 0066 C0C2  GETCM1 MOV   R2,R3
  0128 0068 05C3  GETCM2 INCT  R3
  0129 006A C102         MOV   R2,R4            End address this piece
  0130 006C 0224         AI    R4,>0008
       006E 0008 
  0131 0070 DD73  GETCM3 MOVB  *R3+,*R5+        Copy 6 bytes to bufer
  0132 0072 0606         DEC   R6               All done?
  0133 0074 1304         JEQ   ARGPNT           Yes!
  0134 0076 8103         C     R3,R4            Reached and address
  0135 0078 1AFB         JL    GETCM3           No!
  0136 007A C092         MOV   *R2,R2           Address next piece
  0137 007C 10F4         JMP   GETCM1           Copy it
  0138            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20010401                      PAGE 0006
  0140            
  0141            * Determine argument count ARGC and address of each
  0142            * argument ARGV[1..16], ARGV[0]='*'
  0143            *
  0144 007E 0209  ARGPNT LI    R9,CMDBUF        Commandline buffer
       0080 0194'
  0145 0082 020A         LI    R10,ARGV1        Address pointer to first argum
       0084 01E8'
  0146 0086 020C         LI    R12,NARGC        Maximum number of arguments
       0088 0010 
  0147 008A 1003         JMP   ARGPT2
  0148 008C 0589  ARGPT1 INC   R9
  0149 008E 0608         DEC   R8               All done?
  0150 0090 1310         JEQ   ARGPT4           Yes
  0151 0092 9819  ARGPT2 CB    *R9,@SPACE
       0094 018F'
  0152 0096 12FA         JLE   ARGPT1
  0153 0098 CE89         MOV   R9,*R10+         Store argument adres in ARGC[]
  0154 009A 05A0         INC   @ARGC
       009C 01E4'
  0155 009E 0589  ARGPT3 INC   R9
  0156 00A0 0608         DEC   R8               All done
  0157 00A2 1307         JEQ   ARGPT4           Yes
  0158 00A4 9819         CB    *R9,@SPACE       End of argument?
       00A6 018F'
  0159 00A8 1BFA         JH    ARGPT3           No
  0160 00AA D660         MOVB  @NULL,*R9        Close argument
       00AC 0190'
  0161 00AE 060C         DEC   R12              Can we store more arguments?
  0162 00B0 16ED         JNE   ARGPT1           Yes
  0163 00B2 0589  ARGPT4 INC   R9
  0164 00B4 D660         MOVB  @NULL,*R9
       00B6 0190'
  0165            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20010401                      PAGE 0007
  0167            
  0168            * Plaats addressen van ARGC en ARGV op de stack
  0169            *
  0170            *
  0171            *
  0172 00B8 0200  START2 LI    R0,CEXIT         Address EXIT routine
       00BA 0118'
  0173 00BC 0201         LI    R1,ARGV0         Address ARGV[0]
       00BE 01E6'
  0174 00C0 020E         LI    R14,>FFF6        Start of stack
       00C2 FFF6 
  0175 00C4 C7A0         MOV   @ARGC,*R14       Push ARGV
       00C6 01E4'
  0176 00C8 064E         DECT  R14
  0177 00CA C781         MOV   R1,*R14          Push ARGC[0]
  0178 00CC 064E         DECT  R14
  0179 00CE C780         MOV   R0,*R14          Push return address CEXIT
  0180 00D0 02A0         STWP  R0
  0181 00D2 C280         MOV   R0,R10
  0182 00D4 022A         AI    R10,>0011        Lsb R8
       00D6 0011 
  0183 00D8 0220         AI    R0,>001E         Msb R15 is PUSH routine
       00DA 001E 
  0184 00DC C300         MOV   R0,R12
  0185 00DE 022C         AI    R12,PUSHZ        Size PUSH routine is start add
       00E0 0006 
  0186 00E2 C34C         MOV   R12,R13          Start address CALL routine
  0187 00E4 022D         AI    R13,CALLZ        Size CALL routine is start add
       00E6 0008 
  0188 00E8 0201         LI    R1,PUSH
       00EA 0162'
  0189 00EC 0202         LI    R2,PUSHZ+CALLZ+RETRNZ
       00EE 0012 
  0190 00F0 CC31  START3 MOV   *R1+,*R0+        Move PUSH, CALL and RETURN to 
  0191 00F2 0642         DECT  R2
  0192 00F4 16FD         JNE   START3
  0193 00F6 0200         LI    R0,>0001         Get video mode
       00F8 0001 
  0194 00FA 2C20         SYSC  @VIDEO
       00FC 03C4'
  0195 00FE C801  START4 MOV   R1,@S#WDTH       Save screen width
       0100 03CA'
  0196 0102 C802         MOV   R2,@S#SHGT       Save screen height
       0104 03CC'
  0197 0106 3881         MPY   R1,R2
  0198 0108 C803         MOV   R3,@S#SEND
       010A 03D0'
  0199 010C 0201         LI    R1,>0A00         LF
       010E 0A00 
  0200 0110 06A0         BL    @WRCHR1
       0112 0438'
  0201 0114 0460         B     @MAIN            Call user program
       0116 0000 
  0202            
  0203 0118 04E0  CEXIT  CLR   @C$HOOK+2
       011A 0554'
  0204 011C 0208  CEXIT2 LI    R8,C99CT1        c99 exit
       011E 0176'
  0205 0120 068F         BL    R15

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20010401                      PAGE 0008
  0206 0122 069C         BL    *R12
  0207 0124 0378'        DATA  PUTS
  0208            
  0209 0126 C020  CEXIT1 MOV   @C$HOOK,R0
       0128 0552'
  0210 012A 1301         JEQ   CEXT11
  0211 012C 0690         BL    *R0              Call HOOK (closing files)
  0212            
  0213 012E 0760  CEXT11 ABS   @C$HOOK+2
       0130 0554'
  0214 0132 1611         JNE   CEXT13
  0215 0134 0208         LI    R8,C99CT2        - Rerun? (Y/N)
       0136 0180'
  0216 0138 068F         BL    R15
  0217 013A 069C         BL    *R12
  0218 013C 0378'        DATA  PUTS
  0219 013E 0200  CEXT12 LI    R0,>2000
       0140 2000 
  0220 0142 06A0         BL    @S$TII           Read keyboard
       0144 03DC'
  0221 0146 0241         ANDI  R1,>5F00         Convert to UPC
       0148 5F00 
  0222 014A 0281         CI    R1,>5900         Y?
       014C 5900 
  0223 014E 13B4         JEQ   START2           Rerun
  0224 0150 0281         CI    R1,>4E00         N?
       0152 4E00 
  0225 0154 16F4         JNE   CEXT12           No, read again
  0226 0156 0201  CEXT13 LI    R1,>0A00         LF
       0158 0A00 
  0227 015A 06A0         BL    @WRCHR1
       015C 0438'
  0228 015E 0420         BLWP  @>0000           Return to MDOS
       0160 0000 
  0229            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20010401                      PAGE 0009
  0231            
  0232            * PUSH
  0233            *
  0234            * Pushes contents R8 on stack
  0235            * Called as: BL R15
  0236            *
  0237 0162 064E  PUSH   DECT  R14
  0238 0164 C788         MOV   R8,*R14
  0239 0166 045B         B     *R11
  0240      0006  PUSHZ  EQU   $-PUSH
  0241            
  0242            * CALL
  0243            * Calls a C written function
  0244            * Called as: BL   *R12
  0245            *            DATA function
  0246            *
  0247 0168 C1FB  CALL   MOV   *R11+,R7
  0248 016A 064E         DECT  R14
  0249 016C C78B         MOV   R11,*R14
  0250 016E 0457         B     *R7
  0251      0008  CALLZ  EQU   $-CALL
  0252            
  0253            * RETURN
  0254            * Returns to calling function
  0255            * Called as: BL *R13
  0256            *
  0257 0170 C1FE  RETURN MOV   *R14+,R7
  0258 0172 0457         B     *R7
  0259      0004  RETRNZ EQU   $-RETURN
  0260            
  0261 0174 0007  MEMORY DATA  >0007
  0262            
  0263 0176   0A  C99CT1 BYTE 10
  0264 0177   63         TEXT 'c99 exit'
  0265 017F   00         BYTE 0
  0266 0180   2D  C99CT2 TEXT '-Rerun? (Y/N) '
  0267 018E   00         BYTE 0
  0268 018F   20  SPACE  BYTE ' '
  0269 0190   00  NULL   BYTE 0
  0270 0191   7E  TILDE  BYTE '~'
  0271            
  0272 0192   2A  CMDBU0 TEXT '*'
  0273 0193   00         BYTE 0
  0274 0194       CMDBUF BSS  80                Commandline buffer
  0275      0010  NARGC  EQU  16                Max. number of arguments
  0276 01E4 0001  ARGC   DATA 1                 Aantal argumenten
  0277 01E6 0192' ARGV0  DATA CMDBU0            Argumenten lijst ARGC[0]='*'
  0278 01E8 0190' ARGV1  DATA NULL,NULL         Argumenten lijst ARGC[1..16]
       01EA 0190'
  0279 01EC 0190'        DATA NULL,NULL,NULL,NULL,NULL,NULL,NULL
       01EE 0190'
       01F0 0190'
       01F2 0190'
       01F4 0190'
       01F6 0190'
       01F8 0190'
  0280 01FA 0190'        DATA NULL,NULL,NULL,NULL,NULL,NULL,NULL
       01FC 0190'
       01FE 0190'

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20010401                      PAGE 0010
       0200 0190'
       0202 0190'
       0204 0190'
       0206 0190'

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20010401                      PAGE 0011
  0282            
  0283 0208 823E  C$EQ   C     *R14+,R8
  0284 020A 130F         JEQ   C$TRUE
  0285 020C 1011         JMP   C$FALS
  0286            
  0287 020E 823E  C$NE   C     *R14+,R8
  0288 0210 160C         JNE   C$TRUE
  0289 0212 100E         JMP   C$FALS
  0290            
  0291 0214 823E  C$LT   C     *R14+,R8
  0292 0216 1109         JLT   C$TRUE
  0293 0218 100B         JMP   C$FALS
  0294            
  0295 021A 823E  C$LE   C     *R14+,R8
  0296 021C 1509         JGT   C$FALS
  0297 021E 1005         JMP   C$TRUE
  0298            
  0299 0220 823E  C$GT   C     *R14+,R8
  0300 0222 1503         JGT   C$TRUE
  0301 0224 1005         JMP   C$FALS
  0302            
  0303 0226 823E  C$GE   C     *R14+,R8
  0304 0228 1103         JLT   C$FALS
  0305            
  0306 022A 0208  C$TRUE LI    R8,>FFFF
       022C FFFF 
  0307 022E 045B         B     *R11
  0308            
  0309 0230 6208  C$FALS S     R8,R8
  0310 0232 045B         B     *R11
  0311            
  0312 0234 823E  C$ULT  C     *R14+,R8
  0313 0236 1AF9         JL    C$TRUE
  0314 0238 10FB         JMP   C$FALS
  0315            
  0316 023A 823E  C$ULE  C     *R14+,R8
  0317 023C 12F6         JLE   C$TRUE
  0318 023E 10F8         JMP   C$FALS
  0319            
  0320 0240 823E  C$UGT  C     *R14+,R8
  0321 0242 1BF3         JH    C$TRUE
  0322 0244 10F5         JMP   C$FALS
  0323            
  0324 0246 823E  C$UGE  C     *R14+,R8
  0325 0248 14F0         JHE   C$TRUE
  0326 024A 10F2         JMP   C$FALS
  0327            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20010401                      PAGE 0012
  0329            
  0330 024C C008  C$ASR  MOV   R8,R0
  0331 024E C23E         MOV   *R14+,R8
  0332 0250 0808         SRA   R8,0
  0333 0252 045B         B     *R11
  0334            
  0335 0254 C008  C$ASL  MOV   R8,R0
  0336 0256 C23E         MOV   *R14+,R8
  0337 0258 0A08         SLA   R8,0
  0338 025A 045B         B     *R11
  0339            
  0340 025C C1CB  C$DIV  MOV   R11,R7
  0341 025E 06A0         BL    @DIVIDE
       0260 0270'
  0342 0262 C200         MOV   R0,R8            Quotient
  0343 0264 0457         B     *R7
  0344            
  0345 0266 C1CB  C$REM  MOV   R11,R7
  0346 0268 06A0         BL    @DIVIDE
       026A 0270'
  0347 026C C201         MOV   R1,R8            Remainder
  0348 026E 0457         B     *R7
  0349            
  0350            * R0,R1 / R2 --> R0 = Quotient, R1 = Remainder
  0351            *
  0352 0270 04C0  DIVIDE CLR   R0               Most Significant word
  0353 0272 C27E         MOV   *R14+,R9
  0354 0274 C049         MOV   R9,R1            Least Significant word
  0355 0276 0741         ABS   R1
  0356 0278 C088         MOV   R8,R2            Divider
  0357 027A 130A         JEQ   DIVID3           Divide by zero!
  0358 027C 0742         ABS   R2
  0359 027E 3C02         DIV   R2,R0
  0360 0280 C208         MOV   R8,R8
  0361 0282 1501         JGT   DIVID1
  0362 0284 0500         NEG   R0
  0363 0286 C249  DIVID1 MOV   R9,R9
  0364 0288 1502         JGT   DIVID2
  0365 028A 0500         NEG   R0
  0366 028C 0501         NEG   R1
  0367 028E 045B  DIVID2 B     *R11
  0368            
  0369 0290 04C0  DIVID3 CLR   R0               Divide by zero
  0370 0292 04C1         CLR   R1
  0371 0294 045B         B     *R11
  0372            
  0373            * 0000 --> FFFF
  0374            * xxxx --> 0000
  0375            *
  0376 0296 C208  C$LNEG MOV   R8,R8
  0377 0298 1302         JEQ   C$LNG1
  0378 029A 6208         S     R8,R8
  0379 029C 045B         B     *R11
  0380 029E 0608  C$LNG1 DEC   R8
  0381 02A0 045B         B     *R11
  0382            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20010401                      PAGE 0013
  0384            
  0385            * Switch statement
  0386            * Called as:      B    @C$2
  0387            *            C$3  case statements
  0388            *            C$4  case statements
  0389            *            C$5  default statements
  0390            *                 B    @C$3 exit switch
  0391            *
  0392            *           C$2   BL   @C$SWCH
  0393            *                 DATA C$3,value
  0394            *                 DATA C$4,value
  0395            *                 DATA 0
  0396            *                 B    C$5 do default
  0397            *           C$1   Every break jumps here
  0398            *
  0399 02A2 C03B  C$SWCH MOV   *R11+,R0         Statament adres
  0400 02A4 1303         JEQ   C$SWC1           End of list
  0401 02A6 823B         C     *R11+,R8         This Switch TRUE?
  0402 02A8 16FC         JNE   C$SWCH           No!
  0403 02AA 0450         B     *R0              Execute case Statement
  0404 02AC 045B  C$SWC1 B     *R11             Do default statement
  0405            
  0406            * Indirect function call
  0407            * Called as: LI  R8,function address
  0408            *            MOV R8,@C$CALL
  0409            *            BL  C$IND
  0410            *
  0411 02AE 064E  C$CIND DECT  R14              Save program counter
  0412 02B0 C78B         MOV   R11,*R14
  0413 02B2 C1E0         MOV   @C$CALL,R7       Statement address
       02B4 02B8'
  0414 02B6 0457         B     *R7              Execute Statement
  0415            
  0416 02B8       C$CALL BSS   2
  0417            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20010401                      PAGE 0014
  0419            
  0420            * c=GETCHAR(), c=GETCHR(chr)
  0421            * GETCHAR displays a space at cursor location
  0422            * GETCHR  displays chr at cursor location
  0423            * Wait for a key to be pressed and returns the
  0424            * character value. The character is egoed to
  0425            * the screen. If the character is Enter the
  0426            * screen spaces to the start of a new line and
  0427            * a value of 10 is returned. If the character is
  0428            * Ctrl-z a value of -1 is returned
  0429            *
  0430 02BA C02E  GETCHR MOV   @2(R14),0
       02BC 0002 
  0431 02BE 06C0         SWPB  0
  0432 02C0 1002         JMP   GETCH
  0433 02C2 06A0  GETCHA BL    @SBRV            Read character from cursor loc
       02C4 02FA'
  0434 02C6 06A0  GETCH  BL    @S$TII           Before reading character
       02C8 03DC'
  0435 02CA C201         MOV   R1,R8            Return character
  0436 02CC 0988         SRL   R8,8
  0437 02CE 0281         CI    R1,>2000         Is it ' '..'~'
       02D0 2000 
  0438 02D2 1A06         JL    GETCH3           No, lower
  0439 02D4 0281         CI    R1,>7F00
       02D6 7F00 
  0440 02D8 1403         JHE   GETCH3           No, higher
  0441 02DA 06A0  GETCH1 BL    @WRCHR1          Echo character
       02DC 0438'
  0442 02DE 045D  GETCH2 B     *R13
  0443            
  0444 02E0 0281  GETCH3 CI    R1,>0D00         Is it Enter
       02E2 0D00 
  0445 02E4 1605         JNE   GETCH5           No
  0446 02E6 0208         LI    R8,>000A         Translate to LF
       02E8 000A 
  0447 02EA 0201  GETCH4 LI    R1,>0A00
       02EC 0A00 
  0448 02EE 10F5         JMP   GETCH1           Echo LF character
  0449 02F0 0281  GETCH5 CI    R1,>1A00         Is it Ctrl-z
       02F2 1A00 
  0450 02F4 16F4         JNE   GETCH2           No, but don't echo
  0451 02F6 0708         SETO  R8               Return -1
  0452 02F8 10F8         JMP   GETCH4           Echo LF character
  0453            
  0454            * SBRV - Single byte read video
  0455            *
  0456            * Read character at cursor location
  0457            * row,col-->R0
  0458            *
  0459 02FA 0200  SBRV   LI    R0,3             Get cursor location
       02FC 0003 
  0460 02FE 2C20         SYSC  @VIDEO
       0300 03C4'
  0461 0302 C081         MOV   R1,R2
  0462 0304 C040         MOV   R0,R1
  0463 0306 0200         LI    R0,>0B           Get character
       0308 000B 
  0464 030A 2C20         SYSC  @VIDEO

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20010401                      PAGE 0015
       030C 03C4'
  0465 030E 06C0         SWPB  R0
  0466 0310 045B         RT
  0467            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20010401                      PAGE 0016
  0469            
  0470            * c=GETS(buff)
  0471            *
  0472            * Read one line from the keyboard to a character
  0473            * array. The line is terminated with Enter, Ctrl-z
  0474            * or the 80th character. The array is assumed to be
  0475            * 81 characters long and a null (0) character is
  0476            * appended to the end of the string. A vulue of buff
  0477            * is returned unless Ctrl-z is pressed. In that case
  0478            * a null is returned. Use of the backspace key (Fctn-s)
  0479            * for inline editing is supported.
  0480            *
  0481 0312 C16E  GETS   MOV   @>0002(R14),R5   Get character array address
       0314 0002 
  0482 0316 0204  XGETS  LI    R4,>0050         Maximum 80 characters
       0318 0050 
  0483 031A C205         MOV   R5,R8            Return value
  0484 031C 0200  GETS1  LI    R0,>2000         Read a character
       031E 2000 
  0485 0320 06A0         BL    @S$TII
       0322 03DC'
  0486 0324 0281         CI    R1,>0D00         Is it Enter
       0326 0D00 
  0487 0328 1315         JEQ   GETS4            Yes
  0488 032A 0281         CI    R1,>1A00         Is it Ctrl-z
       032C 1A00 
  0489 032E 1602         JNE   GETS2            No
  0490 0330 04C8         CLR   R8               Return 0
  0491 0332 1010         JMP   GETS4
  0492 0334 0281  GETS2  CI    R1,>8800         Is it Fctn-s
       0336 8800 
  0493 0338 1608         JNE   GETS3            No
  0494 033A 0284         CI    R4,>0050         Max characters entered
       033C 0050 
  0495 033E 13EE         JEQ   GETS1            Yes
  0496 0340 0584         INC   R4               Backspace one character
  0497 0342 0605         DEC   R5
  0498 0344 06A0         BL    @WRCHR1          Echo
       0346 0438'
  0499 0348 10E9         JMP   GETS1            Read next
  0500 034A DD41  GETS3  MOVB  R1,*R5+          Move character into buffer
  0501 034C 06A0         BL    @WRCHR1          Echo character
       034E 0438'
  0502 0350 0604         DEC   R4
  0503 0352 16E4         JNE   GETS1            Read next
  0504 0354 0201  GETS4  LI    R1,>000A         Close string
       0356 000A 
  0505 0358 D541         MOVB  R1,*R5
  0506 035A 06C1         SWPB  R1               Print LF
  0507 035C 06A0         BL    @WRCHR1
       035E 0438'
  0508 0360 045D         B     *R13
  0509            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20010401                      PAGE 0017
  0511            
  0512            * c=PUTCHAR(c)
  0513            *
  0514            * Writes the character whose ascii value is c to the
  0515            * screen. If c==10 (eol) the screen spaces to the start
  0516            * of a new line. If c==8 (BS) the cursor is backspaced.
  0517            * If c==12 (FF) the screen is cleared and the cursor is
  0518            * homed. If c represents a non printing character, a \
  0519            * is echoed. The value of c is returned.
  0520            *
  0521 0362 C06E  PUTCHA MOV   @>0002(R14),R1   Get return character
       0364 0002 
  0522 0366 C201  XPUTC  MOV   R1,R8            Print it
  0523 0368 06C1         SWPB  R1
  0524 036A 06A0         BL    @WRCHR1
       036C 0438'
  0525 036E 045D         B     *R13
  0526            
  0527            * PUTS(string)
  0528            *
  0529            * Writes a string to the screen, stopping when
  0530            * it finds a null (0) character. The null
  0531            * character is not written. The cursor is not
  0532            * spaced to the start of a newline unless
  0533            * newline (\n) is encountered.
  0534            *
  0535 0370 C060  XPUTS  MOV   @S#DRCT,R1       Direct video
       0372 03C6'
  0536 0374 160E         JNE   XDPUTS
  0537 0376 1005         JMP   PUTS1
  0538            
  0539 0378 C060  PUTS   MOV   @S#DRCT,R1       Direct video
       037A 03C6'
  0540 037C 1608         JNE   DPUTS            Yes
  0541 037E C16E         MOV   @>0002(R14),R5   Get string address
       0380 0002 
  0542 0382 D075  PUTS1  MOVB  *R5+,R1          Get character
  0543 0384 1303         JEQ   PUTS2            Its a 0
  0544 0386 06A0         BL    @WRCHR1          Print character
       0388 0438'
  0545 038A 10FB         JMP   PUTS1            Get next one
  0546 038C 045D  PUTS2  B     *R13
  0547            
  0548            * DPUTS - Direct to video ram
  0549            
  0550      F102  VDPWA  EQU   >F102
  0551      F100  VDPWD  EQU   >F100
  0552            
  0553 038E C16E  DPUTS  MOV   @>0002(R14),R5   Get string address
       0390 0002 
  0554 0392 04E0  XDPUTS CLR   @S#DRCT
       0394 03C6'
  0555 0396 0201         LI    R1,>4000         Set VDP location
       0398 4000 
  0556 039A E060         SOC   @S#LOC,R1
       039C 03C8'
  0557 039E 06C1         SWPB  R1
  0558 03A0 0300         LIMI  0
       03A2 0000 

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20010401                      PAGE 0018
  0559 03A4 D801         MOVB  R1,@VDPWA
       03A6 F102 
  0560 03A8 06C1         SWPB  R1
  0561 03AA D801         MOVB  R1,@VDPWA
       03AC F102 
  0562 03AE D075  DPUTS1 MOVB  *R5+,R1          Write string
  0563 03B0 1305         JEQ   DPUTSX
  0564 03B2 D801         MOVB  R1,@VDPWD
       03B4 F100 
  0565 03B6 05A0         INC   @S#LOC
       03B8 03C8'
  0566 03BA 10F9         JMP   DPUTS1
  0567 03BC 0300  DPUTSX LIMI  1
       03BE 0001 
  0568 03C0 045D         B     *R13
  0569            
  0570 03C2 0005  KEYBRD DATA  >0005
  0571 03C4 0006  VIDEO  DATA  >0006
  0572            
  0573 03C6 0000  S#DRCT DATA  0                Direct video
  0574 03C8 0000  S#LOC  DATA  0                Cursor loc
  0575 03CA 0050  S#WDTH DATA  80               Screen width
  0576 03CC 0018  S#SHGT DATA  24               Screen height
  0577 03CE 0000  S#STRT DATA  0                Screen start
  0578 03D0 0780  S#SEND DATA  80*24            Screen end
  0579 03D2 0000  S#PAGE DATA  >0000
  0580            
  0581 03D4 FF00  NOKEY  DATA  >FF00            Nokey code
  0582 03D6 5F08  CURBS  DATA  >5F08            Cursor & Backspace
  0583 03D8 2008  CHRBS  DATA  >2008            Character & Backspace
  0584            
  0585            * S$TII
  0586            *
  0587            * This routine scans the keyboard and returns the
  0588            * entered character. It shows a blinking cursor
  0589            * on the screen on the active row, column position
  0590            *
  0591 03DA 0004  S#KBM  DATA  4                Default Pascal mode
  0592            
  0593 03DC 04C1  S$TII  CLR   R1
  0594 03DE C18B         MOV   R11,R6           Save return address
  0595 03E0 D800         MOVB  R0,@CHRBS        Save character
       03E2 03D8'
  0596 03E4 1007         JMP   S$TII3           Print cursor
  0597 03E6 0207  S$TII1 LI    R7,>0258         Delay timer
       03E8 0258 
  0598 03EA 0607  S$TII2 DEC   R7               End of delay
  0599 03EC 160D         JNE   S$TII6           No, scan keyboard
  0600 03EE 8803         C     R3,@CURBS        Yes exchange cursor and charac
       03F0 03D6'
  0601 03F2 1303         JEQ   S$TII4
  0602 03F4 C0E0  S$TII3 MOV   @CURBS,R3        Display Cursor
       03F6 03D6'
  0603 03F8 1002         JMP   S$TII5
  0604 03FA C0E0  S$TII4 MOV   @CHRBS,R3        Display Character
       03FC 03D8'
  0605 03FE 0202  S$TII5 LI    R2,>0002         Two bytes to print
       0400 0002 
  0606 0402 06A0         BL    @WRCHR3

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20010401                      PAGE 0019
       0404 042A'
  0607 0406 10EF         JMP   S$TII1           Restart delay
  0608 0408 C020  S$TII6 MOV   @S#KBM,R0        Scan keyboard
       040A 03DA'
  0609 040C 2C20         SYSC  @KEYBRD
       040E 03C2'
  0610 0410 16EC         JNE   S$TII2           No key pressed
  0611 0412 9801         CB    R1,@NOKEY        Valid character code
       0414 03D4'
  0612 0416 13E9         JEQ   S$TII2           No
  0613 0418 C241         MOV   R1,R9            Save character code
  0614 041A 0202         LI    R2,>0002         Restore character
       041C 0002 
  0615 041E C0E0         MOV   @CHRBS,R3
       0420 03D8'
  0616 0422 06A0         BL    @WRCHR3
       0424 042A'
  0617 0426 C049         MOV   R9,R1
  0618 0428 0456         B     *R6              Return
  0619            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20010401                      PAGE 0020
  0621            
  0622            * Write Character R3
  0623            *
  0624            * Writes the character(s) in R3 to the screen
  0625            * If R2=1 the MSByte of R3 is written
  0626            * If R2=2 both the MSByte and the LSByte of R3
  0627            * is writen
  0628            *
  0629 042A 0200  WRCHR3 LI    R0,>0027
       042C 0027 
  0630 042E 0201         LI    R1,HR3
       0430 F006 
  0631 0432 2C20         SYSC  @VIDEO
       0434 03C4'
  0632 0436 045B         B     *R11
  0633            
  0634            
  0635            * Write Character R1
  0636            *
  0637            * Writes the MSByte of R1 on the screen. If it
  0638            * is a unprintable character a \ is printed.
  0639            *
  0640 0438 C1CB  WRCHR1 MOV   R11,R7           Save return address
  0641 043A 0241         ANDI  R1,>7F00         Strip MSBit
       043C 7F00 
  0642 043E C0C1         MOV   R1,R3
  0643 0440 0281         CI    R1,>0800         Is it a BS
       0442 0800 
  0644 0444 1315         JEQ   WRCH12           Yes
  0645 0446 0281         CI    R1,>0D00         Is it a CR
       0448 0D00 
  0646 044A 1312         JEQ   WRCH12           Yes
  0647 044C 0281         CI    R1,>0C00         Is it a FF
       044E 0C00 
  0648 0450 130F         JEQ   WRCH12           Yes
  0649 0452 0281         CI    R1,>0A00         Is it a LF
       0454 0A00 
  0650 0456 1607         JNE   WRCH11           No
  0651 0458 0202         LI    R2,>0002         Two bytes to write
       045A 0002 
  0652 045C 0203         LI    R3,>0D0A         CRLF
       045E 0D0A 
  0653 0460 06A0         BL    @WRCHR3          Write characters
       0462 042A'
  0654 0464 0457         B     *R7              Return
  0655            
  0656 0466 0281  WRCH11 CI    R1,>1F00         Is it ' '..'~'
       0468 1F00 
  0657 046A 1B02         JH    WRCH12           Yes
  0658 046C 0203         LI    R3,>5C20         No, print '\'
       046E 5C20 
  0659 0470 0202  WRCH12 LI    R2,>0001         One byte to write
       0472 0001 
  0660 0474 06A0         BL    @WRCHR3          Write character
       0476 042A'
  0661 0478 0457         B     *R7              return
  0662            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20010401                      PAGE 0021
  0664            
  0665            * LOCATE(row,col)
  0666            *
  0667            * Places the cursor at the screen location specified
  0668            * by row and col. Subsequent console I/O will start
  0669            * at the new cursor location. Row and Column numbering
  0670            * starts witch 1 and the validity is not checked.
  0671            *
  0672 047A C02E  LOCATE MOV   @>0002(R14),R0
       047C 0002 
  0673 047E C06E         MOV   @>0004(R14),R1
       0480 0004 
  0674 0482 C080  XLOCAT MOV   R0,R2
  0675 0484 0601         DEC   R1
  0676 0486 0602         DEC   R2
  0677 0488 0200         LI    R0,>0002
       048A 0002 
  0678 048C 2C20         SYSC  @VIDEO
       048E 03C4'
  0679 0490 C0C2         MOV   R2,R3       Calc cursor loc
  0680 0492 3860         MPY   @S#WDTH,R1  for direct video
       0494 03CA'
  0681 0496 A0C2         A     R2,R3
  0682 0498 C803         MOV   R3,@S#LOC
       049A 03C8'
  0683 049C 045D         B     *R13
  0684            
  0685            * Key=POLL(c)
  0686            *
  0687            * Scans the keyboard and returns the key value
  0688            * if one is pressed or 0. If c!=0, the program
  0689            * will pause while a key is down. If c!=0 and
  0690            * Fctn-4 is pressed (CLEAR) the program will
  0691            * branch to the c99 exit function.
  0692            *
  0693 049E C0EE  POLL   MOV   @>0002(R14),R3
       04A0 0002 
  0694 04A2 04C0  XPOLL  CLR   R0               Use last keyboard mode
  0695 04A4 2C20         SYSC  @KEYBRD
       04A6 03C2'
  0696 04A8 0981         SRL   R1,8
  0697 04AA C201         MOV   R1,R8
  0698 04AC 0288         CI    R8,>00FF         Key Hit?
       04AE 00FF 
  0699 04B0 1602         JNE   POLL3            Yes
  0700 04B2 04C8         CLR   R8               No
  0701 04B4 045D  POLL2  B     *R13             Return
  0702 04B6 0743  POLL3  ABS   R3
  0703 04B8 13FD         JEQ   POLL2
  0704 04BA 0288         CI    R8,>0002         Fctn4
       04BC 0002 
  0705 04BE 16F1         JNE   XPOLL            No
  0706 04C0 0460         B     @CEXIT
       04C2 0118'
  0707            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20010401                      PAGE 0022
  0709            
  0710            * TSCRN(f,b)
  0711            *
  0712            * Chacges the text mode screen color to f (foreground)
  0713            * and b (background). The Basic color number convention
  0714            * is used.
  0715            *
  0716 04C4 C02E  TSCRN  MOV   @>0002(R14),R0   Background color
       04C6 0002 
  0717 04C8 C06E         MOV   @>0004(R14),R1   Foreground color
       04CA 0004 
  0718 04CC 0600  XTSCRN DEC   R0
  0719 04CE 0240         ANDI  R0,>000F
       04D0 000F 
  0720 04D2 0601         DEC   R1
  0721 04D4 0241         ANDI  R1,>000F
       04D6 000F 
  0722 04D8 0A41         SLA   R1,4
  0723 04DA E001         SOC   R1,R0
  0724 04DC 0220         AI    R0,>8700
       04DE 8700 
  0725 04E0 06C0         SWPB  R0
  0726 04E2 D800         MOVB  R0,@>F102
       04E4 F102 
  0727 04E6 06C0         SWPB  R0
  0728 04E8 D800         MOVB  R0,@>F102
       04EA F102 
  0729 04EC 045D         B     *R13
  0730            

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20010401                      PAGE 0023
  0732            
  0733            * EXIT(c) or ABORT(c)
  0734            *
  0735            * Branches to the c99 exit function which closes
  0736            * any open files. The value of c may be between
  0737            * 0 and 7. If c==0 the normal exit message is
  0738            * displayed. If c==7 the program terminates
  0739            * immediately. Otherwise the value of c is displayed
  0740            * in an error message. The exit(0) function is also
  0741            * executed when function main() terminates normally
  0742            *
  0743            EXIT
  0744 04EE 04E0  ABORT  CLR   @C$HOOK+2
       04F0 0554'
  0745 04F2 C02E         MOV   @>0002(R14),R0   Exit status
       04F4 0002 
  0746 04F6 1602         JNE   ABORT1
  0747 04F8 0460         B     @CEXIT
       04FA 0118'
  0748            
  0749 04FC 0240  ABORT1 ANDI  R0,>0007         Only exit codes 1..7
       04FE 0007 
  0750 0500 0280         CI    R0,>0007         Terminate immediately?
       0502 0007 
  0751 0504 1604         JNE   ABORT2           No!
  0752 0506 0720         SETO  @C$HOOK+2        Set flag
       0508 0554'
  0753 050A 0460         B     @CEXIT1
       050C 0126'
  0754            *      B     @CEXIT2
  0755 050E 0220  ABORT2 AI    R0,>0030         +ASC("0")
       0510 0030 
  0756 0512 06C0         SWPB  R0
  0757 0514 D800         MOVB  R0,@C99T3X       Move into error message
       0516 0541'
  0758 0518 0208         LI    R8,C99T3         c99 err=X
       051A 0538'
  0759 051C 068F         BL    R15
  0760 051E 069C         BL    *R12
  0761 0520 0378'        DATA  PUTS
  0762 0522 0460         B     @CEXIT1
       0524 0126'
  0763            
  0764 0526 0208  CEXIT0 LI    R8,C99T4         c99 ^C exit
       0528 0543'
  0765 052A 068F         BL    R15
  0766 052C 069C         BL    *R12
  0767 052E 0378'        DATA  PUTS
  0768 0530 0720         SETO  @C$HOOK+2        Set flag
       0532 0554'
  0769 0534 0460         B     @CEXIT1
       0536 0126'
  0770            
  0771 0538   0A  C99T3  BYTE 10
  0772 0539   63         TEXT 'c99 err='
  0773 0541   58  C99T3X TEXT 'X'
  0774 0542   00         BYTE 0
  0775 0543   0A  C99T4  BYTE 10
  0776 0544   63         TEXT 'c99 ^C exit'

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20010401                      PAGE 0024
  0777 054F   0A         BYTE 10
  0778 0550 0000         DATA  >0000
  0779 0552 0000  C$HOOK DATA  >0000
  0780 0554 0000         DATA  >0000
  0781            
  0782                   END

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20010401                      PAGE 0025
  D ABORT   04EE    ' ABORT1  04FC    ' ABORT2  050E    ' ARGC    01E4  
  ' ARGPNT  007E    ' ARGPT1  008C    ' ARGPT2  0092    ' ARGPT3  009E  
  ' ARGPT4  00B2    ' ARGV0   01E6    ' ARGV1   01E8    D C$ASL   0254  
  D C$ASR   024C    D C$CALL  02B8    D C$CIND  02AE    D C$DIV   025C  
  D C$EQ    0208    ' C$FALS  0230    D C$GE    0226    D C$GT    0220  
  D C$HOOK  0552    D C$LE    021A    D C$LNEG  0296    ' C$LNG1  029E  
  D C$LT    0214    D C$NE    020E    D C$REM   0266    ' C$SWC1  02AC  
  D C$SWCH  02A2    ' C$TRUE  022A    D C$UGE   0246    D C$UGT   0240  
  D C$ULE   023A    D C$ULT   0234    ' C99CT1  0176    ' C99CT2  0180  
  ' C99T3   0538    ' C99T3X  0541    ' C99T4   0543      C99WS   F000  
  ' CALL    0168      CALLZ   0008    ' CEXIT   0118    ' CEXIT0  0526  
  ' CEXIT1  0126    ' CEXIT2  011C    ' CEXT11  012E    ' CEXT12  013E  
  ' CEXT13  0156    ' CHRBS   03D8    ' CMDBU0  0192    ' CMDBUF  0194  
  ' CURBS   03D6    ' DIVID1  0286    ' DIVID2  028E    ' DIVID3  0290  
  ' DIVIDE  0270    D DPUTS   038E    ' DPUTS1  03AE    ' DPUTSX  03BC  
  D EXIT    04EE    ' GETCH   02C6    ' GETCH1  02DA    ' GETCH2  02DE  
  ' GETCH3  02E0    ' GETCH4  02EA    ' GETCH5  02F0    D GETCHA  02C2  
  D GETCHR  02BA    ' GETCM1  0066    ' GETCM2  0068    ' GETCM3  0070  
  D GETS    0312    ' GETS1   031C    ' GETS2   0334    ' GETS3   034A  
  ' GETS4   0354      HR0     F000      HR1     F002      HR10    F014  
    HR11    F016      HR12    F018      HR13    F01A      HR14    F01C  
    HR15    F01E      HR2     F004      HR3     F006      HR4     F008  
    HR5     F00A      HR6     F00C      HR7     F00E      HR8     F010  
    HR9     F012    D KEYBRD  03C2    D LOCATE  047A      LR0     F001  
    LR1     F003      LR10    F015      LR11    F017      LR12    F019  
    LR13    F01B      LR14    F01D      LR15    F01F      LR2     F005  
    LR3     F007      LR4     F009      LR5     F00B      LR6     F00D  
    LR7     F00F      LR8     F011      LR9     F013    E MAIN    0116  
  ' MEMORY  0174      NARGC   0010    ' NOKEY   03D4    ' NULL    0190  
  D POLL    049E    ' POLL2   04B4    ' POLL3   04B6    ' PUSH    0162  
    PUSHZ   0006    D PUTCHA  0362    D PUTS    0378    ' PUTS1   0382  
  ' PUTS2   038C      R0      0000      R1      0001      R10     000A  
    R11     000B      R12     000C      R13     000D      R14     000E  
    R15     000F      R2      0002      R3      0003      R4      0004  
    R5      0005      R6      0006      R7      0007      R8      0008  
    R9      0009      RETRNZ  0004    ' RETURN  0170    D S#DRCT  03C6  
  D S#KBM   03DA    D S#LOC   03C8    D S#PAGE  03D2    ' S#SEND  03D0  
  ' S#SHGT  03CC    ' S#STRT  03CE    D S#WDTH  03CA    D S$TII   03DC  
  ' S$TII1  03E6    ' S$TII2  03EA    ' S$TII3  03F4    ' S$TII4  03FA  
  ' S$TII5  03FE    ' S$TII6  0408    ' SBRV    02FA    ' SPACE   018F  
  D START   0000    ' START1  0038    ' START2  00B8    ' START3  00F0  
  ' START4  00FE    X SYSC    0000    ' TILDE   0191    D TSCRN   04C4  
    VDPWA   F102      VDPWD   F100    ' VIDEO   03C4    ' WRCH11  0466  
  ' WRCH12  0470    ' WRCHR1  0438    ' WRCHR3  042A    D XDPUTS  0392  
  D XGETS   0316    D XLOCAT  0482    D XPOLL   04A2    D XPUTC   0366  
  D XPUTS   0370    D XTSCRN  04CC  
  0000 ERRORS

 Xa99 Cross Assembler
C99 CSUP V5G - Runtime Library 20010401                      PAGE 0026
  SEGMENT RORG     SIZE 01366 (>0556) BYTES
