#
# Makefile to build PiCalc
#
# By: Frederik G. Kaal
#
# Target is dependend from the files listed in PICALC.L99
#
# Call: Make -f[path]picalc.mak
#
.AUTODEPEND

#
# Directory settings
#
TI99_binpath = .\..\..\utl

#
# Tools
#
TI99LINK = $(TI99_binpath)\L99.BAT
TI99CC   = $(TI99_binpath)\C99c.BAT

#
# Dependency List
#
Dep_picalc = \
   .\obj\picalc0.x \
   .\obj\picalc1.x \
   .\obj\picalc2.x

PICALC : $(Dep_picalc)
	$(TI99LINK) Picalc.l99
	copy Picalc d:\ti994w\dsk1
	copy Picald d:\ti994w\dsk1
	copy Picale d:\ti994w\dsk1
	copy Picalf d:\ti994w\dsk1
.\obj\picalc0.x :  picalc0.a99
	$(TI99CC) picalc0.a99
.\obj\picalc1.x :  picalc1.c99
	$(TI99CC) picalc1.c99
.\obj\picalc2.x :  picalc2.c99
	$(TI99CC) picalc2.c99
